package muicm.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import muicm.DataBindingGroup;
import muicm.MInteractionFlow;
import muicm.diagram.edit.policies.MuicmBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class MInteractionFlowDataBindingGroupReorientCommand extends EditElementCommand {

	/**
	* @generated
	*/
	private final int reorientDirection;

	/**
	* @generated
	*/
	private final EObject referenceOwner;

	/**
	* @generated
	*/
	private final EObject oldEnd;

	/**
	* @generated
	*/
	private final EObject newEnd;

	/**
	* @generated
	*/
	public MInteractionFlowDataBindingGroupReorientCommand(ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	* @generated
	*/
	public boolean canExecute() {
		if (false == referenceOwner instanceof MInteractionFlow) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	* @generated
	*/
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof DataBindingGroup && newEnd instanceof MInteractionFlow)) {
			return false;
		}
		return MuicmBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistMInteractionFlowDataBindingGroup_4001(getNewSource(), getOldTarget());
	}

	/**
	* @generated
	*/
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof DataBindingGroup && newEnd instanceof DataBindingGroup)) {
			return false;
		}
		return MuicmBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistMInteractionFlowDataBindingGroup_4001(getOldSource(), getNewTarget());
	}

	/**
	* @generated
	*/
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException("Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	* @generated
	*/
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().setDataBindingGroup(null);
		getNewSource().setDataBindingGroup(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	* @generated
	*/
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().setDataBindingGroup(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	* @generated
	*/
	protected MInteractionFlow getOldSource() {
		return (MInteractionFlow) referenceOwner;
	}

	/**
	* @generated
	*/
	protected MInteractionFlow getNewSource() {
		return (MInteractionFlow) newEnd;
	}

	/**
	* @generated
	*/
	protected DataBindingGroup getOldTarget() {
		return (DataBindingGroup) oldEnd;
	}

	/**
	* @generated
	*/
	protected DataBindingGroup getNewTarget() {
		return (DataBindingGroup) newEnd;
	}
}
