package muicm.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import muicm.MInteractionElement;
import muicm.NavigationFlow;
import muicm.diagram.edit.policies.MuicmBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class NavigationFlowReorientCommand extends EditElementCommand {

	/**
	* @generated
	*/
	private final int reorientDirection;

	/**
	* @generated
	*/
	private final EObject oldEnd;

	/**
	* @generated
	*/
	private final EObject newEnd;

	/**
	* @generated
	*/
	public NavigationFlowReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	* @generated
	*/
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof NavigationFlow) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	* @generated
	*/
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof MInteractionElement && newEnd instanceof MInteractionElement)) {
			return false;
		}
		MInteractionElement target = getLink().getTargetInteractionElement();
		if (!(getLink().eContainer() instanceof muicm.MUICM)) {
			return false;
		}
		muicm.MUICM container = (muicm.MUICM) getLink().eContainer();
		return MuicmBaseItemSemanticEditPolicy.getLinkConstraints().canExistNavigationFlow_4002(container, getLink(),
				getNewSource(), target);
	}

	/**
	* @generated
	*/
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof MInteractionElement && newEnd instanceof MInteractionElement)) {
			return false;
		}
		MInteractionElement source = getLink().getSourceInteractionElement();
		if (!(getLink().eContainer() instanceof muicm.MUICM)) {
			return false;
		}
		muicm.MUICM container = (muicm.MUICM) getLink().eContainer();
		return MuicmBaseItemSemanticEditPolicy.getLinkConstraints().canExistNavigationFlow_4002(container, getLink(),
				source, getNewTarget());
	}

	/**
	* @generated
	*/
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException("Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	* @generated
	*/
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setSourceInteractionElement(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	* @generated
	*/
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setTargetInteractionElement(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	* @generated
	*/
	protected NavigationFlow getLink() {
		return (NavigationFlow) getElementToEdit();
	}

	/**
	* @generated
	*/
	protected MInteractionElement getOldSource() {
		return (MInteractionElement) oldEnd;
	}

	/**
	* @generated
	*/
	protected MInteractionElement getNewSource() {
		return (MInteractionElement) newEnd;
	}

	/**
	* @generated
	*/
	protected MInteractionElement getOldTarget() {
		return (MInteractionElement) oldEnd;
	}

	/**
	* @generated
	*/
	protected MInteractionElement getNewTarget() {
		return (MInteractionElement) newEnd;
	}
}
