package muicm.diagram.edit.parts;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.AbstractBorderedShapeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IBorderItemEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.BorderItemSelectionEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DragDropEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.figures.BorderItemLocator;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.edit.policies.reparent.CreationEditPolicyWithCustomReparent;
import org.eclipse.swt.graphics.Color;

import muicm.diagram.edit.policies.MViewComponent2CanonicalEditPolicy;
import muicm.diagram.edit.policies.MViewComponent2ItemSemanticEditPolicy;
import muicm.diagram.part.MuicmVisualIDRegistry;

/**
 * @generated
 */
public class MViewComponent2EditPart extends AbstractBorderedShapeEditPart {

	/**
	* @generated
	*/
	public static final int VISUAL_ID = 3002;

	/**
	* @generated
	*/
	protected IFigure contentPane;

	/**
	* @generated
	*/
	protected IFigure primaryShape;

	/**
	* @generated
	*/
	public MViewComponent2EditPart(View view) {
		super(view);
	}

	/**
	* @generated
	*/
	protected void createDefaultEditPolicies() {
		installEditPolicy(EditPolicyRoles.CREATION_ROLE,
				new CreationEditPolicyWithCustomReparent(MuicmVisualIDRegistry.TYPED_INSTANCE));
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new MViewComponent2ItemSemanticEditPolicy());
		installEditPolicy(EditPolicyRoles.DRAG_DROP_ROLE, new DragDropEditPolicy());
		installEditPolicy(EditPolicyRoles.CANONICAL_ROLE, new MViewComponent2CanonicalEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	* @generated
	*/
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				View childView = (View) child.getModel();
				switch (MuicmVisualIDRegistry.getVisualID(childView)) {
				case SwipeEventEditPart.VISUAL_ID:
				case TapEventEditPart.VISUAL_ID:
				case TouchEventEditPart.VISUAL_ID:
				case PanEventEditPart.VISUAL_ID:
				case PinchEventEditPart.VISUAL_ID:
				case RotateEventEditPart.VISUAL_ID:
				case MViewElementEventEditPart.VISUAL_ID:
					return new BorderItemSelectionEditPolicy();
				}
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	* @generated
	*/
	protected IFigure createNodeShape() {
		return primaryShape = new MViewComponentFigure();
	}

	/**
	* @generated
	*/
	public MViewComponentFigure getPrimaryShape() {
		return (MViewComponentFigure) primaryShape;
	}

	/**
	* @generated
	*/
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof MViewComponentName2EditPart) {
			((MViewComponentName2EditPart) childEditPart)
					.setLabel(getPrimaryShape().getFigureMViewComponentNameFigure());
			return true;
		}
		if (childEditPart instanceof MViewComponentMViewComponentCompartmentEditPart) {
			IFigure pane = getPrimaryShape().getFigureMViewComponentCompartmentFigure();
			setupContentPane(pane); // FIXME each comparment should handle his content pane in his own way 
			pane.add(((MViewComponentMViewComponentCompartmentEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof SwipeEventEditPart) {
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.NONE);
			getBorderedFigure().getBorderItemContainer().add(((SwipeEventEditPart) childEditPart).getFigure(), locator);
			return true;
		}
		if (childEditPart instanceof TapEventEditPart) {
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.NONE);
			getBorderedFigure().getBorderItemContainer().add(((TapEventEditPart) childEditPart).getFigure(), locator);
			return true;
		}
		if (childEditPart instanceof TouchEventEditPart) {
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.NONE);
			getBorderedFigure().getBorderItemContainer().add(((TouchEventEditPart) childEditPart).getFigure(), locator);
			return true;
		}
		if (childEditPart instanceof PanEventEditPart) {
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.NONE);
			getBorderedFigure().getBorderItemContainer().add(((PanEventEditPart) childEditPart).getFigure(), locator);
			return true;
		}
		if (childEditPart instanceof PinchEventEditPart) {
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.NONE);
			getBorderedFigure().getBorderItemContainer().add(((PinchEventEditPart) childEditPart).getFigure(), locator);
			return true;
		}
		if (childEditPart instanceof RotateEventEditPart) {
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.NONE);
			getBorderedFigure().getBorderItemContainer().add(((RotateEventEditPart) childEditPart).getFigure(),
					locator);
			return true;
		}
		if (childEditPart instanceof MViewElementEventEditPart) {
			BorderItemLocator locator = new BorderItemLocator(getMainFigure(), PositionConstants.NONE);
			getBorderedFigure().getBorderItemContainer().add(((MViewElementEventEditPart) childEditPart).getFigure(),
					locator);
			return true;
		}
		return false;
	}

	/**
	* @generated
	*/
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof MViewComponentName2EditPart) {
			return true;
		}
		if (childEditPart instanceof MViewComponentMViewComponentCompartmentEditPart) {
			IFigure pane = getPrimaryShape().getFigureMViewComponentCompartmentFigure();
			pane.remove(((MViewComponentMViewComponentCompartmentEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof SwipeEventEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(((SwipeEventEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof TapEventEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(((TapEventEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof TouchEventEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(((TouchEventEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof PanEventEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(((PanEventEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof PinchEventEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(((PinchEventEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof RotateEventEditPart) {
			getBorderedFigure().getBorderItemContainer().remove(((RotateEventEditPart) childEditPart).getFigure());
			return true;
		}
		if (childEditPart instanceof MViewElementEventEditPart) {
			getBorderedFigure().getBorderItemContainer()
					.remove(((MViewElementEventEditPart) childEditPart).getFigure());
			return true;
		}
		return false;
	}

	/**
	* @generated
	*/
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	* @generated
	*/
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	* @generated
	*/
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		if (editPart instanceof MViewComponentMViewComponentCompartmentEditPart) {
			return getPrimaryShape().getFigureMViewComponentCompartmentFigure();
		}
		if (editPart instanceof IBorderItemEditPart) {
			return getBorderedFigure().getBorderItemContainer();
		}
		return getContentPane();
	}

	/**
	* @generated
	*/
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(80, 80);
		return result;
	}

	/**
	* Creates figure for this edit part.
	* 
	* Body of this method does not depend on settings in generation model
	* so you may safely remove <i>generated</i> tag and modify it.
	* 
	* @generated
	*/
	protected NodeFigure createMainFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	* Default implementation treats passed figure as content pane.
	* Respects layout one may have set for generated figure.
	* @param nodeShape instance of generated figure class
	* @generated
	*/
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	* @generated
	*/
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	* @generated
	*/
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	* @generated
	*/
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	* @generated
	*/
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	* @generated
	*/
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	* @generated
	*/
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(MuicmVisualIDRegistry.getType(MViewComponentName2EditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public class MViewComponentFigure extends RoundedRectangle {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureMViewComponentNameFigure;
		/**
		 * @generated
		 */
		private RectangleFigure fFigureMViewComponentCompartmentFigure;

		/**
		 * @generated
		 */
		public MViewComponentFigure() {

			BorderLayout layoutThis = new BorderLayout();
			this.setLayoutManager(layoutThis);

			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8), getMapMode().DPtoLP(8)));
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureMViewComponentNameFigure = new WrappingLabel();

			fFigureMViewComponentNameFigure.setText("MViewComponent");

			this.add(fFigureMViewComponentNameFigure, BorderLayout.TOP);

			fFigureMViewComponentCompartmentFigure = new RectangleFigure();

			this.add(fFigureMViewComponentCompartmentFigure, BorderLayout.CENTER);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureMViewComponentNameFigure() {
			return fFigureMViewComponentNameFigure;
		}

		/**
		 * @generated
		 */
		public RectangleFigure getFigureMViewComponentCompartmentFigure() {
			return fFigureMViewComponentCompartmentFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 230, 230, 255);

}
