package muicm.diagram.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

import muicm.diagram.part.MuicmVisualIDRegistry;

/**
 * @generated
 */
public class MuicmEditPartFactory implements EditPartFactory {

	/**
	* @generated
	*/
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (MuicmVisualIDRegistry.getVisualID(view)) {

			case MUICMEditPart.VISUAL_ID:
				return new MUICMEditPart(view);

			case ScreenEditPart.VISUAL_ID:
				return new ScreenEditPart(view);

			case ScreenNameEditPart.VISUAL_ID:
				return new ScreenNameEditPart(view);

			case MViewComponentEditPart.VISUAL_ID:
				return new MViewComponentEditPart(view);

			case MViewComponentNameEditPart.VISUAL_ID:
				return new MViewComponentNameEditPart(view);

			case OtherActionEditPart.VISUAL_ID:
				return new OtherActionEditPart(view);

			case OtherActionNameEditPart.VISUAL_ID:
				return new OtherActionNameEditPart(view);

			case CameraActionEditPart.VISUAL_ID:
				return new CameraActionEditPart(view);

			case CameraActionNameEditPart.VISUAL_ID:
				return new CameraActionNameEditPart(view);

			case MicrophoneActionEditPart.VISUAL_ID:
				return new MicrophoneActionEditPart(view);

			case MicrophoneActionNameEditPart.VISUAL_ID:
				return new MicrophoneActionNameEditPart(view);

			case DataBindingGroupEditPart.VISUAL_ID:
				return new DataBindingGroupEditPart(view);

			case DataBindingGroupNameEditPart.VISUAL_ID:
				return new DataBindingGroupNameEditPart(view);

			case Screen2EditPart.VISUAL_ID:
				return new Screen2EditPart(view);

			case ScreenName2EditPart.VISUAL_ID:
				return new ScreenName2EditPart(view);

			case MViewComponent2EditPart.VISUAL_ID:
				return new MViewComponent2EditPart(view);

			case MViewComponentName2EditPart.VISUAL_ID:
				return new MViewComponentName2EditPart(view);

			case LabelEditPart.VISUAL_ID:
				return new LabelEditPart(view);

			case LabelNameEditPart.VISUAL_ID:
				return new LabelNameEditPart(view);

			case TextBoxEditPart.VISUAL_ID:
				return new TextBoxEditPart(view);

			case TextBoxNameEditPart.VISUAL_ID:
				return new TextBoxNameEditPart(view);

			case MapEditPart.VISUAL_ID:
				return new MapEditPart(view);

			case MapNameEditPart.VISUAL_ID:
				return new MapNameEditPart(view);

			case CalendarEditPart.VISUAL_ID:
				return new CalendarEditPart(view);

			case CalendarNameEditPart.VISUAL_ID:
				return new CalendarNameEditPart(view);

			case CodeEditPart.VISUAL_ID:
				return new CodeEditPart(view);

			case CodeNameEditPart.VISUAL_ID:
				return new CodeNameEditPart(view);

			case SimpleFieldEditPart.VISUAL_ID:
				return new SimpleFieldEditPart(view);

			case SimpleFieldNameEditPart.VISUAL_ID:
				return new SimpleFieldNameEditPart(view);

			case SelectionFieldEditPart.VISUAL_ID:
				return new SelectionFieldEditPart(view);

			case SelectionFieldNameEditPart.VISUAL_ID:
				return new SelectionFieldNameEditPart(view);

			case SwipeEventEditPart.VISUAL_ID:
				return new SwipeEventEditPart(view);

			case SwipeEventNameEditPart.VISUAL_ID:
				return new SwipeEventNameEditPart(view);

			case TapEventEditPart.VISUAL_ID:
				return new TapEventEditPart(view);

			case TapEventNameEditPart.VISUAL_ID:
				return new TapEventNameEditPart(view);

			case TouchEventEditPart.VISUAL_ID:
				return new TouchEventEditPart(view);

			case TouchEventNameEditPart.VISUAL_ID:
				return new TouchEventNameEditPart(view);

			case PanEventEditPart.VISUAL_ID:
				return new PanEventEditPart(view);

			case PanEventNameEditPart.VISUAL_ID:
				return new PanEventNameEditPart(view);

			case PinchEventEditPart.VISUAL_ID:
				return new PinchEventEditPart(view);

			case PinchEventNameEditPart.VISUAL_ID:
				return new PinchEventNameEditPart(view);

			case RotateEventEditPart.VISUAL_ID:
				return new RotateEventEditPart(view);

			case RotateEventNameEditPart.VISUAL_ID:
				return new RotateEventNameEditPart(view);

			case MViewElementEventEditPart.VISUAL_ID:
				return new MViewElementEventEditPart(view);

			case MViewElementEventNameEditPart.VISUAL_ID:
				return new MViewElementEventNameEditPart(view);

			case MViewComponentPartEditPart.VISUAL_ID:
				return new MViewComponentPartEditPart(view);

			case MViewComponentPartNameEditPart.VISUAL_ID:
				return new MViewComponentPartNameEditPart(view);

			case StaticContentEditPart.VISUAL_ID:
				return new StaticContentEditPart(view);

			case StaticContentNameEditPart.VISUAL_ID:
				return new StaticContentNameEditPart(view);

			case DynamicBehaviourEditPart.VISUAL_ID:
				return new DynamicBehaviourEditPart(view);

			case DynamicBehaviourNameEditPart.VISUAL_ID:
				return new DynamicBehaviourNameEditPart(view);

			case MediaEditPart.VISUAL_ID:
				return new MediaEditPart(view);

			case MediaNameEditPart.VISUAL_ID:
				return new MediaNameEditPart(view);

			case FormEditPart.VISUAL_ID:
				return new FormEditPart(view);

			case FormNameEditPart.VISUAL_ID:
				return new FormNameEditPart(view);

			case DataEditPart.VISUAL_ID:
				return new DataEditPart(view);

			case DataNameEditPart.VISUAL_ID:
				return new DataNameEditPart(view);

			case SimpleField2EditPart.VISUAL_ID:
				return new SimpleField2EditPart(view);

			case SimpleFieldName2EditPart.VISUAL_ID:
				return new SimpleFieldName2EditPart(view);

			case SelectionField2EditPart.VISUAL_ID:
				return new SelectionField2EditPart(view);

			case SelectionFieldName2EditPart.VISUAL_ID:
				return new SelectionFieldName2EditPart(view);

			case Label2EditPart.VISUAL_ID:
				return new Label2EditPart(view);

			case LabelName2EditPart.VISUAL_ID:
				return new LabelName2EditPart(view);

			case ListEditPart.VISUAL_ID:
				return new ListEditPart(view);

			case ListNameEditPart.VISUAL_ID:
				return new ListNameEditPart(view);

			case DetailsEditPart.VISUAL_ID:
				return new DetailsEditPart(view);

			case DetailsNameEditPart.VISUAL_ID:
				return new DetailsNameEditPart(view);

			case TextBox2EditPart.VISUAL_ID:
				return new TextBox2EditPart(view);

			case TextBoxName2EditPart.VISUAL_ID:
				return new TextBoxName2EditPart(view);

			case StaticContent2EditPart.VISUAL_ID:
				return new StaticContent2EditPart(view);

			case StaticContentName2EditPart.VISUAL_ID:
				return new StaticContentName2EditPart(view);

			case MessageEditPart.VISUAL_ID:
				return new MessageEditPart(view);

			case MessageNameEditPart.VISUAL_ID:
				return new MessageNameEditPart(view);

			case UtilityViewEditPart.VISUAL_ID:
				return new UtilityViewEditPart(view);

			case UtilityViewNameEditPart.VISUAL_ID:
				return new UtilityViewNameEditPart(view);

			case Map2EditPart.VISUAL_ID:
				return new Map2EditPart(view);

			case MapName2EditPart.VISUAL_ID:
				return new MapName2EditPart(view);

			case Code2EditPart.VISUAL_ID:
				return new Code2EditPart(view);

			case CodeName2EditPart.VISUAL_ID:
				return new CodeName2EditPart(view);

			case Calendar2EditPart.VISUAL_ID:
				return new Calendar2EditPart(view);

			case CalendarName2EditPart.VISUAL_ID:
				return new CalendarName2EditPart(view);

			case SearchViewEditPart.VISUAL_ID:
				return new SearchViewEditPart(view);

			case SearchViewNameEditPart.VISUAL_ID:
				return new SearchViewNameEditPart(view);

			case ToolBarEditPart.VISUAL_ID:
				return new ToolBarEditPart(view);

			case ToolBarNameEditPart.VISUAL_ID:
				return new ToolBarNameEditPart(view);

			case IconEditPart.VISUAL_ID:
				return new IconEditPart(view);

			case IconNameEditPart.VISUAL_ID:
				return new IconNameEditPart(view);

			case LongPressEventEditPart.VISUAL_ID:
				return new LongPressEventEditPart(view);

			case LongPressEventNameEditPart.VISUAL_ID:
				return new LongPressEventNameEditPart(view);

			case OtherActionEventEditPart.VISUAL_ID:
				return new OtherActionEventEditPart(view);

			case OtherActionEventNameEditPart.VISUAL_ID:
				return new OtherActionEventNameEditPart(view);

			case CameraActionEventEditPart.VISUAL_ID:
				return new CameraActionEventEditPart(view);

			case CameraActionEventNameEditPart.VISUAL_ID:
				return new CameraActionEventNameEditPart(view);

			case MicrophoneActionEventEditPart.VISUAL_ID:
				return new MicrophoneActionEventEditPart(view);

			case MicrophoneActionEventNameEditPart.VISUAL_ID:
				return new MicrophoneActionEventNameEditPart(view);

			case DataBindingEditPart.VISUAL_ID:
				return new DataBindingEditPart(view);

			case DataBindingSourceDataEditPart.VISUAL_ID:
				return new DataBindingSourceDataEditPart(view);

			case DataBindingTargetDataEditPart.VISUAL_ID:
				return new DataBindingTargetDataEditPart(view);

			case ScreenScreenCompartmentEditPart.VISUAL_ID:
				return new ScreenScreenCompartmentEditPart(view);

			case ScreenScreenCompartment2EditPart.VISUAL_ID:
				return new ScreenScreenCompartment2EditPart(view);

			case MViewComponentMViewComponentCompartmentEditPart.VISUAL_ID:
				return new MViewComponentMViewComponentCompartmentEditPart(view);

			case FormFormCompartmentEditPart.VISUAL_ID:
				return new FormFormCompartmentEditPart(view);

			case ListListCompartmentEditPart.VISUAL_ID:
				return new ListListCompartmentEditPart(view);

			case DetailsDetailsCompartmentEditPart.VISUAL_ID:
				return new DetailsDetailsCompartmentEditPart(view);

			case UtilityViewUtilityViewCompartmentEditPart.VISUAL_ID:
				return new UtilityViewUtilityViewCompartmentEditPart(view);

			case SearchViewSearchViewCompartmentEditPart.VISUAL_ID:
				return new SearchViewSearchViewCompartmentEditPart(view);

			case ToolBarToolBarCompartmentEditPart.VISUAL_ID:
				return new ToolBarToolBarCompartmentEditPart(view);

			case MViewComponentMViewComponentCompartment2EditPart.VISUAL_ID:
				return new MViewComponentMViewComponentCompartment2EditPart(view);

			case DataBindingGroupDataBindingGroupCompartmentEditPart.VISUAL_ID:
				return new DataBindingGroupDataBindingGroupCompartmentEditPart(view);

			case MInteractionFlowDataBindingGroupEditPart.VISUAL_ID:
				return new MInteractionFlowDataBindingGroupEditPart(view);

			case NavigationFlowEditPart.VISUAL_ID:
				return new NavigationFlowEditPart(view);

			case NavigationFlowNameEditPart.VISUAL_ID:
				return new NavigationFlowNameEditPart(view);

			case DataFlowEditPart.VISUAL_ID:
				return new DataFlowEditPart(view);

			case DataFlowNameEditPart.VISUAL_ID:
				return new DataFlowNameEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	* @generated
	*/
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	* @generated
	*/
	public static CellEditorLocator getTextCellEditorLocator(ITextAwareEditPart source) {
		return CellEditorLocatorAccess.INSTANCE.getTextCellEditorLocator(source);
	}

}
