package muicm.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import muicm.diagram.edit.commands.CameraActionCreateCommand;
import muicm.diagram.edit.commands.DataBindingGroupCreateCommand;
import muicm.diagram.edit.commands.MViewComponentCreateCommand;
import muicm.diagram.edit.commands.MicrophoneActionCreateCommand;
import muicm.diagram.edit.commands.OtherActionCreateCommand;
import muicm.diagram.edit.commands.ScreenCreateCommand;
import muicm.diagram.providers.MuicmElementTypes;

/**
 * @generated
 */
public class MUICMItemSemanticEditPolicy extends MuicmBaseItemSemanticEditPolicy {

	/**
	* @generated
	*/
	public MUICMItemSemanticEditPolicy() {
		super(MuicmElementTypes.MUICM_1000);
	}

	/**
	* @generated
	*/
	protected Command getCreateCommand(CreateElementRequest req) {
		if (MuicmElementTypes.Screen_2001 == req.getElementType()) {
			return getGEFWrapper(new ScreenCreateCommand(req));
		}
		if (MuicmElementTypes.MViewComponent_2002 == req.getElementType()) {
			return getGEFWrapper(new MViewComponentCreateCommand(req));
		}
		if (MuicmElementTypes.OtherAction_2003 == req.getElementType()) {
			return getGEFWrapper(new OtherActionCreateCommand(req));
		}
		if (MuicmElementTypes.CameraAction_2004 == req.getElementType()) {
			return getGEFWrapper(new CameraActionCreateCommand(req));
		}
		if (MuicmElementTypes.MicrophoneAction_2005 == req.getElementType()) {
			return getGEFWrapper(new MicrophoneActionCreateCommand(req));
		}
		if (MuicmElementTypes.DataBindingGroup_2006 == req.getElementType()) {
			return getGEFWrapper(new DataBindingGroupCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	* @generated
	*/
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost()).getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	* @generated
	*/
	private static class DuplicateAnythingCommand extends DuplicateEObjectsCommand {

		/**
		* @generated
		*/
		public DuplicateAnythingCommand(TransactionalEditingDomain editingDomain, DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req.getElementsToBeDuplicated(), req.getAllDuplicatedElementsMap());
		}

	}

}
