package muicm.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import muicm.Calendar;
import muicm.CameraAction;
import muicm.CameraActionEvent;
import muicm.Code;
import muicm.Data;
import muicm.DataBinding;
import muicm.DataBindingGroup;
import muicm.DataFlow;
import muicm.Details;
import muicm.DynamicBehaviour;
import muicm.Form;
import muicm.Icon;
import muicm.Label;
import muicm.LongPressEvent;
import muicm.MActionEvent;
import muicm.MInteractionElement;
import muicm.MInteractionFlow;
import muicm.MUICMElement;
import muicm.MViewComponent;
import muicm.MViewComponentPart;
import muicm.MViewComponentPartAbstract;
import muicm.MViewElement;
import muicm.MViewElementEvent;
import muicm.MViewElementEventAbstract;
import muicm.Media;
import muicm.Message;
import muicm.MicrophoneAction;
import muicm.MicrophoneActionEvent;
import muicm.MuicmPackage;
import muicm.NavigationFlow;
import muicm.OtherAction;
import muicm.OtherActionEvent;
import muicm.PanEvent;
import muicm.PinchEvent;
import muicm.RotateEvent;
import muicm.Screen;
import muicm.SearchView;
import muicm.SelectionField;
import muicm.SimpleField;
import muicm.StaticContent;
import muicm.SwipeEvent;
import muicm.TapEvent;
import muicm.TextBox;
import muicm.ToolBar;
import muicm.TouchEvent;
import muicm.UtilityView;
import muicm.diagram.edit.parts.Calendar2EditPart;
import muicm.diagram.edit.parts.CalendarEditPart;
import muicm.diagram.edit.parts.CameraActionEditPart;
import muicm.diagram.edit.parts.CameraActionEventEditPart;
import muicm.diagram.edit.parts.Code2EditPart;
import muicm.diagram.edit.parts.CodeEditPart;
import muicm.diagram.edit.parts.DataBindingEditPart;
import muicm.diagram.edit.parts.DataBindingGroupDataBindingGroupCompartmentEditPart;
import muicm.diagram.edit.parts.DataBindingGroupEditPart;
import muicm.diagram.edit.parts.DataEditPart;
import muicm.diagram.edit.parts.DataFlowEditPart;
import muicm.diagram.edit.parts.DetailsDetailsCompartmentEditPart;
import muicm.diagram.edit.parts.DetailsEditPart;
import muicm.diagram.edit.parts.DynamicBehaviourEditPart;
import muicm.diagram.edit.parts.FormEditPart;
import muicm.diagram.edit.parts.FormFormCompartmentEditPart;
import muicm.diagram.edit.parts.IconEditPart;
import muicm.diagram.edit.parts.Label2EditPart;
import muicm.diagram.edit.parts.LabelEditPart;
import muicm.diagram.edit.parts.ListEditPart;
import muicm.diagram.edit.parts.ListListCompartmentEditPart;
import muicm.diagram.edit.parts.LongPressEventEditPart;
import muicm.diagram.edit.parts.MInteractionFlowDataBindingGroupEditPart;
import muicm.diagram.edit.parts.MUICMEditPart;
import muicm.diagram.edit.parts.MViewComponent2EditPart;
import muicm.diagram.edit.parts.MViewComponentEditPart;
import muicm.diagram.edit.parts.MViewComponentMViewComponentCompartment2EditPart;
import muicm.diagram.edit.parts.MViewComponentMViewComponentCompartmentEditPart;
import muicm.diagram.edit.parts.MViewComponentPartEditPart;
import muicm.diagram.edit.parts.MViewElementEventEditPart;
import muicm.diagram.edit.parts.Map2EditPart;
import muicm.diagram.edit.parts.MapEditPart;
import muicm.diagram.edit.parts.MediaEditPart;
import muicm.diagram.edit.parts.MessageEditPart;
import muicm.diagram.edit.parts.MicrophoneActionEditPart;
import muicm.diagram.edit.parts.MicrophoneActionEventEditPart;
import muicm.diagram.edit.parts.NavigationFlowEditPart;
import muicm.diagram.edit.parts.OtherActionEditPart;
import muicm.diagram.edit.parts.OtherActionEventEditPart;
import muicm.diagram.edit.parts.PanEventEditPart;
import muicm.diagram.edit.parts.PinchEventEditPart;
import muicm.diagram.edit.parts.RotateEventEditPart;
import muicm.diagram.edit.parts.Screen2EditPart;
import muicm.diagram.edit.parts.ScreenEditPart;
import muicm.diagram.edit.parts.ScreenScreenCompartment2EditPart;
import muicm.diagram.edit.parts.ScreenScreenCompartmentEditPart;
import muicm.diagram.edit.parts.SearchViewEditPart;
import muicm.diagram.edit.parts.SearchViewSearchViewCompartmentEditPart;
import muicm.diagram.edit.parts.SelectionField2EditPart;
import muicm.diagram.edit.parts.SelectionFieldEditPart;
import muicm.diagram.edit.parts.SimpleField2EditPart;
import muicm.diagram.edit.parts.SimpleFieldEditPart;
import muicm.diagram.edit.parts.StaticContent2EditPart;
import muicm.diagram.edit.parts.StaticContentEditPart;
import muicm.diagram.edit.parts.SwipeEventEditPart;
import muicm.diagram.edit.parts.TapEventEditPart;
import muicm.diagram.edit.parts.TextBox2EditPart;
import muicm.diagram.edit.parts.TextBoxEditPart;
import muicm.diagram.edit.parts.ToolBarEditPart;
import muicm.diagram.edit.parts.ToolBarToolBarCompartmentEditPart;
import muicm.diagram.edit.parts.TouchEventEditPart;
import muicm.diagram.edit.parts.UtilityViewEditPart;
import muicm.diagram.edit.parts.UtilityViewUtilityViewCompartmentEditPart;
import muicm.diagram.providers.MuicmElementTypes;

/**
 * @generated
 */
public class MuicmDiagramUpdater {

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getSemanticChildren(View view) {
		switch (MuicmVisualIDRegistry.getVisualID(view)) {
		case MUICMEditPart.VISUAL_ID:
			return getMUICM_1000SemanticChildren(view);
		case ScreenEditPart.VISUAL_ID:
			return getScreen_2001SemanticChildren(view);
		case MViewComponentEditPart.VISUAL_ID:
			return getMViewComponent_2002SemanticChildren(view);
		case OtherActionEditPart.VISUAL_ID:
			return getOtherAction_2003SemanticChildren(view);
		case CameraActionEditPart.VISUAL_ID:
			return getCameraAction_2004SemanticChildren(view);
		case MicrophoneActionEditPart.VISUAL_ID:
			return getMicrophoneAction_2005SemanticChildren(view);
		case Screen2EditPart.VISUAL_ID:
			return getScreen_3001SemanticChildren(view);
		case MViewComponent2EditPart.VISUAL_ID:
			return getMViewComponent_3002SemanticChildren(view);
		case FormEditPart.VISUAL_ID:
			return getForm_3003SemanticChildren(view);
		case ListEditPart.VISUAL_ID:
			return getList_3004SemanticChildren(view);
		case DetailsEditPart.VISUAL_ID:
			return getDetails_3005SemanticChildren(view);
		case UtilityViewEditPart.VISUAL_ID:
			return getUtilityView_3007SemanticChildren(view);
		case SearchViewEditPart.VISUAL_ID:
			return getSearchView_3008SemanticChildren(view);
		case ToolBarEditPart.VISUAL_ID:
			return getToolBar_3009SemanticChildren(view);
		case ScreenScreenCompartmentEditPart.VISUAL_ID:
			return getScreenScreenCompartment_7001SemanticChildren(view);
		case ScreenScreenCompartment2EditPart.VISUAL_ID:
			return getScreenScreenCompartment_7002SemanticChildren(view);
		case MViewComponentMViewComponentCompartmentEditPart.VISUAL_ID:
			return getMViewComponentMViewComponentCompartment_7004SemanticChildren(view);
		case FormFormCompartmentEditPart.VISUAL_ID:
			return getFormFormCompartment_7005SemanticChildren(view);
		case ListListCompartmentEditPart.VISUAL_ID:
			return getListListCompartment_7006SemanticChildren(view);
		case DetailsDetailsCompartmentEditPart.VISUAL_ID:
			return getDetailsDetailsCompartment_7007SemanticChildren(view);
		case UtilityViewUtilityViewCompartmentEditPart.VISUAL_ID:
			return getUtilityViewUtilityViewCompartment_7008SemanticChildren(view);
		case SearchViewSearchViewCompartmentEditPart.VISUAL_ID:
			return getSearchViewSearchViewCompartment_7009SemanticChildren(view);
		case ToolBarToolBarCompartmentEditPart.VISUAL_ID:
			return getToolBarToolBarCompartment_7010SemanticChildren(view);
		case MViewComponentMViewComponentCompartment2EditPart.VISUAL_ID:
			return getMViewComponentMViewComponentCompartment_7011SemanticChildren(view);
		case DataBindingGroupDataBindingGroupCompartmentEditPart.VISUAL_ID:
			return getDataBindingGroupDataBindingGroupCompartment_7003SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getMUICM_1000SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		muicm.MUICM modelElement = (muicm.MUICM) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMuicmElements().iterator(); it.hasNext();) {
			MUICMElement childElement = (MUICMElement) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == ScreenEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewComponentEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == OtherActionEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CameraActionEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MicrophoneActionEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == DataBindingGroupEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getScreen_2001SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Screen modelElement = (Screen) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == LongPressEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getMViewComponent_2002SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		MViewComponent modelElement = (MViewComponent) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getOtherAction_2003SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		OtherAction modelElement = (OtherAction) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMactionEvents().iterator(); it.hasNext();) {
			MActionEvent childElement = (MActionEvent) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == OtherActionEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getCameraAction_2004SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		CameraAction modelElement = (CameraAction) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMactionEvents().iterator(); it.hasNext();) {
			MActionEvent childElement = (MActionEvent) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == CameraActionEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getMicrophoneAction_2005SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		MicrophoneAction modelElement = (MicrophoneAction) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMactionEvents().iterator(); it.hasNext();) {
			MActionEvent childElement = (MActionEvent) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MicrophoneActionEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getScreen_3001SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Screen modelElement = (Screen) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == LongPressEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getMViewComponent_3002SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		MViewComponent modelElement = (MViewComponent) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getForm_3003SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Form modelElement = (Form) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getList_3004SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		muicm.List modelElement = (muicm.List) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getDetails_3005SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Details modelElement = (Details) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getUtilityView_3007SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		UtilityView modelElement = (UtilityView) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MViewElementEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TouchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SwipeEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == RotateEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PinchEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PanEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getSearchView_3008SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		SearchView modelElement = (SearchView) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getToolBar_3009SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		ToolBar modelElement = (ToolBar) view.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElementEvents().iterator(); it.hasNext();) {
			MViewElementEventAbstract childElement = (MViewElementEventAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == TapEventEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getScreenScreenCompartment_7001SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Screen modelElement = (Screen) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElements().iterator(); it.hasNext();) {
			MViewElement childElement = (MViewElement) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == Screen2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewComponent2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == FormEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ListEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == DetailsEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MessageEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == UtilityViewEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SearchViewEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ToolBarEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getDatas().iterator(); it.hasNext();) {
			Data childElement = (Data) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == DataEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getScreenScreenCompartment_7002SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Screen modelElement = (Screen) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewElements().iterator(); it.hasNext();) {
			MViewElement childElement = (MViewElement) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == Screen2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewComponent2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == FormEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ListEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == DetailsEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MessageEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == UtilityViewEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SearchViewEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ToolBarEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getDatas().iterator(); it.hasNext();) {
			Data childElement = (Data) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == DataEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getMViewComponentMViewComponentCompartment_7004SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		MViewComponent modelElement = (MViewComponent) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == LabelEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TextBoxEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MapEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CalendarEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CodeEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SimpleFieldEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SelectionFieldEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewComponentPartEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StaticContentEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == DynamicBehaviourEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MediaEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getFormFormCompartment_7005SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Form modelElement = (Form) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getDatas().iterator(); it.hasNext();) {
			Data childElement = (Data) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == DataEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == SimpleField2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SelectionField2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == Label2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getListListCompartment_7006SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		muicm.List modelElement = (muicm.List) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getDatas().iterator(); it.hasNext();) {
			Data childElement = (Data) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == DataEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == SimpleField2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == Label2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getDetailsDetailsCompartment_7007SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		Details modelElement = (Details) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == TextBox2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StaticContent2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getUtilityViewUtilityViewCompartment_7008SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		UtilityView modelElement = (UtilityView) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == Map2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == Code2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == Calendar2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getSearchViewSearchViewCompartment_7009SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		SearchView modelElement = (SearchView) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == SimpleField2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getToolBarToolBarCompartment_7010SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		ToolBar modelElement = (ToolBar) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == Label2EditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == IconEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getMViewComponentMViewComponentCompartment_7011SemanticChildren(View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		MViewComponent modelElement = (MViewComponent) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getMviewComponentParts().iterator(); it.hasNext();) {
			MViewComponentPartAbstract childElement = (MViewComponentPartAbstract) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == LabelEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == TextBoxEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MapEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CalendarEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CodeEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SimpleFieldEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == SelectionFieldEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MViewComponentPartEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StaticContentEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == DynamicBehaviourEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == MediaEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmNodeDescriptor> getDataBindingGroupDataBindingGroupCompartment_7003SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.emptyList();
		}
		DataBindingGroup modelElement = (DataBindingGroup) containerView.getElement();
		LinkedList<MuicmNodeDescriptor> result = new LinkedList<MuicmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getDataBindings().iterator(); it.hasNext();) {
			DataBinding childElement = (DataBinding) it.next();
			int visualID = MuicmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == DataBindingEditPart.VISUAL_ID) {
				result.add(new MuicmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	* @generated
	*/
	public static List<MuicmLinkDescriptor> getContainedLinks(View view) {
		switch (MuicmVisualIDRegistry.getVisualID(view)) {
		case MUICMEditPart.VISUAL_ID:
			return getMUICM_1000ContainedLinks(view);
		case ScreenEditPart.VISUAL_ID:
			return getScreen_2001ContainedLinks(view);
		case MViewComponentEditPart.VISUAL_ID:
			return getMViewComponent_2002ContainedLinks(view);
		case OtherActionEditPart.VISUAL_ID:
			return getOtherAction_2003ContainedLinks(view);
		case CameraActionEditPart.VISUAL_ID:
			return getCameraAction_2004ContainedLinks(view);
		case MicrophoneActionEditPart.VISUAL_ID:
			return getMicrophoneAction_2005ContainedLinks(view);
		case DataBindingGroupEditPart.VISUAL_ID:
			return getDataBindingGroup_2006ContainedLinks(view);
		case Screen2EditPart.VISUAL_ID:
			return getScreen_3001ContainedLinks(view);
		case MViewComponent2EditPart.VISUAL_ID:
			return getMViewComponent_3002ContainedLinks(view);
		case LabelEditPart.VISUAL_ID:
			return getLabel_3021ContainedLinks(view);
		case TextBoxEditPart.VISUAL_ID:
			return getTextBox_3022ContainedLinks(view);
		case MapEditPart.VISUAL_ID:
			return getMap_3023ContainedLinks(view);
		case CalendarEditPart.VISUAL_ID:
			return getCalendar_3024ContainedLinks(view);
		case CodeEditPart.VISUAL_ID:
			return getCode_3025ContainedLinks(view);
		case SimpleFieldEditPart.VISUAL_ID:
			return getSimpleField_3026ContainedLinks(view);
		case SelectionFieldEditPart.VISUAL_ID:
			return getSelectionField_3027ContainedLinks(view);
		case SwipeEventEditPart.VISUAL_ID:
			return getSwipeEvent_3014ContainedLinks(view);
		case TapEventEditPart.VISUAL_ID:
			return getTapEvent_3015ContainedLinks(view);
		case TouchEventEditPart.VISUAL_ID:
			return getTouchEvent_3016ContainedLinks(view);
		case PanEventEditPart.VISUAL_ID:
			return getPanEvent_3011ContainedLinks(view);
		case PinchEventEditPart.VISUAL_ID:
			return getPinchEvent_3012ContainedLinks(view);
		case RotateEventEditPart.VISUAL_ID:
			return getRotateEvent_3013ContainedLinks(view);
		case MViewElementEventEditPart.VISUAL_ID:
			return getMViewElementEvent_3028ContainedLinks(view);
		case MViewComponentPartEditPart.VISUAL_ID:
			return getMViewComponentPart_3029ContainedLinks(view);
		case StaticContentEditPart.VISUAL_ID:
			return getStaticContent_3030ContainedLinks(view);
		case DynamicBehaviourEditPart.VISUAL_ID:
			return getDynamicBehaviour_3031ContainedLinks(view);
		case MediaEditPart.VISUAL_ID:
			return getMedia_3042ContainedLinks(view);
		case FormEditPart.VISUAL_ID:
			return getForm_3003ContainedLinks(view);
		case DataEditPart.VISUAL_ID:
			return getData_3032ContainedLinks(view);
		case SimpleField2EditPart.VISUAL_ID:
			return getSimpleField_3033ContainedLinks(view);
		case SelectionField2EditPart.VISUAL_ID:
			return getSelectionField_3034ContainedLinks(view);
		case Label2EditPart.VISUAL_ID:
			return getLabel_3035ContainedLinks(view);
		case ListEditPart.VISUAL_ID:
			return getList_3004ContainedLinks(view);
		case DetailsEditPart.VISUAL_ID:
			return getDetails_3005ContainedLinks(view);
		case TextBox2EditPart.VISUAL_ID:
			return getTextBox_3036ContainedLinks(view);
		case StaticContent2EditPart.VISUAL_ID:
			return getStaticContent_3037ContainedLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_3006ContainedLinks(view);
		case UtilityViewEditPart.VISUAL_ID:
			return getUtilityView_3007ContainedLinks(view);
		case Map2EditPart.VISUAL_ID:
			return getMap_3038ContainedLinks(view);
		case Code2EditPart.VISUAL_ID:
			return getCode_3039ContainedLinks(view);
		case Calendar2EditPart.VISUAL_ID:
			return getCalendar_3040ContainedLinks(view);
		case SearchViewEditPart.VISUAL_ID:
			return getSearchView_3008ContainedLinks(view);
		case ToolBarEditPart.VISUAL_ID:
			return getToolBar_3009ContainedLinks(view);
		case IconEditPart.VISUAL_ID:
			return getIcon_3041ContainedLinks(view);
		case LongPressEventEditPart.VISUAL_ID:
			return getLongPressEvent_3010ContainedLinks(view);
		case OtherActionEventEditPart.VISUAL_ID:
			return getOtherActionEvent_3017ContainedLinks(view);
		case CameraActionEventEditPart.VISUAL_ID:
			return getCameraActionEvent_3018ContainedLinks(view);
		case MicrophoneActionEventEditPart.VISUAL_ID:
			return getMicrophoneActionEvent_3019ContainedLinks(view);
		case DataBindingEditPart.VISUAL_ID:
			return getDataBinding_3020ContainedLinks(view);
		case NavigationFlowEditPart.VISUAL_ID:
			return getNavigationFlow_4002ContainedLinks(view);
		case DataFlowEditPart.VISUAL_ID:
			return getDataFlow_4003ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	* @generated
	*/
	public static List<MuicmLinkDescriptor> getIncomingLinks(View view) {
		switch (MuicmVisualIDRegistry.getVisualID(view)) {
		case ScreenEditPart.VISUAL_ID:
			return getScreen_2001IncomingLinks(view);
		case MViewComponentEditPart.VISUAL_ID:
			return getMViewComponent_2002IncomingLinks(view);
		case OtherActionEditPart.VISUAL_ID:
			return getOtherAction_2003IncomingLinks(view);
		case CameraActionEditPart.VISUAL_ID:
			return getCameraAction_2004IncomingLinks(view);
		case MicrophoneActionEditPart.VISUAL_ID:
			return getMicrophoneAction_2005IncomingLinks(view);
		case DataBindingGroupEditPart.VISUAL_ID:
			return getDataBindingGroup_2006IncomingLinks(view);
		case Screen2EditPart.VISUAL_ID:
			return getScreen_3001IncomingLinks(view);
		case MViewComponent2EditPart.VISUAL_ID:
			return getMViewComponent_3002IncomingLinks(view);
		case LabelEditPart.VISUAL_ID:
			return getLabel_3021IncomingLinks(view);
		case TextBoxEditPart.VISUAL_ID:
			return getTextBox_3022IncomingLinks(view);
		case MapEditPart.VISUAL_ID:
			return getMap_3023IncomingLinks(view);
		case CalendarEditPart.VISUAL_ID:
			return getCalendar_3024IncomingLinks(view);
		case CodeEditPart.VISUAL_ID:
			return getCode_3025IncomingLinks(view);
		case SimpleFieldEditPart.VISUAL_ID:
			return getSimpleField_3026IncomingLinks(view);
		case SelectionFieldEditPart.VISUAL_ID:
			return getSelectionField_3027IncomingLinks(view);
		case SwipeEventEditPart.VISUAL_ID:
			return getSwipeEvent_3014IncomingLinks(view);
		case TapEventEditPart.VISUAL_ID:
			return getTapEvent_3015IncomingLinks(view);
		case TouchEventEditPart.VISUAL_ID:
			return getTouchEvent_3016IncomingLinks(view);
		case PanEventEditPart.VISUAL_ID:
			return getPanEvent_3011IncomingLinks(view);
		case PinchEventEditPart.VISUAL_ID:
			return getPinchEvent_3012IncomingLinks(view);
		case RotateEventEditPart.VISUAL_ID:
			return getRotateEvent_3013IncomingLinks(view);
		case MViewElementEventEditPart.VISUAL_ID:
			return getMViewElementEvent_3028IncomingLinks(view);
		case MViewComponentPartEditPart.VISUAL_ID:
			return getMViewComponentPart_3029IncomingLinks(view);
		case StaticContentEditPart.VISUAL_ID:
			return getStaticContent_3030IncomingLinks(view);
		case DynamicBehaviourEditPart.VISUAL_ID:
			return getDynamicBehaviour_3031IncomingLinks(view);
		case MediaEditPart.VISUAL_ID:
			return getMedia_3042IncomingLinks(view);
		case FormEditPart.VISUAL_ID:
			return getForm_3003IncomingLinks(view);
		case DataEditPart.VISUAL_ID:
			return getData_3032IncomingLinks(view);
		case SimpleField2EditPart.VISUAL_ID:
			return getSimpleField_3033IncomingLinks(view);
		case SelectionField2EditPart.VISUAL_ID:
			return getSelectionField_3034IncomingLinks(view);
		case Label2EditPart.VISUAL_ID:
			return getLabel_3035IncomingLinks(view);
		case ListEditPart.VISUAL_ID:
			return getList_3004IncomingLinks(view);
		case DetailsEditPart.VISUAL_ID:
			return getDetails_3005IncomingLinks(view);
		case TextBox2EditPart.VISUAL_ID:
			return getTextBox_3036IncomingLinks(view);
		case StaticContent2EditPart.VISUAL_ID:
			return getStaticContent_3037IncomingLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_3006IncomingLinks(view);
		case UtilityViewEditPart.VISUAL_ID:
			return getUtilityView_3007IncomingLinks(view);
		case Map2EditPart.VISUAL_ID:
			return getMap_3038IncomingLinks(view);
		case Code2EditPart.VISUAL_ID:
			return getCode_3039IncomingLinks(view);
		case Calendar2EditPart.VISUAL_ID:
			return getCalendar_3040IncomingLinks(view);
		case SearchViewEditPart.VISUAL_ID:
			return getSearchView_3008IncomingLinks(view);
		case ToolBarEditPart.VISUAL_ID:
			return getToolBar_3009IncomingLinks(view);
		case IconEditPart.VISUAL_ID:
			return getIcon_3041IncomingLinks(view);
		case LongPressEventEditPart.VISUAL_ID:
			return getLongPressEvent_3010IncomingLinks(view);
		case OtherActionEventEditPart.VISUAL_ID:
			return getOtherActionEvent_3017IncomingLinks(view);
		case CameraActionEventEditPart.VISUAL_ID:
			return getCameraActionEvent_3018IncomingLinks(view);
		case MicrophoneActionEventEditPart.VISUAL_ID:
			return getMicrophoneActionEvent_3019IncomingLinks(view);
		case DataBindingEditPart.VISUAL_ID:
			return getDataBinding_3020IncomingLinks(view);
		case NavigationFlowEditPart.VISUAL_ID:
			return getNavigationFlow_4002IncomingLinks(view);
		case DataFlowEditPart.VISUAL_ID:
			return getDataFlow_4003IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	* @generated
	*/
	public static List<MuicmLinkDescriptor> getOutgoingLinks(View view) {
		switch (MuicmVisualIDRegistry.getVisualID(view)) {
		case ScreenEditPart.VISUAL_ID:
			return getScreen_2001OutgoingLinks(view);
		case MViewComponentEditPart.VISUAL_ID:
			return getMViewComponent_2002OutgoingLinks(view);
		case OtherActionEditPart.VISUAL_ID:
			return getOtherAction_2003OutgoingLinks(view);
		case CameraActionEditPart.VISUAL_ID:
			return getCameraAction_2004OutgoingLinks(view);
		case MicrophoneActionEditPart.VISUAL_ID:
			return getMicrophoneAction_2005OutgoingLinks(view);
		case DataBindingGroupEditPart.VISUAL_ID:
			return getDataBindingGroup_2006OutgoingLinks(view);
		case Screen2EditPart.VISUAL_ID:
			return getScreen_3001OutgoingLinks(view);
		case MViewComponent2EditPart.VISUAL_ID:
			return getMViewComponent_3002OutgoingLinks(view);
		case LabelEditPart.VISUAL_ID:
			return getLabel_3021OutgoingLinks(view);
		case TextBoxEditPart.VISUAL_ID:
			return getTextBox_3022OutgoingLinks(view);
		case MapEditPart.VISUAL_ID:
			return getMap_3023OutgoingLinks(view);
		case CalendarEditPart.VISUAL_ID:
			return getCalendar_3024OutgoingLinks(view);
		case CodeEditPart.VISUAL_ID:
			return getCode_3025OutgoingLinks(view);
		case SimpleFieldEditPart.VISUAL_ID:
			return getSimpleField_3026OutgoingLinks(view);
		case SelectionFieldEditPart.VISUAL_ID:
			return getSelectionField_3027OutgoingLinks(view);
		case SwipeEventEditPart.VISUAL_ID:
			return getSwipeEvent_3014OutgoingLinks(view);
		case TapEventEditPart.VISUAL_ID:
			return getTapEvent_3015OutgoingLinks(view);
		case TouchEventEditPart.VISUAL_ID:
			return getTouchEvent_3016OutgoingLinks(view);
		case PanEventEditPart.VISUAL_ID:
			return getPanEvent_3011OutgoingLinks(view);
		case PinchEventEditPart.VISUAL_ID:
			return getPinchEvent_3012OutgoingLinks(view);
		case RotateEventEditPart.VISUAL_ID:
			return getRotateEvent_3013OutgoingLinks(view);
		case MViewElementEventEditPart.VISUAL_ID:
			return getMViewElementEvent_3028OutgoingLinks(view);
		case MViewComponentPartEditPart.VISUAL_ID:
			return getMViewComponentPart_3029OutgoingLinks(view);
		case StaticContentEditPart.VISUAL_ID:
			return getStaticContent_3030OutgoingLinks(view);
		case DynamicBehaviourEditPart.VISUAL_ID:
			return getDynamicBehaviour_3031OutgoingLinks(view);
		case MediaEditPart.VISUAL_ID:
			return getMedia_3042OutgoingLinks(view);
		case FormEditPart.VISUAL_ID:
			return getForm_3003OutgoingLinks(view);
		case DataEditPart.VISUAL_ID:
			return getData_3032OutgoingLinks(view);
		case SimpleField2EditPart.VISUAL_ID:
			return getSimpleField_3033OutgoingLinks(view);
		case SelectionField2EditPart.VISUAL_ID:
			return getSelectionField_3034OutgoingLinks(view);
		case Label2EditPart.VISUAL_ID:
			return getLabel_3035OutgoingLinks(view);
		case ListEditPart.VISUAL_ID:
			return getList_3004OutgoingLinks(view);
		case DetailsEditPart.VISUAL_ID:
			return getDetails_3005OutgoingLinks(view);
		case TextBox2EditPart.VISUAL_ID:
			return getTextBox_3036OutgoingLinks(view);
		case StaticContent2EditPart.VISUAL_ID:
			return getStaticContent_3037OutgoingLinks(view);
		case MessageEditPart.VISUAL_ID:
			return getMessage_3006OutgoingLinks(view);
		case UtilityViewEditPart.VISUAL_ID:
			return getUtilityView_3007OutgoingLinks(view);
		case Map2EditPart.VISUAL_ID:
			return getMap_3038OutgoingLinks(view);
		case Code2EditPart.VISUAL_ID:
			return getCode_3039OutgoingLinks(view);
		case Calendar2EditPart.VISUAL_ID:
			return getCalendar_3040OutgoingLinks(view);
		case SearchViewEditPart.VISUAL_ID:
			return getSearchView_3008OutgoingLinks(view);
		case ToolBarEditPart.VISUAL_ID:
			return getToolBar_3009OutgoingLinks(view);
		case IconEditPart.VISUAL_ID:
			return getIcon_3041OutgoingLinks(view);
		case LongPressEventEditPart.VISUAL_ID:
			return getLongPressEvent_3010OutgoingLinks(view);
		case OtherActionEventEditPart.VISUAL_ID:
			return getOtherActionEvent_3017OutgoingLinks(view);
		case CameraActionEventEditPart.VISUAL_ID:
			return getCameraActionEvent_3018OutgoingLinks(view);
		case MicrophoneActionEventEditPart.VISUAL_ID:
			return getMicrophoneActionEvent_3019OutgoingLinks(view);
		case DataBindingEditPart.VISUAL_ID:
			return getDataBinding_3020OutgoingLinks(view);
		case NavigationFlowEditPart.VISUAL_ID:
			return getNavigationFlow_4002OutgoingLinks(view);
		case DataFlowEditPart.VISUAL_ID:
			return getDataFlow_4003OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMUICM_1000ContainedLinks(View view) {
		muicm.MUICM modelElement = (muicm.MUICM) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getScreen_2001ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponent_2002ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getOtherAction_2003ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCameraAction_2004ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMicrophoneAction_2005ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataBindingGroup_2006ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getScreen_3001ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponent_3002ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLabel_3021ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTextBox_3022ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMap_3023ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCalendar_3024ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCode_3025ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSimpleField_3026ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSelectionField_3027ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSwipeEvent_3014ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTapEvent_3015ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTouchEvent_3016ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getPanEvent_3011ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getPinchEvent_3012ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getRotateEvent_3013ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewElementEvent_3028ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponentPart_3029ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getStaticContent_3030ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDynamicBehaviour_3031ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMedia_3042ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getForm_3003ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getData_3032ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSimpleField_3033ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSelectionField_3034ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLabel_3035ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getList_3004ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDetails_3005ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTextBox_3036ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getStaticContent_3037ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMessage_3006ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getUtilityView_3007ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMap_3038ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCode_3039ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCalendar_3040ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSearchView_3008ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getToolBar_3009ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getIcon_3041ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLongPressEvent_3010ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getOtherActionEvent_3017ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCameraActionEvent_3018ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMicrophoneActionEvent_3019ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataBinding_3020ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getNavigationFlow_4002ContainedLinks(View view) {
		NavigationFlow modelElement = (NavigationFlow) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MInteractionFlow_DataBindingGroup_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataFlow_4003ContainedLinks(View view) {
		DataFlow modelElement = (DataFlow) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MInteractionFlow_DataBindingGroup_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getScreen_2001IncomingLinks(View view) {
		Screen modelElement = (Screen) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponent_2002IncomingLinks(View view) {
		MViewComponent modelElement = (MViewComponent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getOtherAction_2003IncomingLinks(View view) {
		OtherAction modelElement = (OtherAction) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCameraAction_2004IncomingLinks(View view) {
		CameraAction modelElement = (CameraAction) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMicrophoneAction_2005IncomingLinks(View view) {
		MicrophoneAction modelElement = (MicrophoneAction) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataBindingGroup_2006IncomingLinks(View view) {
		DataBindingGroup modelElement = (DataBindingGroup) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_MInteractionFlow_DataBindingGroup_4001(modelElement,
				crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getScreen_3001IncomingLinks(View view) {
		Screen modelElement = (Screen) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponent_3002IncomingLinks(View view) {
		MViewComponent modelElement = (MViewComponent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLabel_3021IncomingLinks(View view) {
		Label modelElement = (Label) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTextBox_3022IncomingLinks(View view) {
		TextBox modelElement = (TextBox) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMap_3023IncomingLinks(View view) {
		muicm.Map modelElement = (muicm.Map) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCalendar_3024IncomingLinks(View view) {
		Calendar modelElement = (Calendar) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCode_3025IncomingLinks(View view) {
		Code modelElement = (Code) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSimpleField_3026IncomingLinks(View view) {
		SimpleField modelElement = (SimpleField) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSelectionField_3027IncomingLinks(View view) {
		SelectionField modelElement = (SelectionField) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSwipeEvent_3014IncomingLinks(View view) {
		SwipeEvent modelElement = (SwipeEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTapEvent_3015IncomingLinks(View view) {
		TapEvent modelElement = (TapEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTouchEvent_3016IncomingLinks(View view) {
		TouchEvent modelElement = (TouchEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getPanEvent_3011IncomingLinks(View view) {
		PanEvent modelElement = (PanEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getPinchEvent_3012IncomingLinks(View view) {
		PinchEvent modelElement = (PinchEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getRotateEvent_3013IncomingLinks(View view) {
		RotateEvent modelElement = (RotateEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewElementEvent_3028IncomingLinks(View view) {
		MViewElementEvent modelElement = (MViewElementEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponentPart_3029IncomingLinks(View view) {
		MViewComponentPart modelElement = (MViewComponentPart) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getStaticContent_3030IncomingLinks(View view) {
		StaticContent modelElement = (StaticContent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDynamicBehaviour_3031IncomingLinks(View view) {
		DynamicBehaviour modelElement = (DynamicBehaviour) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMedia_3042IncomingLinks(View view) {
		Media modelElement = (Media) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getForm_3003IncomingLinks(View view) {
		Form modelElement = (Form) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getData_3032IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSimpleField_3033IncomingLinks(View view) {
		SimpleField modelElement = (SimpleField) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSelectionField_3034IncomingLinks(View view) {
		SelectionField modelElement = (SelectionField) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLabel_3035IncomingLinks(View view) {
		Label modelElement = (Label) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getList_3004IncomingLinks(View view) {
		muicm.List modelElement = (muicm.List) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDetails_3005IncomingLinks(View view) {
		Details modelElement = (Details) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTextBox_3036IncomingLinks(View view) {
		TextBox modelElement = (TextBox) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getStaticContent_3037IncomingLinks(View view) {
		StaticContent modelElement = (StaticContent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMessage_3006IncomingLinks(View view) {
		Message modelElement = (Message) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getUtilityView_3007IncomingLinks(View view) {
		UtilityView modelElement = (UtilityView) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMap_3038IncomingLinks(View view) {
		muicm.Map modelElement = (muicm.Map) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCode_3039IncomingLinks(View view) {
		Code modelElement = (Code) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCalendar_3040IncomingLinks(View view) {
		Calendar modelElement = (Calendar) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSearchView_3008IncomingLinks(View view) {
		SearchView modelElement = (SearchView) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getToolBar_3009IncomingLinks(View view) {
		ToolBar modelElement = (ToolBar) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getIcon_3041IncomingLinks(View view) {
		Icon modelElement = (Icon) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLongPressEvent_3010IncomingLinks(View view) {
		LongPressEvent modelElement = (LongPressEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getOtherActionEvent_3017IncomingLinks(View view) {
		OtherActionEvent modelElement = (OtherActionEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCameraActionEvent_3018IncomingLinks(View view) {
		CameraActionEvent modelElement = (CameraActionEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMicrophoneActionEvent_3019IncomingLinks(View view) {
		MicrophoneActionEvent modelElement = (MicrophoneActionEvent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_NavigationFlow_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_DataFlow_4003(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataBinding_3020IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getNavigationFlow_4002IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataFlow_4003IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getScreen_2001OutgoingLinks(View view) {
		Screen modelElement = (Screen) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponent_2002OutgoingLinks(View view) {
		MViewComponent modelElement = (MViewComponent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getOtherAction_2003OutgoingLinks(View view) {
		OtherAction modelElement = (OtherAction) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCameraAction_2004OutgoingLinks(View view) {
		CameraAction modelElement = (CameraAction) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMicrophoneAction_2005OutgoingLinks(View view) {
		MicrophoneAction modelElement = (MicrophoneAction) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataBindingGroup_2006OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getScreen_3001OutgoingLinks(View view) {
		Screen modelElement = (Screen) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponent_3002OutgoingLinks(View view) {
		MViewComponent modelElement = (MViewComponent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLabel_3021OutgoingLinks(View view) {
		Label modelElement = (Label) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTextBox_3022OutgoingLinks(View view) {
		TextBox modelElement = (TextBox) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMap_3023OutgoingLinks(View view) {
		muicm.Map modelElement = (muicm.Map) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCalendar_3024OutgoingLinks(View view) {
		Calendar modelElement = (Calendar) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCode_3025OutgoingLinks(View view) {
		Code modelElement = (Code) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSimpleField_3026OutgoingLinks(View view) {
		SimpleField modelElement = (SimpleField) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSelectionField_3027OutgoingLinks(View view) {
		SelectionField modelElement = (SelectionField) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSwipeEvent_3014OutgoingLinks(View view) {
		SwipeEvent modelElement = (SwipeEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTapEvent_3015OutgoingLinks(View view) {
		TapEvent modelElement = (TapEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTouchEvent_3016OutgoingLinks(View view) {
		TouchEvent modelElement = (TouchEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getPanEvent_3011OutgoingLinks(View view) {
		PanEvent modelElement = (PanEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getPinchEvent_3012OutgoingLinks(View view) {
		PinchEvent modelElement = (PinchEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getRotateEvent_3013OutgoingLinks(View view) {
		RotateEvent modelElement = (RotateEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewElementEvent_3028OutgoingLinks(View view) {
		MViewElementEvent modelElement = (MViewElementEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMViewComponentPart_3029OutgoingLinks(View view) {
		MViewComponentPart modelElement = (MViewComponentPart) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getStaticContent_3030OutgoingLinks(View view) {
		StaticContent modelElement = (StaticContent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDynamicBehaviour_3031OutgoingLinks(View view) {
		DynamicBehaviour modelElement = (DynamicBehaviour) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMedia_3042OutgoingLinks(View view) {
		Media modelElement = (Media) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getForm_3003OutgoingLinks(View view) {
		Form modelElement = (Form) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getData_3032OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSimpleField_3033OutgoingLinks(View view) {
		SimpleField modelElement = (SimpleField) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSelectionField_3034OutgoingLinks(View view) {
		SelectionField modelElement = (SelectionField) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLabel_3035OutgoingLinks(View view) {
		Label modelElement = (Label) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getList_3004OutgoingLinks(View view) {
		muicm.List modelElement = (muicm.List) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDetails_3005OutgoingLinks(View view) {
		Details modelElement = (Details) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getTextBox_3036OutgoingLinks(View view) {
		TextBox modelElement = (TextBox) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getStaticContent_3037OutgoingLinks(View view) {
		StaticContent modelElement = (StaticContent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMessage_3006OutgoingLinks(View view) {
		Message modelElement = (Message) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getUtilityView_3007OutgoingLinks(View view) {
		UtilityView modelElement = (UtilityView) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMap_3038OutgoingLinks(View view) {
		muicm.Map modelElement = (muicm.Map) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCode_3039OutgoingLinks(View view) {
		Code modelElement = (Code) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCalendar_3040OutgoingLinks(View view) {
		Calendar modelElement = (Calendar) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getSearchView_3008OutgoingLinks(View view) {
		SearchView modelElement = (SearchView) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getToolBar_3009OutgoingLinks(View view) {
		ToolBar modelElement = (ToolBar) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getIcon_3041OutgoingLinks(View view) {
		Icon modelElement = (Icon) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getLongPressEvent_3010OutgoingLinks(View view) {
		LongPressEvent modelElement = (LongPressEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getOtherActionEvent_3017OutgoingLinks(View view) {
		OtherActionEvent modelElement = (OtherActionEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getCameraActionEvent_3018OutgoingLinks(View view) {
		CameraActionEvent modelElement = (CameraActionEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getMicrophoneActionEvent_3019OutgoingLinks(View view) {
		MicrophoneActionEvent modelElement = (MicrophoneActionEvent) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_NavigationFlow_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_DataFlow_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataBinding_3020OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getNavigationFlow_4002OutgoingLinks(View view) {
		NavigationFlow modelElement = (NavigationFlow) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MInteractionFlow_DataBindingGroup_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MuicmLinkDescriptor> getDataFlow_4003OutgoingLinks(View view) {
		DataFlow modelElement = (DataFlow) view.getElement();
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MInteractionFlow_DataBindingGroup_4001(modelElement));
		return result;
	}

	/**
	* @generated
	*/
	private static Collection<MuicmLinkDescriptor> getContainedTypeModelFacetLinks_NavigationFlow_4002(
			muicm.MUICM container) {
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		for (Iterator<?> links = container.getMuicmElements().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof NavigationFlow) {
				continue;
			}
			NavigationFlow link = (NavigationFlow) linkObject;
			if (NavigationFlowEditPart.VISUAL_ID != MuicmVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			MInteractionElement dst = link.getTargetInteractionElement();
			MInteractionElement src = link.getSourceInteractionElement();
			result.add(new MuicmLinkDescriptor(src, dst, link, MuicmElementTypes.NavigationFlow_4002,
					NavigationFlowEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	* @generated
	*/
	private static Collection<MuicmLinkDescriptor> getContainedTypeModelFacetLinks_DataFlow_4003(
			muicm.MUICM container) {
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		for (Iterator<?> links = container.getMuicmElements().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof DataFlow) {
				continue;
			}
			DataFlow link = (DataFlow) linkObject;
			if (DataFlowEditPart.VISUAL_ID != MuicmVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			MInteractionElement dst = link.getTargetInteractionElement();
			MInteractionElement src = link.getSourceInteractionElement();
			result.add(new MuicmLinkDescriptor(src, dst, link, MuicmElementTypes.DataFlow_4003,
					DataFlowEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MuicmLinkDescriptor> getIncomingFeatureModelFacetLinks_MInteractionFlow_DataBindingGroup_4001(
			DataBindingGroup target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == MuicmPackage.eINSTANCE.getMInteractionFlow_DataBindingGroup()) {
				result.add(new MuicmLinkDescriptor(setting.getEObject(), target,
						MuicmElementTypes.MInteractionFlowDataBindingGroup_4001,
						MInteractionFlowDataBindingGroupEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MuicmLinkDescriptor> getIncomingTypeModelFacetLinks_NavigationFlow_4002(
			MInteractionElement target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != MuicmPackage.eINSTANCE.getMInteractionFlow_TargetInteractionElement()
					|| false == setting.getEObject() instanceof NavigationFlow) {
				continue;
			}
			NavigationFlow link = (NavigationFlow) setting.getEObject();
			if (NavigationFlowEditPart.VISUAL_ID != MuicmVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			MInteractionElement src = link.getSourceInteractionElement();
			result.add(new MuicmLinkDescriptor(src, target, link, MuicmElementTypes.NavigationFlow_4002,
					NavigationFlowEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MuicmLinkDescriptor> getIncomingTypeModelFacetLinks_DataFlow_4003(
			MInteractionElement target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != MuicmPackage.eINSTANCE.getMInteractionFlow_TargetInteractionElement()
					|| false == setting.getEObject() instanceof DataFlow) {
				continue;
			}
			DataFlow link = (DataFlow) setting.getEObject();
			if (DataFlowEditPart.VISUAL_ID != MuicmVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			MInteractionElement src = link.getSourceInteractionElement();
			result.add(new MuicmLinkDescriptor(src, target, link, MuicmElementTypes.DataFlow_4003,
					DataFlowEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	* @generated
	*/
	private static Collection<MuicmLinkDescriptor> getOutgoingFeatureModelFacetLinks_MInteractionFlow_DataBindingGroup_4001(
			MInteractionFlow source) {
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		DataBindingGroup destination = source.getDataBindingGroup();
		if (destination == null) {
			return result;
		}
		result.add(new MuicmLinkDescriptor(source, destination, MuicmElementTypes.MInteractionFlowDataBindingGroup_4001,
				MInteractionFlowDataBindingGroupEditPart.VISUAL_ID));
		return result;
	}

	/**
	* @generated
	*/
	private static Collection<MuicmLinkDescriptor> getOutgoingTypeModelFacetLinks_NavigationFlow_4002(
			MInteractionElement source) {
		muicm.MUICM container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer()) {
			if (element instanceof muicm.MUICM) {
				container = (muicm.MUICM) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		for (Iterator<?> links = container.getMuicmElements().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof NavigationFlow) {
				continue;
			}
			NavigationFlow link = (NavigationFlow) linkObject;
			if (NavigationFlowEditPart.VISUAL_ID != MuicmVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			MInteractionElement dst = link.getTargetInteractionElement();
			MInteractionElement src = link.getSourceInteractionElement();
			if (src != source) {
				continue;
			}
			result.add(new MuicmLinkDescriptor(src, dst, link, MuicmElementTypes.NavigationFlow_4002,
					NavigationFlowEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	* @generated
	*/
	private static Collection<MuicmLinkDescriptor> getOutgoingTypeModelFacetLinks_DataFlow_4003(
			MInteractionElement source) {
		muicm.MUICM container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer()) {
			if (element instanceof muicm.MUICM) {
				container = (muicm.MUICM) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<MuicmLinkDescriptor> result = new LinkedList<MuicmLinkDescriptor>();
		for (Iterator<?> links = container.getMuicmElements().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof DataFlow) {
				continue;
			}
			DataFlow link = (DataFlow) linkObject;
			if (DataFlowEditPart.VISUAL_ID != MuicmVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			MInteractionElement dst = link.getTargetInteractionElement();
			MInteractionElement src = link.getSourceInteractionElement();
			if (src != source) {
				continue;
			}
			result.add(new MuicmLinkDescriptor(src, dst, link, MuicmElementTypes.DataFlow_4003,
					DataFlowEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	* @generated
	*/
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		* @generated
		*/
		@Override

		public List<MuicmNodeDescriptor> getSemanticChildren(View view) {
			return MuicmDiagramUpdater.getSemanticChildren(view);
		}

		/**
		* @generated
		*/
		@Override

		public List<MuicmLinkDescriptor> getContainedLinks(View view) {
			return MuicmDiagramUpdater.getContainedLinks(view);
		}

		/**
		* @generated
		*/
		@Override

		public List<MuicmLinkDescriptor> getIncomingLinks(View view) {
			return MuicmDiagramUpdater.getIncomingLinks(view);
		}

		/**
		* @generated
		*/
		@Override

		public List<MuicmLinkDescriptor> getOutgoingLinks(View view) {
			return MuicmDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
