/**
 */
package muicm.provider;

import java.util.ArrayList;
import java.util.Collection;

import muicm.util.MuicmAdapterFactory;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class MuicmItemProviderAdapterFactory extends MuicmAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MuicmItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.MUICM} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MUICMItemProvider muicmItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.MUICM}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMUICMAdapter() {
		if (muicmItemProvider == null) {
			muicmItemProvider = new MUICMItemProvider(this);
		}

		return muicmItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.MInteractionFlow} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MInteractionFlowItemProvider mInteractionFlowItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.MInteractionFlow}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMInteractionFlowAdapter() {
		if (mInteractionFlowItemProvider == null) {
			mInteractionFlowItemProvider = new MInteractionFlowItemProvider(this);
		}

		return mInteractionFlowItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.NavigationFlow} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NavigationFlowItemProvider navigationFlowItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.NavigationFlow}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNavigationFlowAdapter() {
		if (navigationFlowItemProvider == null) {
			navigationFlowItemProvider = new NavigationFlowItemProvider(this);
		}

		return navigationFlowItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.DataFlow} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataFlowItemProvider dataFlowItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.DataFlow}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDataFlowAdapter() {
		if (dataFlowItemProvider == null) {
			dataFlowItemProvider = new DataFlowItemProvider(this);
		}

		return dataFlowItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.DataBindingGroup} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataBindingGroupItemProvider dataBindingGroupItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.DataBindingGroup}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDataBindingGroupAdapter() {
		if (dataBindingGroupItemProvider == null) {
			dataBindingGroupItemProvider = new DataBindingGroupItemProvider(this);
		}

		return dataBindingGroupItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.DataBinding} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataBindingItemProvider dataBindingItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.DataBinding}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDataBindingAdapter() {
		if (dataBindingItemProvider == null) {
			dataBindingItemProvider = new DataBindingItemProvider(this);
		}

		return dataBindingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Data} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataItemProvider dataItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Data}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDataAdapter() {
		if (dataItemProvider == null) {
			dataItemProvider = new DataItemProvider(this);
		}

		return dataItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Screen} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ScreenItemProvider screenItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Screen}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createScreenAdapter() {
		if (screenItemProvider == null) {
			screenItemProvider = new ScreenItemProvider(this);
		}

		return screenItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.MViewComponent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MViewComponentItemProvider mViewComponentItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.MViewComponent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMViewComponentAdapter() {
		if (mViewComponentItemProvider == null) {
			mViewComponentItemProvider = new MViewComponentItemProvider(this);
		}

		return mViewComponentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.SearchView} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SearchViewItemProvider searchViewItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.SearchView}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSearchViewAdapter() {
		if (searchViewItemProvider == null) {
			searchViewItemProvider = new SearchViewItemProvider(this);
		}

		return searchViewItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.List} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ListItemProvider listItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.List}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createListAdapter() {
		if (listItemProvider == null) {
			listItemProvider = new ListItemProvider(this);
		}

		return listItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.ToolBar} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ToolBarItemProvider toolBarItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.ToolBar}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createToolBarAdapter() {
		if (toolBarItemProvider == null) {
			toolBarItemProvider = new ToolBarItemProvider(this);
		}

		return toolBarItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Form} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FormItemProvider formItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Form}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFormAdapter() {
		if (formItemProvider == null) {
			formItemProvider = new FormItemProvider(this);
		}

		return formItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Message} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MessageItemProvider messageItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Message}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMessageAdapter() {
		if (messageItemProvider == null) {
			messageItemProvider = new MessageItemProvider(this);
		}

		return messageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Details} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DetailsItemProvider detailsItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Details}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDetailsAdapter() {
		if (detailsItemProvider == null) {
			detailsItemProvider = new DetailsItemProvider(this);
		}

		return detailsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.UtilityView} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UtilityViewItemProvider utilityViewItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.UtilityView}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUtilityViewAdapter() {
		if (utilityViewItemProvider == null) {
			utilityViewItemProvider = new UtilityViewItemProvider(this);
		}

		return utilityViewItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.SimpleField} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SimpleFieldItemProvider simpleFieldItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.SimpleField}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSimpleFieldAdapter() {
		if (simpleFieldItemProvider == null) {
			simpleFieldItemProvider = new SimpleFieldItemProvider(this);
		}

		return simpleFieldItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.SelectionField} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SelectionFieldItemProvider selectionFieldItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.SelectionField}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSelectionFieldAdapter() {
		if (selectionFieldItemProvider == null) {
			selectionFieldItemProvider = new SelectionFieldItemProvider(this);
		}

		return selectionFieldItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.TextBox} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TextBoxItemProvider textBoxItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.TextBox}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTextBoxAdapter() {
		if (textBoxItemProvider == null) {
			textBoxItemProvider = new TextBoxItemProvider(this);
		}

		return textBoxItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Media} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MediaItemProvider mediaItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Media}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMediaAdapter() {
		if (mediaItemProvider == null) {
			mediaItemProvider = new MediaItemProvider(this);
		}

		return mediaItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Label} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LabelItemProvider labelItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Label}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLabelAdapter() {
		if (labelItemProvider == null) {
			labelItemProvider = new LabelItemProvider(this);
		}

		return labelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Map} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MapItemProvider mapItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Map}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMapAdapter() {
		if (mapItemProvider == null) {
			mapItemProvider = new MapItemProvider(this);
		}

		return mapItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Calendar} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CalendarItemProvider calendarItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Calendar}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCalendarAdapter() {
		if (calendarItemProvider == null) {
			calendarItemProvider = new CalendarItemProvider(this);
		}

		return calendarItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Code} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CodeItemProvider codeItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Code}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCodeAdapter() {
		if (codeItemProvider == null) {
			codeItemProvider = new CodeItemProvider(this);
		}

		return codeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Icon} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IconItemProvider iconItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Icon}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIconAdapter() {
		if (iconItemProvider == null) {
			iconItemProvider = new IconItemProvider(this);
		}

		return iconItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.MViewComponentPart} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MViewComponentPartItemProvider mViewComponentPartItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.MViewComponentPart}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMViewComponentPartAdapter() {
		if (mViewComponentPartItemProvider == null) {
			mViewComponentPartItemProvider = new MViewComponentPartItemProvider(this);
		}

		return mViewComponentPartItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.MViewElementEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MViewElementEventItemProvider mViewElementEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.MViewElementEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMViewElementEventAdapter() {
		if (mViewElementEventItemProvider == null) {
			mViewElementEventItemProvider = new MViewElementEventItemProvider(this);
		}

		return mViewElementEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.PinchEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PinchEventItemProvider pinchEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.PinchEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPinchEventAdapter() {
		if (pinchEventItemProvider == null) {
			pinchEventItemProvider = new PinchEventItemProvider(this);
		}

		return pinchEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.RotateEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RotateEventItemProvider rotateEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.RotateEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRotateEventAdapter() {
		if (rotateEventItemProvider == null) {
			rotateEventItemProvider = new RotateEventItemProvider(this);
		}

		return rotateEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.TapEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TapEventItemProvider tapEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.TapEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTapEventAdapter() {
		if (tapEventItemProvider == null) {
			tapEventItemProvider = new TapEventItemProvider(this);
		}

		return tapEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.SystemEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SystemEventItemProvider systemEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.SystemEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSystemEventAdapter() {
		if (systemEventItemProvider == null) {
			systemEventItemProvider = new SystemEventItemProvider(this);
		}

		return systemEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.PanEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PanEventItemProvider panEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.PanEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPanEventAdapter() {
		if (panEventItemProvider == null) {
			panEventItemProvider = new PanEventItemProvider(this);
		}

		return panEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.TouchEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TouchEventItemProvider touchEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.TouchEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTouchEventAdapter() {
		if (touchEventItemProvider == null) {
			touchEventItemProvider = new TouchEventItemProvider(this);
		}

		return touchEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.LongPressEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LongPressEventItemProvider longPressEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.LongPressEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLongPressEventAdapter() {
		if (longPressEventItemProvider == null) {
			longPressEventItemProvider = new LongPressEventItemProvider(this);
		}

		return longPressEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.SwipeEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SwipeEventItemProvider swipeEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.SwipeEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSwipeEventAdapter() {
		if (swipeEventItemProvider == null) {
			swipeEventItemProvider = new SwipeEventItemProvider(this);
		}

		return swipeEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.CameraActionEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CameraActionEventItemProvider cameraActionEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.CameraActionEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCameraActionEventAdapter() {
		if (cameraActionEventItemProvider == null) {
			cameraActionEventItemProvider = new CameraActionEventItemProvider(this);
		}

		return cameraActionEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.MicrophoneActionEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MicrophoneActionEventItemProvider microphoneActionEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.MicrophoneActionEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMicrophoneActionEventAdapter() {
		if (microphoneActionEventItemProvider == null) {
			microphoneActionEventItemProvider = new MicrophoneActionEventItemProvider(this);
		}

		return microphoneActionEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.OtherActionEvent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OtherActionEventItemProvider otherActionEventItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.OtherActionEvent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOtherActionEventAdapter() {
		if (otherActionEventItemProvider == null) {
			otherActionEventItemProvider = new OtherActionEventItemProvider(this);
		}

		return otherActionEventItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.CameraAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CameraActionItemProvider cameraActionItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.CameraAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCameraActionAdapter() {
		if (cameraActionItemProvider == null) {
			cameraActionItemProvider = new CameraActionItemProvider(this);
		}

		return cameraActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.MicrophoneAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MicrophoneActionItemProvider microphoneActionItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.MicrophoneAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMicrophoneActionAdapter() {
		if (microphoneActionItemProvider == null) {
			microphoneActionItemProvider = new MicrophoneActionItemProvider(this);
		}

		return microphoneActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.OtherAction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OtherActionItemProvider otherActionItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.OtherAction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOtherActionAdapter() {
		if (otherActionItemProvider == null) {
			otherActionItemProvider = new OtherActionItemProvider(this);
		}

		return otherActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.ConditionalExpression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConditionalExpressionItemProvider conditionalExpressionItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.ConditionalExpression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConditionalExpressionAdapter() {
		if (conditionalExpressionItemProvider == null) {
			conditionalExpressionItemProvider = new ConditionalExpressionItemProvider(this);
		}

		return conditionalExpressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.StaticContent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StaticContentItemProvider staticContentItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.StaticContent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStaticContentAdapter() {
		if (staticContentItemProvider == null) {
			staticContentItemProvider = new StaticContentItemProvider(this);
		}

		return staticContentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.DynamicBehaviour} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DynamicBehaviourItemProvider dynamicBehaviourItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.DynamicBehaviour}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDynamicBehaviourAdapter() {
		if (dynamicBehaviourItemProvider == null) {
			dynamicBehaviourItemProvider = new DynamicBehaviourItemProvider(this);
		}

		return dynamicBehaviourItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.BehaviourConcept} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BehaviourConceptItemProvider behaviourConceptItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.BehaviourConcept}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBehaviourConceptAdapter() {
		if (behaviourConceptItemProvider == null) {
			behaviourConceptItemProvider = new BehaviourConceptItemProvider(this);
		}

		return behaviourConceptItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.DomainConcept} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DomainConceptItemProvider domainConceptItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.DomainConcept}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDomainConceptAdapter() {
		if (domainConceptItemProvider == null) {
			domainConceptItemProvider = new DomainConceptItemProvider(this);
		}

		return domainConceptItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.FeatureConcept} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FeatureConceptItemProvider featureConceptItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.FeatureConcept}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFeatureConceptAdapter() {
		if (featureConceptItemProvider == null) {
			featureConceptItemProvider = new FeatureConceptItemProvider(this);
		}

		return featureConceptItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link muicm.Attribute} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AttributeItemProvider attributeItemProvider;

	/**
	 * This creates an adapter for a {@link muicm.Attribute}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAttributeAdapter() {
		if (attributeItemProvider == null) {
			attributeItemProvider = new AttributeItemProvider(this);
		}

		return attributeItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (muicmItemProvider != null) muicmItemProvider.dispose();
		if (mInteractionFlowItemProvider != null) mInteractionFlowItemProvider.dispose();
		if (navigationFlowItemProvider != null) navigationFlowItemProvider.dispose();
		if (dataFlowItemProvider != null) dataFlowItemProvider.dispose();
		if (dataBindingGroupItemProvider != null) dataBindingGroupItemProvider.dispose();
		if (dataBindingItemProvider != null) dataBindingItemProvider.dispose();
		if (dataItemProvider != null) dataItemProvider.dispose();
		if (screenItemProvider != null) screenItemProvider.dispose();
		if (mViewComponentItemProvider != null) mViewComponentItemProvider.dispose();
		if (searchViewItemProvider != null) searchViewItemProvider.dispose();
		if (listItemProvider != null) listItemProvider.dispose();
		if (toolBarItemProvider != null) toolBarItemProvider.dispose();
		if (formItemProvider != null) formItemProvider.dispose();
		if (messageItemProvider != null) messageItemProvider.dispose();
		if (detailsItemProvider != null) detailsItemProvider.dispose();
		if (utilityViewItemProvider != null) utilityViewItemProvider.dispose();
		if (simpleFieldItemProvider != null) simpleFieldItemProvider.dispose();
		if (selectionFieldItemProvider != null) selectionFieldItemProvider.dispose();
		if (textBoxItemProvider != null) textBoxItemProvider.dispose();
		if (mediaItemProvider != null) mediaItemProvider.dispose();
		if (labelItemProvider != null) labelItemProvider.dispose();
		if (mapItemProvider != null) mapItemProvider.dispose();
		if (calendarItemProvider != null) calendarItemProvider.dispose();
		if (codeItemProvider != null) codeItemProvider.dispose();
		if (iconItemProvider != null) iconItemProvider.dispose();
		if (mViewComponentPartItemProvider != null) mViewComponentPartItemProvider.dispose();
		if (mViewElementEventItemProvider != null) mViewElementEventItemProvider.dispose();
		if (pinchEventItemProvider != null) pinchEventItemProvider.dispose();
		if (rotateEventItemProvider != null) rotateEventItemProvider.dispose();
		if (tapEventItemProvider != null) tapEventItemProvider.dispose();
		if (systemEventItemProvider != null) systemEventItemProvider.dispose();
		if (panEventItemProvider != null) panEventItemProvider.dispose();
		if (touchEventItemProvider != null) touchEventItemProvider.dispose();
		if (longPressEventItemProvider != null) longPressEventItemProvider.dispose();
		if (swipeEventItemProvider != null) swipeEventItemProvider.dispose();
		if (cameraActionEventItemProvider != null) cameraActionEventItemProvider.dispose();
		if (microphoneActionEventItemProvider != null) microphoneActionEventItemProvider.dispose();
		if (otherActionEventItemProvider != null) otherActionEventItemProvider.dispose();
		if (cameraActionItemProvider != null) cameraActionItemProvider.dispose();
		if (microphoneActionItemProvider != null) microphoneActionItemProvider.dispose();
		if (otherActionItemProvider != null) otherActionItemProvider.dispose();
		if (conditionalExpressionItemProvider != null) conditionalExpressionItemProvider.dispose();
		if (staticContentItemProvider != null) staticContentItemProvider.dispose();
		if (dynamicBehaviourItemProvider != null) dynamicBehaviourItemProvider.dispose();
		if (behaviourConceptItemProvider != null) behaviourConceptItemProvider.dispose();
		if (domainConceptItemProvider != null) domainConceptItemProvider.dispose();
		if (featureConceptItemProvider != null) featureConceptItemProvider.dispose();
		if (attributeItemProvider != null) attributeItemProvider.dispose();
	}

}
