/**
 */
package muicm.provider;


import java.util.Collection;
import java.util.List;

import muicm.MuicmFactory;
import muicm.MuicmPackage;
import muicm.Screen;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link muicm.Screen} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ScreenItemProvider extends MViewElementItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScreenItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addIsModalPropertyDescriptor(object);
			addHasNavPropertyDescriptor(object);
			addIsHomePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Is Modal feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIsModalPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Screen_isModal_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Screen_isModal_feature", "_UI_Screen_type"),
				 MuicmPackage.Literals.SCREEN__IS_MODAL,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Has Nav feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addHasNavPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Screen_HasNav_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Screen_HasNav_feature", "_UI_Screen_type"),
				 MuicmPackage.Literals.SCREEN__HAS_NAV,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Is Home feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIsHomePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Screen_isHome_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Screen_isHome_feature", "_UI_Screen_type"),
				 MuicmPackage.Literals.SCREEN__IS_HOME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Screen.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Screen"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((Screen)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_Screen_type") :
			getString("_UI_Screen_type") + " " + label;
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Screen.class)) {
			case MuicmPackage.SCREEN__IS_MODAL:
			case MuicmPackage.SCREEN__HAS_NAV:
			case MuicmPackage.SCREEN__IS_HOME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case MuicmPackage.SCREEN__MVIEW_ELEMENTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createScreen()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createMViewComponent()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createSearchView()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createList()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createToolBar()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createForm()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createMessage()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createDetails()));

		newChildDescriptors.add
			(createChildParameter
				(MuicmPackage.Literals.SCREEN__MVIEW_ELEMENTS,
				 MuicmFactory.eINSTANCE.createUtilityView()));
	}

}
