/**
 */
package muicm.impl;

import muicm.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MuicmFactoryImpl extends EFactoryImpl implements MuicmFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static MuicmFactory init() {
		try {
			MuicmFactory theMuicmFactory = (MuicmFactory)EPackage.Registry.INSTANCE.getEFactory(MuicmPackage.eNS_URI);
			if (theMuicmFactory != null) {
				return theMuicmFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new MuicmFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MuicmFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case MuicmPackage.MUICM: return createMUICM();
			case MuicmPackage.MINTERACTION_FLOW: return createMInteractionFlow();
			case MuicmPackage.NAVIGATION_FLOW: return createNavigationFlow();
			case MuicmPackage.DATA_FLOW: return createDataFlow();
			case MuicmPackage.DATA_BINDING_GROUP: return createDataBindingGroup();
			case MuicmPackage.DATA_BINDING: return createDataBinding();
			case MuicmPackage.DATA: return createData();
			case MuicmPackage.SCREEN: return createScreen();
			case MuicmPackage.MVIEW_COMPONENT: return createMViewComponent();
			case MuicmPackage.SEARCH_VIEW: return createSearchView();
			case MuicmPackage.LIST: return createList();
			case MuicmPackage.TOOL_BAR: return createToolBar();
			case MuicmPackage.FORM: return createForm();
			case MuicmPackage.MESSAGE: return createMessage();
			case MuicmPackage.DETAILS: return createDetails();
			case MuicmPackage.UTILITY_VIEW: return createUtilityView();
			case MuicmPackage.SIMPLE_FIELD: return createSimpleField();
			case MuicmPackage.SELECTION_FIELD: return createSelectionField();
			case MuicmPackage.TEXT_BOX: return createTextBox();
			case MuicmPackage.MEDIA: return createMedia();
			case MuicmPackage.LABEL: return createLabel();
			case MuicmPackage.MAP: return createMap();
			case MuicmPackage.CALENDAR: return createCalendar();
			case MuicmPackage.CODE: return createCode();
			case MuicmPackage.ICON: return createIcon();
			case MuicmPackage.MVIEW_COMPONENT_PART: return createMViewComponentPart();
			case MuicmPackage.MVIEW_ELEMENT_EVENT: return createMViewElementEvent();
			case MuicmPackage.PINCH_EVENT: return createPinchEvent();
			case MuicmPackage.ROTATE_EVENT: return createRotateEvent();
			case MuicmPackage.TAP_EVENT: return createTapEvent();
			case MuicmPackage.SYSTEM_EVENT: return createSystemEvent();
			case MuicmPackage.PAN_EVENT: return createPanEvent();
			case MuicmPackage.TOUCH_EVENT: return createTouchEvent();
			case MuicmPackage.LONG_PRESS_EVENT: return createLongPressEvent();
			case MuicmPackage.SWIPE_EVENT: return createSwipeEvent();
			case MuicmPackage.CAMERA_ACTION_EVENT: return createCameraActionEvent();
			case MuicmPackage.MICROPHONE_ACTION_EVENT: return createMicrophoneActionEvent();
			case MuicmPackage.OTHER_ACTION_EVENT: return createOtherActionEvent();
			case MuicmPackage.CAMERA_ACTION: return createCameraAction();
			case MuicmPackage.MICROPHONE_ACTION: return createMicrophoneAction();
			case MuicmPackage.OTHER_ACTION: return createOtherAction();
			case MuicmPackage.CONDITIONAL_EXPRESSION: return createConditionalExpression();
			case MuicmPackage.STATIC_CONTENT: return createStaticContent();
			case MuicmPackage.DYNAMIC_BEHAVIOUR: return createDynamicBehaviour();
			case MuicmPackage.BEHAVIOUR_CONCEPT: return createBehaviourConcept();
			case MuicmPackage.DOMAIN_CONCEPT: return createDomainConcept();
			case MuicmPackage.FEATURE_CONCEPT: return createFeatureConcept();
			case MuicmPackage.ATTRIBUTE: return createAttribute();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case MuicmPackage.DATA_TYPE:
				return createDataTypeFromString(eDataType, initialValue);
			case MuicmPackage.MEIDA_TYPE:
				return createMeidaTypeFromString(eDataType, initialValue);
			case MuicmPackage.SWIPE_DIRECTION:
				return createSwipeDirectionFromString(eDataType, initialValue);
			case MuicmPackage.CODE_TYPE:
				return createCodeTypeFromString(eDataType, initialValue);
			case MuicmPackage.EVENT_TYPE:
				return createEventTypeFromString(eDataType, initialValue);
			case MuicmPackage.DIR_TYPE:
				return createDirTypeFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case MuicmPackage.DATA_TYPE:
				return convertDataTypeToString(eDataType, instanceValue);
			case MuicmPackage.MEIDA_TYPE:
				return convertMeidaTypeToString(eDataType, instanceValue);
			case MuicmPackage.SWIPE_DIRECTION:
				return convertSwipeDirectionToString(eDataType, instanceValue);
			case MuicmPackage.CODE_TYPE:
				return convertCodeTypeToString(eDataType, instanceValue);
			case MuicmPackage.EVENT_TYPE:
				return convertEventTypeToString(eDataType, instanceValue);
			case MuicmPackage.DIR_TYPE:
				return convertDirTypeToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MUICM createMUICM() {
		MUICMImpl muicm = new MUICMImpl();
		return muicm;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MInteractionFlow createMInteractionFlow() {
		MInteractionFlowImpl mInteractionFlow = new MInteractionFlowImpl();
		return mInteractionFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NavigationFlow createNavigationFlow() {
		NavigationFlowImpl navigationFlow = new NavigationFlowImpl();
		return navigationFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlow createDataFlow() {
		DataFlowImpl dataFlow = new DataFlowImpl();
		return dataFlow;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataBindingGroup createDataBindingGroup() {
		DataBindingGroupImpl dataBindingGroup = new DataBindingGroupImpl();
		return dataBindingGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataBinding createDataBinding() {
		DataBindingImpl dataBinding = new DataBindingImpl();
		return dataBinding;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Data createData() {
		DataImpl data = new DataImpl();
		return data;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Screen createScreen() {
		ScreenImpl screen = new ScreenImpl();
		return screen;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MViewComponent createMViewComponent() {
		MViewComponentImpl mViewComponent = new MViewComponentImpl();
		return mViewComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SearchView createSearchView() {
		SearchViewImpl searchView = new SearchViewImpl();
		return searchView;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List createList() {
		ListImpl list = new ListImpl();
		return list;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToolBar createToolBar() {
		ToolBarImpl toolBar = new ToolBarImpl();
		return toolBar;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Form createForm() {
		FormImpl form = new FormImpl();
		return form;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Message createMessage() {
		MessageImpl message = new MessageImpl();
		return message;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Details createDetails() {
		DetailsImpl details = new DetailsImpl();
		return details;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UtilityView createUtilityView() {
		UtilityViewImpl utilityView = new UtilityViewImpl();
		return utilityView;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleField createSimpleField() {
		SimpleFieldImpl simpleField = new SimpleFieldImpl();
		return simpleField;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SelectionField createSelectionField() {
		SelectionFieldImpl selectionField = new SelectionFieldImpl();
		return selectionField;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TextBox createTextBox() {
		TextBoxImpl textBox = new TextBoxImpl();
		return textBox;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Media createMedia() {
		MediaImpl media = new MediaImpl();
		return media;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Label createLabel() {
		LabelImpl label = new LabelImpl();
		return label;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Map createMap() {
		MapImpl map = new MapImpl();
		return map;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Calendar createCalendar() {
		CalendarImpl calendar = new CalendarImpl();
		return calendar;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Code createCode() {
		CodeImpl code = new CodeImpl();
		return code;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Icon createIcon() {
		IconImpl icon = new IconImpl();
		return icon;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MViewComponentPart createMViewComponentPart() {
		MViewComponentPartImpl mViewComponentPart = new MViewComponentPartImpl();
		return mViewComponentPart;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MViewElementEvent createMViewElementEvent() {
		MViewElementEventImpl mViewElementEvent = new MViewElementEventImpl();
		return mViewElementEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PinchEvent createPinchEvent() {
		PinchEventImpl pinchEvent = new PinchEventImpl();
		return pinchEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RotateEvent createRotateEvent() {
		RotateEventImpl rotateEvent = new RotateEventImpl();
		return rotateEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TapEvent createTapEvent() {
		TapEventImpl tapEvent = new TapEventImpl();
		return tapEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SystemEvent createSystemEvent() {
		SystemEventImpl systemEvent = new SystemEventImpl();
		return systemEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PanEvent createPanEvent() {
		PanEventImpl panEvent = new PanEventImpl();
		return panEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TouchEvent createTouchEvent() {
		TouchEventImpl touchEvent = new TouchEventImpl();
		return touchEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LongPressEvent createLongPressEvent() {
		LongPressEventImpl longPressEvent = new LongPressEventImpl();
		return longPressEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SwipeEvent createSwipeEvent() {
		SwipeEventImpl swipeEvent = new SwipeEventImpl();
		return swipeEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CameraActionEvent createCameraActionEvent() {
		CameraActionEventImpl cameraActionEvent = new CameraActionEventImpl();
		return cameraActionEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MicrophoneActionEvent createMicrophoneActionEvent() {
		MicrophoneActionEventImpl microphoneActionEvent = new MicrophoneActionEventImpl();
		return microphoneActionEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OtherActionEvent createOtherActionEvent() {
		OtherActionEventImpl otherActionEvent = new OtherActionEventImpl();
		return otherActionEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CameraAction createCameraAction() {
		CameraActionImpl cameraAction = new CameraActionImpl();
		return cameraAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MicrophoneAction createMicrophoneAction() {
		MicrophoneActionImpl microphoneAction = new MicrophoneActionImpl();
		return microphoneAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OtherAction createOtherAction() {
		OtherActionImpl otherAction = new OtherActionImpl();
		return otherAction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConditionalExpression createConditionalExpression() {
		ConditionalExpressionImpl conditionalExpression = new ConditionalExpressionImpl();
		return conditionalExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StaticContent createStaticContent() {
		StaticContentImpl staticContent = new StaticContentImpl();
		return staticContent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DynamicBehaviour createDynamicBehaviour() {
		DynamicBehaviourImpl dynamicBehaviour = new DynamicBehaviourImpl();
		return dynamicBehaviour;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BehaviourConcept createBehaviourConcept() {
		BehaviourConceptImpl behaviourConcept = new BehaviourConceptImpl();
		return behaviourConcept;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DomainConcept createDomainConcept() {
		DomainConceptImpl domainConcept = new DomainConceptImpl();
		return domainConcept;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureConcept createFeatureConcept() {
		FeatureConceptImpl featureConcept = new FeatureConceptImpl();
		return featureConcept;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Attribute createAttribute() {
		AttributeImpl attribute = new AttributeImpl();
		return attribute;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataType createDataTypeFromString(EDataType eDataType, String initialValue) {
		DataType result = DataType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertDataTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MeidaType createMeidaTypeFromString(EDataType eDataType, String initialValue) {
		MeidaType result = MeidaType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertMeidaTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SwipeDirection createSwipeDirectionFromString(EDataType eDataType, String initialValue) {
		SwipeDirection result = SwipeDirection.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertSwipeDirectionToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CodeType createCodeTypeFromString(EDataType eDataType, String initialValue) {
		CodeType result = CodeType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertCodeTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventType createEventTypeFromString(EDataType eDataType, String initialValue) {
		EventType result = EventType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertEventTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DirType createDirTypeFromString(EDataType eDataType, String initialValue) {
		DirType result = DirType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertDirTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MuicmPackage getMuicmPackage() {
		return (MuicmPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static MuicmPackage getPackage() {
		return MuicmPackage.eINSTANCE;
	}

} //MuicmFactoryImpl
