/**
 */
package muicm.util;

import muicm.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see muicm.MuicmPackage
 * @generated
 */
public class MuicmAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static MuicmPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MuicmAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = MuicmPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MuicmSwitch<Adapter> modelSwitch =
		new MuicmSwitch<Adapter>() {
			@Override
			public Adapter caseMUICM(MUICM object) {
				return createMUICMAdapter();
			}
			@Override
			public Adapter caseMUICMElement(MUICMElement object) {
				return createMUICMElementAdapter();
			}
			@Override
			public Adapter caseMInteractionFlow(MInteractionFlow object) {
				return createMInteractionFlowAdapter();
			}
			@Override
			public Adapter caseNavigationFlow(NavigationFlow object) {
				return createNavigationFlowAdapter();
			}
			@Override
			public Adapter caseDataFlow(DataFlow object) {
				return createDataFlowAdapter();
			}
			@Override
			public Adapter caseMInteractionElement(MInteractionElement object) {
				return createMInteractionElementAdapter();
			}
			@Override
			public Adapter caseDataBindingGroup(DataBindingGroup object) {
				return createDataBindingGroupAdapter();
			}
			@Override
			public Adapter caseDataBinding(DataBinding object) {
				return createDataBindingAdapter();
			}
			@Override
			public Adapter caseData(Data object) {
				return createDataAdapter();
			}
			@Override
			public Adapter caseMViewElement(MViewElement object) {
				return createMViewElementAdapter();
			}
			@Override
			public Adapter caseScreen(Screen object) {
				return createScreenAdapter();
			}
			@Override
			public Adapter caseMviewComponentExt(MviewComponentExt object) {
				return createMviewComponentExtAdapter();
			}
			@Override
			public Adapter caseMViewComponent(MViewComponent object) {
				return createMViewComponentAdapter();
			}
			@Override
			public Adapter caseSearchView(SearchView object) {
				return createSearchViewAdapter();
			}
			@Override
			public Adapter caseList(List object) {
				return createListAdapter();
			}
			@Override
			public Adapter caseToolBar(ToolBar object) {
				return createToolBarAdapter();
			}
			@Override
			public Adapter caseForm(Form object) {
				return createFormAdapter();
			}
			@Override
			public Adapter caseMessage(Message object) {
				return createMessageAdapter();
			}
			@Override
			public Adapter caseDetails(Details object) {
				return createDetailsAdapter();
			}
			@Override
			public Adapter caseUtilityView(UtilityView object) {
				return createUtilityViewAdapter();
			}
			@Override
			public Adapter caseMViewComponentPartAbstract(MViewComponentPartAbstract object) {
				return createMViewComponentPartAbstractAdapter();
			}
			@Override
			public Adapter caseField(Field object) {
				return createFieldAdapter();
			}
			@Override
			public Adapter caseSimpleField(SimpleField object) {
				return createSimpleFieldAdapter();
			}
			@Override
			public Adapter caseSelectionField(SelectionField object) {
				return createSelectionFieldAdapter();
			}
			@Override
			public Adapter caseTextBox(TextBox object) {
				return createTextBoxAdapter();
			}
			@Override
			public Adapter caseMedia(Media object) {
				return createMediaAdapter();
			}
			@Override
			public Adapter caseLabel(Label object) {
				return createLabelAdapter();
			}
			@Override
			public Adapter caseMAction(MAction object) {
				return createMActionAdapter();
			}
			@Override
			public Adapter caseUtility(Utility object) {
				return createUtilityAdapter();
			}
			@Override
			public Adapter caseMap(Map object) {
				return createMapAdapter();
			}
			@Override
			public Adapter caseCalendar(Calendar object) {
				return createCalendarAdapter();
			}
			@Override
			public Adapter caseCode(Code object) {
				return createCodeAdapter();
			}
			@Override
			public Adapter caseIcon(Icon object) {
				return createIconAdapter();
			}
			@Override
			public Adapter caseContentBinding(ContentBinding object) {
				return createContentBindingAdapter();
			}
			@Override
			public Adapter caseMEvent(MEvent object) {
				return createMEventAdapter();
			}
			@Override
			public Adapter caseMViewElementEventAbstract(MViewElementEventAbstract object) {
				return createMViewElementEventAbstractAdapter();
			}
			@Override
			public Adapter caseMViewComponentPart(MViewComponentPart object) {
				return createMViewComponentPartAdapter();
			}
			@Override
			public Adapter caseMViewElementEvent(MViewElementEvent object) {
				return createMViewElementEventAdapter();
			}
			@Override
			public Adapter casePinchEvent(PinchEvent object) {
				return createPinchEventAdapter();
			}
			@Override
			public Adapter caseRotateEvent(RotateEvent object) {
				return createRotateEventAdapter();
			}
			@Override
			public Adapter caseTapEvent(TapEvent object) {
				return createTapEventAdapter();
			}
			@Override
			public Adapter caseSystemEvent(SystemEvent object) {
				return createSystemEventAdapter();
			}
			@Override
			public Adapter casePanEvent(PanEvent object) {
				return createPanEventAdapter();
			}
			@Override
			public Adapter caseTouchEvent(TouchEvent object) {
				return createTouchEventAdapter();
			}
			@Override
			public Adapter caseLongPressEvent(LongPressEvent object) {
				return createLongPressEventAdapter();
			}
			@Override
			public Adapter caseSwipeEvent(SwipeEvent object) {
				return createSwipeEventAdapter();
			}
			@Override
			public Adapter caseMActionEvent(MActionEvent object) {
				return createMActionEventAdapter();
			}
			@Override
			public Adapter caseCameraActionEvent(CameraActionEvent object) {
				return createCameraActionEventAdapter();
			}
			@Override
			public Adapter caseMicrophoneActionEvent(MicrophoneActionEvent object) {
				return createMicrophoneActionEventAdapter();
			}
			@Override
			public Adapter caseOtherActionEvent(OtherActionEvent object) {
				return createOtherActionEventAdapter();
			}
			@Override
			public Adapter caseMExpression(MExpression object) {
				return createMExpressionAdapter();
			}
			@Override
			public Adapter caseCameraAction(CameraAction object) {
				return createCameraActionAdapter();
			}
			@Override
			public Adapter caseMicrophoneAction(MicrophoneAction object) {
				return createMicrophoneActionAdapter();
			}
			@Override
			public Adapter caseOtherAction(OtherAction object) {
				return createOtherActionAdapter();
			}
			@Override
			public Adapter caseConditionalExpression(ConditionalExpression object) {
				return createConditionalExpressionAdapter();
			}
			@Override
			public Adapter caseStaticContent(StaticContent object) {
				return createStaticContentAdapter();
			}
			@Override
			public Adapter caseDynamicBehaviour(DynamicBehaviour object) {
				return createDynamicBehaviourAdapter();
			}
			@Override
			public Adapter caseContentModel(ContentModel object) {
				return createContentModelAdapter();
			}
			@Override
			public Adapter caseContentElement(ContentElement object) {
				return createContentElementAdapter();
			}
			@Override
			public Adapter caseBehaviourConcept(BehaviourConcept object) {
				return createBehaviourConceptAdapter();
			}
			@Override
			public Adapter caseDomainConcept(DomainConcept object) {
				return createDomainConceptAdapter();
			}
			@Override
			public Adapter caseFeatureConcept(FeatureConcept object) {
				return createFeatureConceptAdapter();
			}
			@Override
			public Adapter caseAttribute(Attribute object) {
				return createAttributeAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link muicm.MUICM <em>MUICM</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MUICM
	 * @generated
	 */
	public Adapter createMUICMAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MUICMElement <em>MUICM Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MUICMElement
	 * @generated
	 */
	public Adapter createMUICMElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MInteractionFlow <em>MInteraction Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MInteractionFlow
	 * @generated
	 */
	public Adapter createMInteractionFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.NavigationFlow <em>Navigation Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.NavigationFlow
	 * @generated
	 */
	public Adapter createNavigationFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.DataFlow <em>Data Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.DataFlow
	 * @generated
	 */
	public Adapter createDataFlowAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MInteractionElement <em>MInteraction Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MInteractionElement
	 * @generated
	 */
	public Adapter createMInteractionElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.DataBindingGroup <em>Data Binding Group</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.DataBindingGroup
	 * @generated
	 */
	public Adapter createDataBindingGroupAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.DataBinding <em>Data Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.DataBinding
	 * @generated
	 */
	public Adapter createDataBindingAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Data <em>Data</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Data
	 * @generated
	 */
	public Adapter createDataAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MViewElement <em>MView Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MViewElement
	 * @generated
	 */
	public Adapter createMViewElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Screen <em>Screen</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Screen
	 * @generated
	 */
	public Adapter createScreenAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MviewComponentExt <em>Mview Component Ext</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MviewComponentExt
	 * @generated
	 */
	public Adapter createMviewComponentExtAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MViewComponent <em>MView Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MViewComponent
	 * @generated
	 */
	public Adapter createMViewComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.SearchView <em>Search View</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.SearchView
	 * @generated
	 */
	public Adapter createSearchViewAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.List <em>List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.List
	 * @generated
	 */
	public Adapter createListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.ToolBar <em>Tool Bar</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.ToolBar
	 * @generated
	 */
	public Adapter createToolBarAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Form <em>Form</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Form
	 * @generated
	 */
	public Adapter createFormAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Message <em>Message</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Message
	 * @generated
	 */
	public Adapter createMessageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Details <em>Details</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Details
	 * @generated
	 */
	public Adapter createDetailsAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.UtilityView <em>Utility View</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.UtilityView
	 * @generated
	 */
	public Adapter createUtilityViewAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MViewComponentPartAbstract <em>MView Component Part Abstract</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MViewComponentPartAbstract
	 * @generated
	 */
	public Adapter createMViewComponentPartAbstractAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Field <em>Field</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Field
	 * @generated
	 */
	public Adapter createFieldAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.SimpleField <em>Simple Field</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.SimpleField
	 * @generated
	 */
	public Adapter createSimpleFieldAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.SelectionField <em>Selection Field</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.SelectionField
	 * @generated
	 */
	public Adapter createSelectionFieldAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.TextBox <em>Text Box</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.TextBox
	 * @generated
	 */
	public Adapter createTextBoxAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Media <em>Media</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Media
	 * @generated
	 */
	public Adapter createMediaAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Label <em>Label</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Label
	 * @generated
	 */
	public Adapter createLabelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MAction <em>MAction</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MAction
	 * @generated
	 */
	public Adapter createMActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Utility <em>Utility</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Utility
	 * @generated
	 */
	public Adapter createUtilityAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Map <em>Map</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Map
	 * @generated
	 */
	public Adapter createMapAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Calendar <em>Calendar</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Calendar
	 * @generated
	 */
	public Adapter createCalendarAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Code <em>Code</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Code
	 * @generated
	 */
	public Adapter createCodeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Icon <em>Icon</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Icon
	 * @generated
	 */
	public Adapter createIconAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.ContentBinding <em>Content Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.ContentBinding
	 * @generated
	 */
	public Adapter createContentBindingAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MEvent <em>MEvent</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MEvent
	 * @generated
	 */
	public Adapter createMEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MViewElementEventAbstract <em>MView Element Event Abstract</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MViewElementEventAbstract
	 * @generated
	 */
	public Adapter createMViewElementEventAbstractAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MViewComponentPart <em>MView Component Part</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MViewComponentPart
	 * @generated
	 */
	public Adapter createMViewComponentPartAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MViewElementEvent <em>MView Element Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MViewElementEvent
	 * @generated
	 */
	public Adapter createMViewElementEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.PinchEvent <em>Pinch Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.PinchEvent
	 * @generated
	 */
	public Adapter createPinchEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.RotateEvent <em>Rotate Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.RotateEvent
	 * @generated
	 */
	public Adapter createRotateEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.TapEvent <em>Tap Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.TapEvent
	 * @generated
	 */
	public Adapter createTapEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.SystemEvent <em>System Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.SystemEvent
	 * @generated
	 */
	public Adapter createSystemEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.PanEvent <em>Pan Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.PanEvent
	 * @generated
	 */
	public Adapter createPanEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.TouchEvent <em>Touch Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.TouchEvent
	 * @generated
	 */
	public Adapter createTouchEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.LongPressEvent <em>Long Press Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.LongPressEvent
	 * @generated
	 */
	public Adapter createLongPressEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.SwipeEvent <em>Swipe Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.SwipeEvent
	 * @generated
	 */
	public Adapter createSwipeEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MActionEvent <em>MAction Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MActionEvent
	 * @generated
	 */
	public Adapter createMActionEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.CameraActionEvent <em>Camera Action Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.CameraActionEvent
	 * @generated
	 */
	public Adapter createCameraActionEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MicrophoneActionEvent <em>Microphone Action Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MicrophoneActionEvent
	 * @generated
	 */
	public Adapter createMicrophoneActionEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.OtherActionEvent <em>Other Action Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.OtherActionEvent
	 * @generated
	 */
	public Adapter createOtherActionEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MExpression <em>MExpression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MExpression
	 * @generated
	 */
	public Adapter createMExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.CameraAction <em>Camera Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.CameraAction
	 * @generated
	 */
	public Adapter createCameraActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.MicrophoneAction <em>Microphone Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.MicrophoneAction
	 * @generated
	 */
	public Adapter createMicrophoneActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.OtherAction <em>Other Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.OtherAction
	 * @generated
	 */
	public Adapter createOtherActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.ConditionalExpression <em>Conditional Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.ConditionalExpression
	 * @generated
	 */
	public Adapter createConditionalExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.StaticContent <em>Static Content</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.StaticContent
	 * @generated
	 */
	public Adapter createStaticContentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.DynamicBehaviour <em>Dynamic Behaviour</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.DynamicBehaviour
	 * @generated
	 */
	public Adapter createDynamicBehaviourAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.ContentModel <em>Content Model</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.ContentModel
	 * @generated
	 */
	public Adapter createContentModelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.ContentElement <em>Content Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.ContentElement
	 * @generated
	 */
	public Adapter createContentElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.BehaviourConcept <em>Behaviour Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.BehaviourConcept
	 * @generated
	 */
	public Adapter createBehaviourConceptAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.DomainConcept <em>Domain Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.DomainConcept
	 * @generated
	 */
	public Adapter createDomainConceptAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.FeatureConcept <em>Feature Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.FeatureConcept
	 * @generated
	 */
	public Adapter createFeatureConceptAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link muicm.Attribute <em>Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see muicm.Attribute
	 * @generated
	 */
	public Adapter createAttributeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //MuicmAdapterFactory
