/**
 */
package muicm.util;

import muicm.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see muicm.MuicmPackage
 * @generated
 */
public class MuicmSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static MuicmPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MuicmSwitch() {
		if (modelPackage == null) {
			modelPackage = MuicmPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case MuicmPackage.MUICM: {
				MUICM muicm = (MUICM)theEObject;
				T result = caseMUICM(muicm);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MUICM_ELEMENT: {
				MUICMElement muicmElement = (MUICMElement)theEObject;
				T result = caseMUICMElement(muicmElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MINTERACTION_FLOW: {
				MInteractionFlow mInteractionFlow = (MInteractionFlow)theEObject;
				T result = caseMInteractionFlow(mInteractionFlow);
				if (result == null) result = caseMUICMElement(mInteractionFlow);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.NAVIGATION_FLOW: {
				NavigationFlow navigationFlow = (NavigationFlow)theEObject;
				T result = caseNavigationFlow(navigationFlow);
				if (result == null) result = caseMInteractionFlow(navigationFlow);
				if (result == null) result = caseMUICMElement(navigationFlow);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.DATA_FLOW: {
				DataFlow dataFlow = (DataFlow)theEObject;
				T result = caseDataFlow(dataFlow);
				if (result == null) result = caseMInteractionFlow(dataFlow);
				if (result == null) result = caseMUICMElement(dataFlow);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MINTERACTION_ELEMENT: {
				MInteractionElement mInteractionElement = (MInteractionElement)theEObject;
				T result = caseMInteractionElement(mInteractionElement);
				if (result == null) result = caseMUICMElement(mInteractionElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.DATA_BINDING_GROUP: {
				DataBindingGroup dataBindingGroup = (DataBindingGroup)theEObject;
				T result = caseDataBindingGroup(dataBindingGroup);
				if (result == null) result = caseMUICMElement(dataBindingGroup);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.DATA_BINDING: {
				DataBinding dataBinding = (DataBinding)theEObject;
				T result = caseDataBinding(dataBinding);
				if (result == null) result = caseMUICMElement(dataBinding);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.DATA: {
				Data data = (Data)theEObject;
				T result = caseData(data);
				if (result == null) result = caseMUICMElement(data);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MVIEW_ELEMENT: {
				MViewElement mViewElement = (MViewElement)theEObject;
				T result = caseMViewElement(mViewElement);
				if (result == null) result = caseMInteractionElement(mViewElement);
				if (result == null) result = caseMUICMElement(mViewElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.SCREEN: {
				Screen screen = (Screen)theEObject;
				T result = caseScreen(screen);
				if (result == null) result = caseMViewElement(screen);
				if (result == null) result = caseMInteractionElement(screen);
				if (result == null) result = caseMUICMElement(screen);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MVIEW_COMPONENT_EXT: {
				MviewComponentExt mviewComponentExt = (MviewComponentExt)theEObject;
				T result = caseMviewComponentExt(mviewComponentExt);
				if (result == null) result = caseMViewElement(mviewComponentExt);
				if (result == null) result = caseMInteractionElement(mviewComponentExt);
				if (result == null) result = caseMUICMElement(mviewComponentExt);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MVIEW_COMPONENT: {
				MViewComponent mViewComponent = (MViewComponent)theEObject;
				T result = caseMViewComponent(mViewComponent);
				if (result == null) result = caseMViewElement(mViewComponent);
				if (result == null) result = caseMInteractionElement(mViewComponent);
				if (result == null) result = caseMUICMElement(mViewComponent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.SEARCH_VIEW: {
				SearchView searchView = (SearchView)theEObject;
				T result = caseSearchView(searchView);
				if (result == null) result = caseMviewComponentExt(searchView);
				if (result == null) result = caseMViewElement(searchView);
				if (result == null) result = caseMInteractionElement(searchView);
				if (result == null) result = caseMUICMElement(searchView);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.LIST: {
				List list = (List)theEObject;
				T result = caseList(list);
				if (result == null) result = caseMviewComponentExt(list);
				if (result == null) result = caseMViewElement(list);
				if (result == null) result = caseMInteractionElement(list);
				if (result == null) result = caseMUICMElement(list);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.TOOL_BAR: {
				ToolBar toolBar = (ToolBar)theEObject;
				T result = caseToolBar(toolBar);
				if (result == null) result = caseMviewComponentExt(toolBar);
				if (result == null) result = caseMViewElement(toolBar);
				if (result == null) result = caseMInteractionElement(toolBar);
				if (result == null) result = caseMUICMElement(toolBar);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.FORM: {
				Form form = (Form)theEObject;
				T result = caseForm(form);
				if (result == null) result = caseMviewComponentExt(form);
				if (result == null) result = caseMViewElement(form);
				if (result == null) result = caseMInteractionElement(form);
				if (result == null) result = caseMUICMElement(form);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MESSAGE: {
				Message message = (Message)theEObject;
				T result = caseMessage(message);
				if (result == null) result = caseMviewComponentExt(message);
				if (result == null) result = caseMViewElement(message);
				if (result == null) result = caseMInteractionElement(message);
				if (result == null) result = caseMUICMElement(message);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.DETAILS: {
				Details details = (Details)theEObject;
				T result = caseDetails(details);
				if (result == null) result = caseMviewComponentExt(details);
				if (result == null) result = caseMViewElement(details);
				if (result == null) result = caseMInteractionElement(details);
				if (result == null) result = caseMUICMElement(details);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.UTILITY_VIEW: {
				UtilityView utilityView = (UtilityView)theEObject;
				T result = caseUtilityView(utilityView);
				if (result == null) result = caseMviewComponentExt(utilityView);
				if (result == null) result = caseMViewElement(utilityView);
				if (result == null) result = caseMInteractionElement(utilityView);
				if (result == null) result = caseMUICMElement(utilityView);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MVIEW_COMPONENT_PART_ABSTRACT: {
				MViewComponentPartAbstract mViewComponentPartAbstract = (MViewComponentPartAbstract)theEObject;
				T result = caseMViewComponentPartAbstract(mViewComponentPartAbstract);
				if (result == null) result = caseMInteractionElement(mViewComponentPartAbstract);
				if (result == null) result = caseMUICMElement(mViewComponentPartAbstract);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.FIELD: {
				Field field = (Field)theEObject;
				T result = caseField(field);
				if (result == null) result = caseMViewComponentPartAbstract(field);
				if (result == null) result = caseMInteractionElement(field);
				if (result == null) result = caseMUICMElement(field);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.SIMPLE_FIELD: {
				SimpleField simpleField = (SimpleField)theEObject;
				T result = caseSimpleField(simpleField);
				if (result == null) result = caseField(simpleField);
				if (result == null) result = caseMViewComponentPartAbstract(simpleField);
				if (result == null) result = caseMInteractionElement(simpleField);
				if (result == null) result = caseMUICMElement(simpleField);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.SELECTION_FIELD: {
				SelectionField selectionField = (SelectionField)theEObject;
				T result = caseSelectionField(selectionField);
				if (result == null) result = caseField(selectionField);
				if (result == null) result = caseMViewComponentPartAbstract(selectionField);
				if (result == null) result = caseMInteractionElement(selectionField);
				if (result == null) result = caseMUICMElement(selectionField);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.TEXT_BOX: {
				TextBox textBox = (TextBox)theEObject;
				T result = caseTextBox(textBox);
				if (result == null) result = caseMViewComponentPartAbstract(textBox);
				if (result == null) result = caseMInteractionElement(textBox);
				if (result == null) result = caseMUICMElement(textBox);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MEDIA: {
				Media media = (Media)theEObject;
				T result = caseMedia(media);
				if (result == null) result = caseMViewComponentPartAbstract(media);
				if (result == null) result = caseMInteractionElement(media);
				if (result == null) result = caseMUICMElement(media);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.LABEL: {
				Label label = (Label)theEObject;
				T result = caseLabel(label);
				if (result == null) result = caseMViewComponentPartAbstract(label);
				if (result == null) result = caseMInteractionElement(label);
				if (result == null) result = caseMUICMElement(label);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MACTION: {
				MAction mAction = (MAction)theEObject;
				T result = caseMAction(mAction);
				if (result == null) result = caseMInteractionElement(mAction);
				if (result == null) result = caseMUICMElement(mAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.UTILITY: {
				Utility utility = (Utility)theEObject;
				T result = caseUtility(utility);
				if (result == null) result = caseMViewComponentPartAbstract(utility);
				if (result == null) result = caseMInteractionElement(utility);
				if (result == null) result = caseMUICMElement(utility);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MAP: {
				Map map = (Map)theEObject;
				T result = caseMap(map);
				if (result == null) result = caseUtility(map);
				if (result == null) result = caseMViewComponentPartAbstract(map);
				if (result == null) result = caseMInteractionElement(map);
				if (result == null) result = caseMUICMElement(map);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CALENDAR: {
				Calendar calendar = (Calendar)theEObject;
				T result = caseCalendar(calendar);
				if (result == null) result = caseUtility(calendar);
				if (result == null) result = caseMViewComponentPartAbstract(calendar);
				if (result == null) result = caseMInteractionElement(calendar);
				if (result == null) result = caseMUICMElement(calendar);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CODE: {
				Code code = (Code)theEObject;
				T result = caseCode(code);
				if (result == null) result = caseUtility(code);
				if (result == null) result = caseMViewComponentPartAbstract(code);
				if (result == null) result = caseMInteractionElement(code);
				if (result == null) result = caseMUICMElement(code);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.ICON: {
				Icon icon = (Icon)theEObject;
				T result = caseIcon(icon);
				if (result == null) result = caseMViewComponentPartAbstract(icon);
				if (result == null) result = caseMInteractionElement(icon);
				if (result == null) result = caseMUICMElement(icon);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CONTENT_BINDING: {
				ContentBinding contentBinding = (ContentBinding)theEObject;
				T result = caseContentBinding(contentBinding);
				if (result == null) result = caseMViewComponentPartAbstract(contentBinding);
				if (result == null) result = caseMInteractionElement(contentBinding);
				if (result == null) result = caseMUICMElement(contentBinding);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MEVENT: {
				MEvent mEvent = (MEvent)theEObject;
				T result = caseMEvent(mEvent);
				if (result == null) result = caseMInteractionElement(mEvent);
				if (result == null) result = caseMUICMElement(mEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MVIEW_ELEMENT_EVENT_ABSTRACT: {
				MViewElementEventAbstract mViewElementEventAbstract = (MViewElementEventAbstract)theEObject;
				T result = caseMViewElementEventAbstract(mViewElementEventAbstract);
				if (result == null) result = caseMEvent(mViewElementEventAbstract);
				if (result == null) result = caseMInteractionElement(mViewElementEventAbstract);
				if (result == null) result = caseMUICMElement(mViewElementEventAbstract);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MVIEW_COMPONENT_PART: {
				MViewComponentPart mViewComponentPart = (MViewComponentPart)theEObject;
				T result = caseMViewComponentPart(mViewComponentPart);
				if (result == null) result = caseMViewComponentPartAbstract(mViewComponentPart);
				if (result == null) result = caseMInteractionElement(mViewComponentPart);
				if (result == null) result = caseMUICMElement(mViewComponentPart);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MVIEW_ELEMENT_EVENT: {
				MViewElementEvent mViewElementEvent = (MViewElementEvent)theEObject;
				T result = caseMViewElementEvent(mViewElementEvent);
				if (result == null) result = caseMViewElementEventAbstract(mViewElementEvent);
				if (result == null) result = caseMEvent(mViewElementEvent);
				if (result == null) result = caseMInteractionElement(mViewElementEvent);
				if (result == null) result = caseMUICMElement(mViewElementEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.PINCH_EVENT: {
				PinchEvent pinchEvent = (PinchEvent)theEObject;
				T result = casePinchEvent(pinchEvent);
				if (result == null) result = caseMViewElementEventAbstract(pinchEvent);
				if (result == null) result = caseMEvent(pinchEvent);
				if (result == null) result = caseMInteractionElement(pinchEvent);
				if (result == null) result = caseMUICMElement(pinchEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.ROTATE_EVENT: {
				RotateEvent rotateEvent = (RotateEvent)theEObject;
				T result = caseRotateEvent(rotateEvent);
				if (result == null) result = caseMViewElementEventAbstract(rotateEvent);
				if (result == null) result = caseMEvent(rotateEvent);
				if (result == null) result = caseMInteractionElement(rotateEvent);
				if (result == null) result = caseMUICMElement(rotateEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.TAP_EVENT: {
				TapEvent tapEvent = (TapEvent)theEObject;
				T result = caseTapEvent(tapEvent);
				if (result == null) result = caseMViewElementEventAbstract(tapEvent);
				if (result == null) result = caseMEvent(tapEvent);
				if (result == null) result = caseMInteractionElement(tapEvent);
				if (result == null) result = caseMUICMElement(tapEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.SYSTEM_EVENT: {
				SystemEvent systemEvent = (SystemEvent)theEObject;
				T result = caseSystemEvent(systemEvent);
				if (result == null) result = caseMViewElementEventAbstract(systemEvent);
				if (result == null) result = caseMEvent(systemEvent);
				if (result == null) result = caseMInteractionElement(systemEvent);
				if (result == null) result = caseMUICMElement(systemEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.PAN_EVENT: {
				PanEvent panEvent = (PanEvent)theEObject;
				T result = casePanEvent(panEvent);
				if (result == null) result = caseMViewElementEventAbstract(panEvent);
				if (result == null) result = caseMEvent(panEvent);
				if (result == null) result = caseMInteractionElement(panEvent);
				if (result == null) result = caseMUICMElement(panEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.TOUCH_EVENT: {
				TouchEvent touchEvent = (TouchEvent)theEObject;
				T result = caseTouchEvent(touchEvent);
				if (result == null) result = caseMViewElementEventAbstract(touchEvent);
				if (result == null) result = caseMEvent(touchEvent);
				if (result == null) result = caseMInteractionElement(touchEvent);
				if (result == null) result = caseMUICMElement(touchEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.LONG_PRESS_EVENT: {
				LongPressEvent longPressEvent = (LongPressEvent)theEObject;
				T result = caseLongPressEvent(longPressEvent);
				if (result == null) result = caseMViewElementEventAbstract(longPressEvent);
				if (result == null) result = caseMEvent(longPressEvent);
				if (result == null) result = caseMInteractionElement(longPressEvent);
				if (result == null) result = caseMUICMElement(longPressEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.SWIPE_EVENT: {
				SwipeEvent swipeEvent = (SwipeEvent)theEObject;
				T result = caseSwipeEvent(swipeEvent);
				if (result == null) result = caseMViewElementEventAbstract(swipeEvent);
				if (result == null) result = caseMEvent(swipeEvent);
				if (result == null) result = caseMInteractionElement(swipeEvent);
				if (result == null) result = caseMUICMElement(swipeEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MACTION_EVENT: {
				MActionEvent mActionEvent = (MActionEvent)theEObject;
				T result = caseMActionEvent(mActionEvent);
				if (result == null) result = caseMEvent(mActionEvent);
				if (result == null) result = caseMInteractionElement(mActionEvent);
				if (result == null) result = caseMUICMElement(mActionEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CAMERA_ACTION_EVENT: {
				CameraActionEvent cameraActionEvent = (CameraActionEvent)theEObject;
				T result = caseCameraActionEvent(cameraActionEvent);
				if (result == null) result = caseMActionEvent(cameraActionEvent);
				if (result == null) result = caseMEvent(cameraActionEvent);
				if (result == null) result = caseMInteractionElement(cameraActionEvent);
				if (result == null) result = caseMUICMElement(cameraActionEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MICROPHONE_ACTION_EVENT: {
				MicrophoneActionEvent microphoneActionEvent = (MicrophoneActionEvent)theEObject;
				T result = caseMicrophoneActionEvent(microphoneActionEvent);
				if (result == null) result = caseMActionEvent(microphoneActionEvent);
				if (result == null) result = caseMEvent(microphoneActionEvent);
				if (result == null) result = caseMInteractionElement(microphoneActionEvent);
				if (result == null) result = caseMUICMElement(microphoneActionEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.OTHER_ACTION_EVENT: {
				OtherActionEvent otherActionEvent = (OtherActionEvent)theEObject;
				T result = caseOtherActionEvent(otherActionEvent);
				if (result == null) result = caseMActionEvent(otherActionEvent);
				if (result == null) result = caseMEvent(otherActionEvent);
				if (result == null) result = caseMInteractionElement(otherActionEvent);
				if (result == null) result = caseMUICMElement(otherActionEvent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MEXPRESSION: {
				MExpression mExpression = (MExpression)theEObject;
				T result = caseMExpression(mExpression);
				if (result == null) result = caseMInteractionElement(mExpression);
				if (result == null) result = caseMUICMElement(mExpression);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CAMERA_ACTION: {
				CameraAction cameraAction = (CameraAction)theEObject;
				T result = caseCameraAction(cameraAction);
				if (result == null) result = caseMAction(cameraAction);
				if (result == null) result = caseMInteractionElement(cameraAction);
				if (result == null) result = caseMUICMElement(cameraAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.MICROPHONE_ACTION: {
				MicrophoneAction microphoneAction = (MicrophoneAction)theEObject;
				T result = caseMicrophoneAction(microphoneAction);
				if (result == null) result = caseMAction(microphoneAction);
				if (result == null) result = caseMInteractionElement(microphoneAction);
				if (result == null) result = caseMUICMElement(microphoneAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.OTHER_ACTION: {
				OtherAction otherAction = (OtherAction)theEObject;
				T result = caseOtherAction(otherAction);
				if (result == null) result = caseMAction(otherAction);
				if (result == null) result = caseMInteractionElement(otherAction);
				if (result == null) result = caseMUICMElement(otherAction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CONDITIONAL_EXPRESSION: {
				ConditionalExpression conditionalExpression = (ConditionalExpression)theEObject;
				T result = caseConditionalExpression(conditionalExpression);
				if (result == null) result = caseMExpression(conditionalExpression);
				if (result == null) result = caseMInteractionElement(conditionalExpression);
				if (result == null) result = caseMUICMElement(conditionalExpression);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.STATIC_CONTENT: {
				StaticContent staticContent = (StaticContent)theEObject;
				T result = caseStaticContent(staticContent);
				if (result == null) result = caseContentBinding(staticContent);
				if (result == null) result = caseMViewComponentPartAbstract(staticContent);
				if (result == null) result = caseMInteractionElement(staticContent);
				if (result == null) result = caseMUICMElement(staticContent);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.DYNAMIC_BEHAVIOUR: {
				DynamicBehaviour dynamicBehaviour = (DynamicBehaviour)theEObject;
				T result = caseDynamicBehaviour(dynamicBehaviour);
				if (result == null) result = caseContentBinding(dynamicBehaviour);
				if (result == null) result = caseMViewComponentPartAbstract(dynamicBehaviour);
				if (result == null) result = caseMInteractionElement(dynamicBehaviour);
				if (result == null) result = caseMUICMElement(dynamicBehaviour);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CONTENT_MODEL: {
				ContentModel contentModel = (ContentModel)theEObject;
				T result = caseContentModel(contentModel);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.CONTENT_ELEMENT: {
				ContentElement contentElement = (ContentElement)theEObject;
				T result = caseContentElement(contentElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.BEHAVIOUR_CONCEPT: {
				BehaviourConcept behaviourConcept = (BehaviourConcept)theEObject;
				T result = caseBehaviourConcept(behaviourConcept);
				if (result == null) result = caseContentElement(behaviourConcept);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.DOMAIN_CONCEPT: {
				DomainConcept domainConcept = (DomainConcept)theEObject;
				T result = caseDomainConcept(domainConcept);
				if (result == null) result = caseContentElement(domainConcept);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.FEATURE_CONCEPT: {
				FeatureConcept featureConcept = (FeatureConcept)theEObject;
				T result = caseFeatureConcept(featureConcept);
				if (result == null) result = caseContentElement(featureConcept);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case MuicmPackage.ATTRIBUTE: {
				Attribute attribute = (Attribute)theEObject;
				T result = caseAttribute(attribute);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MUICM</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MUICM</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMUICM(MUICM object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MUICM Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MUICM Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMUICMElement(MUICMElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MInteraction Flow</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MInteraction Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMInteractionFlow(MInteractionFlow object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Navigation Flow</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Navigation Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNavigationFlow(NavigationFlow object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Flow</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Flow</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataFlow(DataFlow object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MInteraction Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MInteraction Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMInteractionElement(MInteractionElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Binding Group</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Binding Group</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataBindingGroup(DataBindingGroup object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data Binding</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data Binding</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDataBinding(DataBinding object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Data</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Data</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseData(Data object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MView Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MView Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMViewElement(MViewElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Screen</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Screen</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseScreen(Screen object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Mview Component Ext</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Mview Component Ext</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMviewComponentExt(MviewComponentExt object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MView Component</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MView Component</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMViewComponent(MViewComponent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Search View</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Search View</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSearchView(SearchView object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>List</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>List</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseList(List object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Tool Bar</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Tool Bar</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToolBar(ToolBar object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Form</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Form</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseForm(Form object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Message</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Message</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMessage(Message object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Details</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Details</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDetails(Details object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Utility View</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Utility View</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseUtilityView(UtilityView object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MView Component Part Abstract</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MView Component Part Abstract</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMViewComponentPartAbstract(MViewComponentPartAbstract object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Field</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Field</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseField(Field object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Simple Field</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Simple Field</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSimpleField(SimpleField object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Selection Field</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Selection Field</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSelectionField(SelectionField object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Text Box</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Text Box</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTextBox(TextBox object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Media</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Media</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMedia(Media object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Label</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Label</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLabel(Label object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MAction</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MAction</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMAction(MAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Utility</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Utility</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseUtility(Utility object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Map</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Map</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMap(Map object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Calendar</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Calendar</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCalendar(Calendar object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Code</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Code</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCode(Code object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Icon</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Icon</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIcon(Icon object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Content Binding</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Content Binding</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseContentBinding(ContentBinding object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MEvent</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MEvent</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMEvent(MEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MView Element Event Abstract</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MView Element Event Abstract</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMViewElementEventAbstract(MViewElementEventAbstract object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MView Component Part</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MView Component Part</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMViewComponentPart(MViewComponentPart object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MView Element Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MView Element Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMViewElementEvent(MViewElementEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Pinch Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Pinch Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePinchEvent(PinchEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rotate Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rotate Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRotateEvent(RotateEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Tap Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Tap Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTapEvent(TapEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>System Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>System Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSystemEvent(SystemEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Pan Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Pan Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePanEvent(PanEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Touch Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Touch Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTouchEvent(TouchEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Long Press Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Long Press Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLongPressEvent(LongPressEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Swipe Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Swipe Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSwipeEvent(SwipeEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MAction Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MAction Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMActionEvent(MActionEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Camera Action Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Camera Action Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCameraActionEvent(CameraActionEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Microphone Action Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Microphone Action Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMicrophoneActionEvent(MicrophoneActionEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Other Action Event</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Other Action Event</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOtherActionEvent(OtherActionEvent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MExpression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MExpression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMExpression(MExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Camera Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Camera Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCameraAction(CameraAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Microphone Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Microphone Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMicrophoneAction(MicrophoneAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Other Action</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Other Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOtherAction(OtherAction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Conditional Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Conditional Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConditionalExpression(ConditionalExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Static Content</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Static Content</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseStaticContent(StaticContent object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Dynamic Behaviour</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Dynamic Behaviour</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDynamicBehaviour(DynamicBehaviour object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Content Model</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Content Model</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseContentModel(ContentModel object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Content Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Content Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseContentElement(ContentElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Behaviour Concept</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Behaviour Concept</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBehaviourConcept(BehaviourConcept object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Domain Concept</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Domain Concept</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDomainConcept(DomainConcept object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Feature Concept</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Feature Concept</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFeatureConcept(FeatureConcept object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Attribute</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Attribute</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAttribute(Attribute object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //MuicmSwitch
