/**
 */
package muicm;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see muicm.MuicmFactory
 * @model kind="package"
 * @generated
 */
public interface MuicmPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "muicm";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.example.org/muicm";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "muicm";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MuicmPackage eINSTANCE = muicm.impl.MuicmPackageImpl.init();

	/**
	 * The meta object id for the '{@link muicm.impl.MUICMImpl <em>MUICM</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MUICMImpl
	 * @see muicm.impl.MuicmPackageImpl#getMUICM()
	 * @generated
	 */
	int MUICM = 0;

	/**
	 * The feature id for the '<em><b>Muicm Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUICM__MUICM_ELEMENTS = 0;

	/**
	 * The feature id for the '<em><b>Contentmodel</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUICM__CONTENTMODEL = 1;

	/**
	 * The number of structural features of the '<em>MUICM</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUICM_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>MUICM</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUICM_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MUICMElementImpl <em>MUICM Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MUICMElementImpl
	 * @see muicm.impl.MuicmPackageImpl#getMUICMElement()
	 * @generated
	 */
	int MUICM_ELEMENT = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUICM_ELEMENT__NAME = 0;

	/**
	 * The number of structural features of the '<em>MUICM Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUICM_ELEMENT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>MUICM Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MUICM_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MInteractionFlowImpl <em>MInteraction Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MInteractionFlowImpl
	 * @see muicm.impl.MuicmPackageImpl#getMInteractionFlow()
	 * @generated
	 */
	int MINTERACTION_FLOW = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW__NAME = MUICM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Source Interaction Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW__SOURCE_INTERACTION_ELEMENT = MUICM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target Interaction Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW__TARGET_INTERACTION_ELEMENT = MUICM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Data Binding Group</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW__DATA_BINDING_GROUP = MUICM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Source Element Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW__SOURCE_ELEMENT_NAME = MUICM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Target Element Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW__TARGET_ELEMENT_NAME = MUICM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>MInteraction Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW_FEATURE_COUNT = MUICM_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>MInteraction Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_FLOW_OPERATION_COUNT = MUICM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.NavigationFlowImpl <em>Navigation Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.NavigationFlowImpl
	 * @see muicm.impl.MuicmPackageImpl#getNavigationFlow()
	 * @generated
	 */
	int NAVIGATION_FLOW = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW__NAME = MINTERACTION_FLOW__NAME;

	/**
	 * The feature id for the '<em><b>Source Interaction Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW__SOURCE_INTERACTION_ELEMENT = MINTERACTION_FLOW__SOURCE_INTERACTION_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Interaction Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW__TARGET_INTERACTION_ELEMENT = MINTERACTION_FLOW__TARGET_INTERACTION_ELEMENT;

	/**
	 * The feature id for the '<em><b>Data Binding Group</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW__DATA_BINDING_GROUP = MINTERACTION_FLOW__DATA_BINDING_GROUP;

	/**
	 * The feature id for the '<em><b>Source Element Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW__SOURCE_ELEMENT_NAME = MINTERACTION_FLOW__SOURCE_ELEMENT_NAME;

	/**
	 * The feature id for the '<em><b>Target Element Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW__TARGET_ELEMENT_NAME = MINTERACTION_FLOW__TARGET_ELEMENT_NAME;

	/**
	 * The number of structural features of the '<em>Navigation Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW_FEATURE_COUNT = MINTERACTION_FLOW_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Navigation Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAVIGATION_FLOW_OPERATION_COUNT = MINTERACTION_FLOW_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.DataFlowImpl <em>Data Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.DataFlowImpl
	 * @see muicm.impl.MuicmPackageImpl#getDataFlow()
	 * @generated
	 */
	int DATA_FLOW = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__NAME = MINTERACTION_FLOW__NAME;

	/**
	 * The feature id for the '<em><b>Source Interaction Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__SOURCE_INTERACTION_ELEMENT = MINTERACTION_FLOW__SOURCE_INTERACTION_ELEMENT;

	/**
	 * The feature id for the '<em><b>Target Interaction Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__TARGET_INTERACTION_ELEMENT = MINTERACTION_FLOW__TARGET_INTERACTION_ELEMENT;

	/**
	 * The feature id for the '<em><b>Data Binding Group</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__DATA_BINDING_GROUP = MINTERACTION_FLOW__DATA_BINDING_GROUP;

	/**
	 * The feature id for the '<em><b>Source Element Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__SOURCE_ELEMENT_NAME = MINTERACTION_FLOW__SOURCE_ELEMENT_NAME;

	/**
	 * The feature id for the '<em><b>Target Element Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__TARGET_ELEMENT_NAME = MINTERACTION_FLOW__TARGET_ELEMENT_NAME;

	/**
	 * The number of structural features of the '<em>Data Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_FEATURE_COUNT = MINTERACTION_FLOW_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Data Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_OPERATION_COUNT = MINTERACTION_FLOW_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MInteractionElementImpl <em>MInteraction Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MInteractionElementImpl
	 * @see muicm.impl.MuicmPackageImpl#getMInteractionElement()
	 * @generated
	 */
	int MINTERACTION_ELEMENT = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_ELEMENT__NAME = MUICM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_ELEMENT__DATAS = MUICM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MInteraction Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_ELEMENT_FEATURE_COUNT = MUICM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>MInteraction Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MINTERACTION_ELEMENT_OPERATION_COUNT = MUICM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.DataBindingGroupImpl <em>Data Binding Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.DataBindingGroupImpl
	 * @see muicm.impl.MuicmPackageImpl#getDataBindingGroup()
	 * @generated
	 */
	int DATA_BINDING_GROUP = 6;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING_GROUP__NAME = MUICM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Data Bindings</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING_GROUP__DATA_BINDINGS = MUICM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Data Binding Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING_GROUP_FEATURE_COUNT = MUICM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Data Binding Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING_GROUP_OPERATION_COUNT = MUICM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.DataBindingImpl <em>Data Binding</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.DataBindingImpl
	 * @see muicm.impl.MuicmPackageImpl#getDataBinding()
	 * @generated
	 */
	int DATA_BINDING = 7;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING__NAME = MUICM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Source Data</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING__SOURCE_DATA = MUICM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target Data</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING__TARGET_DATA = MUICM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Source Data Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING__SOURCE_DATA_NAME = MUICM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Target Data Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING__TARGET_DATA_NAME = MUICM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Data Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING_FEATURE_COUNT = MUICM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Data Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_BINDING_OPERATION_COUNT = MUICM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.DataImpl <em>Data</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.DataImpl
	 * @see muicm.impl.MuicmPackageImpl#getData()
	 * @generated
	 */
	int DATA = 8;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__NAME = MUICM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__TYPE = MUICM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Dir Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__DIR_TYPE = MUICM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Visual</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA__VISUAL = MUICM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Data</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FEATURE_COUNT = MUICM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Data</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_OPERATION_COUNT = MUICM_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MViewElementImpl <em>MView Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MViewElementImpl
	 * @see muicm.impl.MuicmPackageImpl#getMViewElement()
	 * @generated
	 */
	int MVIEW_ELEMENT = 9;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT__NAME = MINTERACTION_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT__DATAS = MINTERACTION_ELEMENT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT__MVIEW_ELEMENT_EVENTS = MINTERACTION_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MView Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_FEATURE_COUNT = MINTERACTION_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>MView Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_OPERATION_COUNT = MINTERACTION_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.ScreenImpl <em>Screen</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.ScreenImpl
	 * @see muicm.impl.MuicmPackageImpl#getScreen()
	 * @generated
	 */
	int SCREEN = 10;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN__NAME = MVIEW_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN__DATAS = MVIEW_ELEMENT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN__MVIEW_ELEMENT_EVENTS = MVIEW_ELEMENT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Is Modal</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN__IS_MODAL = MVIEW_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Has Nav</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN__HAS_NAV = MVIEW_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Is Home</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN__IS_HOME = MVIEW_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Mview Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN__MVIEW_ELEMENTS = MVIEW_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Screen</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN_FEATURE_COUNT = MVIEW_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Screen</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCREEN_OPERATION_COUNT = MVIEW_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MviewComponentExtImpl <em>Mview Component Ext</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MviewComponentExtImpl
	 * @see muicm.impl.MuicmPackageImpl#getMviewComponentExt()
	 * @generated
	 */
	int MVIEW_COMPONENT_EXT = 11;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_EXT__NAME = MVIEW_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_EXT__DATAS = MVIEW_ELEMENT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS = MVIEW_ELEMENT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS = MVIEW_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Mview Component Ext</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_EXT_FEATURE_COUNT = MVIEW_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Mview Component Ext</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_EXT_OPERATION_COUNT = MVIEW_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MViewComponentImpl <em>MView Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MViewComponentImpl
	 * @see muicm.impl.MuicmPackageImpl#getMViewComponent()
	 * @generated
	 */
	int MVIEW_COMPONENT = 12;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT__NAME = MVIEW_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT__DATAS = MVIEW_ELEMENT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT__MVIEW_ELEMENT_EVENTS = MVIEW_ELEMENT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT__MVIEW_COMPONENT_PARTS = MVIEW_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MView Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_FEATURE_COUNT = MVIEW_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>MView Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_OPERATION_COUNT = MVIEW_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.SearchViewImpl <em>Search View</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.SearchViewImpl
	 * @see muicm.impl.MuicmPackageImpl#getSearchView()
	 * @generated
	 */
	int SEARCH_VIEW = 13;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEARCH_VIEW__NAME = MVIEW_COMPONENT_EXT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEARCH_VIEW__DATAS = MVIEW_COMPONENT_EXT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEARCH_VIEW__MVIEW_ELEMENT_EVENTS = MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEARCH_VIEW__MVIEW_COMPONENT_PARTS = MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS;

	/**
	 * The number of structural features of the '<em>Search View</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEARCH_VIEW_FEATURE_COUNT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Search View</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEARCH_VIEW_OPERATION_COUNT = MVIEW_COMPONENT_EXT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.ListImpl <em>List</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.ListImpl
	 * @see muicm.impl.MuicmPackageImpl#getList()
	 * @generated
	 */
	int LIST = 14;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST__NAME = MVIEW_COMPONENT_EXT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST__DATAS = MVIEW_COMPONENT_EXT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST__MVIEW_ELEMENT_EVENTS = MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST__MVIEW_COMPONENT_PARTS = MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS;

	/**
	 * The number of structural features of the '<em>List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_FEATURE_COUNT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>List</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LIST_OPERATION_COUNT = MVIEW_COMPONENT_EXT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.ToolBarImpl <em>Tool Bar</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.ToolBarImpl
	 * @see muicm.impl.MuicmPackageImpl#getToolBar()
	 * @generated
	 */
	int TOOL_BAR = 15;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_BAR__NAME = MVIEW_COMPONENT_EXT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_BAR__DATAS = MVIEW_COMPONENT_EXT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_BAR__MVIEW_ELEMENT_EVENTS = MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_BAR__MVIEW_COMPONENT_PARTS = MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS;

	/**
	 * The number of structural features of the '<em>Tool Bar</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_BAR_FEATURE_COUNT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Tool Bar</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOOL_BAR_OPERATION_COUNT = MVIEW_COMPONENT_EXT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.FormImpl <em>Form</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.FormImpl
	 * @see muicm.impl.MuicmPackageImpl#getForm()
	 * @generated
	 */
	int FORM = 16;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM__NAME = MVIEW_COMPONENT_EXT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM__DATAS = MVIEW_COMPONENT_EXT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM__MVIEW_ELEMENT_EVENTS = MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM__MVIEW_COMPONENT_PARTS = MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS;

	/**
	 * The number of structural features of the '<em>Form</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_FEATURE_COUNT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Form</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FORM_OPERATION_COUNT = MVIEW_COMPONENT_EXT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MessageImpl <em>Message</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MessageImpl
	 * @see muicm.impl.MuicmPackageImpl#getMessage()
	 * @generated
	 */
	int MESSAGE = 17;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__NAME = MVIEW_COMPONENT_EXT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__DATAS = MVIEW_COMPONENT_EXT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__MVIEW_ELEMENT_EVENTS = MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__MVIEW_COMPONENT_PARTS = MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS;

	/**
	 * The feature id for the '<em><b>Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE__TEXT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_FEATURE_COUNT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_OPERATION_COUNT = MVIEW_COMPONENT_EXT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.DetailsImpl <em>Details</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.DetailsImpl
	 * @see muicm.impl.MuicmPackageImpl#getDetails()
	 * @generated
	 */
	int DETAILS = 18;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DETAILS__NAME = MVIEW_COMPONENT_EXT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DETAILS__DATAS = MVIEW_COMPONENT_EXT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DETAILS__MVIEW_ELEMENT_EVENTS = MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DETAILS__MVIEW_COMPONENT_PARTS = MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS;

	/**
	 * The number of structural features of the '<em>Details</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DETAILS_FEATURE_COUNT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Details</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DETAILS_OPERATION_COUNT = MVIEW_COMPONENT_EXT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.UtilityViewImpl <em>Utility View</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.UtilityViewImpl
	 * @see muicm.impl.MuicmPackageImpl#getUtilityView()
	 * @generated
	 */
	int UTILITY_VIEW = 19;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_VIEW__NAME = MVIEW_COMPONENT_EXT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_VIEW__DATAS = MVIEW_COMPONENT_EXT__DATAS;

	/**
	 * The feature id for the '<em><b>Mview Element Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_VIEW__MVIEW_ELEMENT_EVENTS = MVIEW_COMPONENT_EXT__MVIEW_ELEMENT_EVENTS;

	/**
	 * The feature id for the '<em><b>Mview Component Parts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_VIEW__MVIEW_COMPONENT_PARTS = MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS;

	/**
	 * The number of structural features of the '<em>Utility View</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_VIEW_FEATURE_COUNT = MVIEW_COMPONENT_EXT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Utility View</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_VIEW_OPERATION_COUNT = MVIEW_COMPONENT_EXT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MViewComponentPartAbstractImpl <em>MView Component Part Abstract</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MViewComponentPartAbstractImpl
	 * @see muicm.impl.MuicmPackageImpl#getMViewComponentPartAbstract()
	 * @generated
	 */
	int MVIEW_COMPONENT_PART_ABSTRACT = 20;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART_ABSTRACT__NAME = MINTERACTION_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART_ABSTRACT__DATAS = MINTERACTION_ELEMENT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART = MINTERACTION_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MView Component Part Abstract</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT = MINTERACTION_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>MView Component Part Abstract</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT = MINTERACTION_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.FieldImpl <em>Field</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.FieldImpl
	 * @see muicm.impl.MuicmPackageImpl#getField()
	 * @generated
	 */
	int FIELD = 21;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD__CONTENT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIELD_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.SimpleFieldImpl <em>Simple Field</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.SimpleFieldImpl
	 * @see muicm.impl.MuicmPackageImpl#getSimpleField()
	 * @generated
	 */
	int SIMPLE_FIELD = 22;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_FIELD__NAME = FIELD__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_FIELD__DATAS = FIELD__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_FIELD__SUB_MVIEW_COMPONENT_PART = FIELD__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_FIELD__CONTENT = FIELD__CONTENT;

	/**
	 * The number of structural features of the '<em>Simple Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_FIELD_FEATURE_COUNT = FIELD_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Simple Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_FIELD_OPERATION_COUNT = FIELD_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.SelectionFieldImpl <em>Selection Field</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.SelectionFieldImpl
	 * @see muicm.impl.MuicmPackageImpl#getSelectionField()
	 * @generated
	 */
	int SELECTION_FIELD = 23;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTION_FIELD__NAME = FIELD__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTION_FIELD__DATAS = FIELD__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTION_FIELD__SUB_MVIEW_COMPONENT_PART = FIELD__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Content</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTION_FIELD__CONTENT = FIELD__CONTENT;

	/**
	 * The feature id for the '<em><b>Is Multi Selection</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTION_FIELD__IS_MULTI_SELECTION = FIELD_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Selection Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTION_FIELD_FEATURE_COUNT = FIELD_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Selection Field</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTION_FIELD_OPERATION_COUNT = FIELD_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.TextBoxImpl <em>Text Box</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.TextBoxImpl
	 * @see muicm.impl.MuicmPackageImpl#getTextBox()
	 * @generated
	 */
	int TEXT_BOX = 24;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT_BOX__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT_BOX__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT_BOX__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT_BOX__TEXT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Text Box</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT_BOX_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Text Box</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEXT_BOX_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MediaImpl <em>Media</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MediaImpl
	 * @see muicm.impl.MuicmPackageImpl#getMedia()
	 * @generated
	 */
	int MEDIA = 25;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIA__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIA__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIA__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIA__TYPE = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Media Image</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIA__MEDIA_IMAGE = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Media</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIA_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Media</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEDIA_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.LabelImpl <em>Label</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.LabelImpl
	 * @see muicm.impl.MuicmPackageImpl#getLabel()
	 * @generated
	 */
	int LABEL = 26;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABEL__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABEL__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABEL__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABEL__DESCRIPTION = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABEL_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Label</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LABEL_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MActionImpl <em>MAction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MActionImpl
	 * @see muicm.impl.MuicmPackageImpl#getMAction()
	 * @generated
	 */
	int MACTION = 27;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION__NAME = MINTERACTION_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION__DATAS = MINTERACTION_ELEMENT__DATAS;

	/**
	 * The feature id for the '<em><b>Dynamic Behaviour</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION__DYNAMIC_BEHAVIOUR = MINTERACTION_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Maction Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION__MACTION_EVENTS = MINTERACTION_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>MAction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION_FEATURE_COUNT = MINTERACTION_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>MAction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION_OPERATION_COUNT = MINTERACTION_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.UtilityImpl <em>Utility</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.UtilityImpl
	 * @see muicm.impl.MuicmPackageImpl#getUtility()
	 * @generated
	 */
	int UTILITY = 28;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The number of structural features of the '<em>Utility</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Utility</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UTILITY_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MapImpl <em>Map</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MapImpl
	 * @see muicm.impl.MuicmPackageImpl#getMap()
	 * @generated
	 */
	int MAP = 29;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP__NAME = UTILITY__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP__DATAS = UTILITY__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP__SUB_MVIEW_COMPONENT_PART = UTILITY__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Provider</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP__PROVIDER = UTILITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Map</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_FEATURE_COUNT = UTILITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Map</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MAP_OPERATION_COUNT = UTILITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.CalendarImpl <em>Calendar</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.CalendarImpl
	 * @see muicm.impl.MuicmPackageImpl#getCalendar()
	 * @generated
	 */
	int CALENDAR = 30;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALENDAR__NAME = UTILITY__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALENDAR__DATAS = UTILITY__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALENDAR__SUB_MVIEW_COMPONENT_PART = UTILITY__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Years Block Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALENDAR__YEARS_BLOCK_SIZE = UTILITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Calendar</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALENDAR_FEATURE_COUNT = UTILITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Calendar</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALENDAR_OPERATION_COUNT = UTILITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.CodeImpl <em>Code</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.CodeImpl
	 * @see muicm.impl.MuicmPackageImpl#getCode()
	 * @generated
	 */
	int CODE = 31;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE__NAME = UTILITY__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE__DATAS = UTILITY__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE__SUB_MVIEW_COMPONENT_PART = UTILITY__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Format</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE__FORMAT = UTILITY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Code</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_FEATURE_COUNT = UTILITY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Code</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CODE_OPERATION_COUNT = UTILITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.IconImpl <em>Icon</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.IconImpl
	 * @see muicm.impl.MuicmPackageImpl#getIcon()
	 * @generated
	 */
	int ICON = 32;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICON__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICON__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICON__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The number of structural features of the '<em>Icon</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICON_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Icon</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICON_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.ContentBindingImpl <em>Content Binding</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.ContentBindingImpl
	 * @see muicm.impl.MuicmPackageImpl#getContentBinding()
	 * @generated
	 */
	int CONTENT_BINDING = 33;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_BINDING__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_BINDING__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_BINDING__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The number of structural features of the '<em>Content Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_BINDING_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Content Binding</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_BINDING_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MEventImpl <em>MEvent</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getMEvent()
	 * @generated
	 */
	int MEVENT = 34;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEVENT__NAME = MINTERACTION_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEVENT__DATAS = MINTERACTION_ELEMENT__DATAS;

	/**
	 * The number of structural features of the '<em>MEvent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEVENT_FEATURE_COUNT = MINTERACTION_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>MEvent</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEVENT_OPERATION_COUNT = MINTERACTION_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MViewElementEventAbstractImpl <em>MView Element Event Abstract</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MViewElementEventAbstractImpl
	 * @see muicm.impl.MuicmPackageImpl#getMViewElementEventAbstract()
	 * @generated
	 */
	int MVIEW_ELEMENT_EVENT_ABSTRACT = 35;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT_ABSTRACT__NAME = MEVENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS = MEVENT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE = MEVENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MView Element Event Abstract</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT = MEVENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>MView Element Event Abstract</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT = MEVENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MViewComponentPartImpl <em>MView Component Part</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MViewComponentPartImpl
	 * @see muicm.impl.MuicmPackageImpl#getMViewComponentPart()
	 * @generated
	 */
	int MVIEW_COMPONENT_PART = 36;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART__NAME = MVIEW_COMPONENT_PART_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART__DATAS = MVIEW_COMPONENT_PART_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART__SUB_MVIEW_COMPONENT_PART = MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Mviewelementevent</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART__MVIEWELEMENTEVENT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MView Component Part</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART_FEATURE_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>MView Component Part</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_COMPONENT_PART_OPERATION_COUNT = MVIEW_COMPONENT_PART_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MViewElementEventImpl <em>MView Element Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MViewElementEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getMViewElementEvent()
	 * @generated
	 */
	int MVIEW_ELEMENT_EVENT = 37;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The number of structural features of the '<em>MView Element Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>MView Element Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MVIEW_ELEMENT_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.PinchEventImpl <em>Pinch Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.PinchEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getPinchEvent()
	 * @generated
	 */
	int PINCH_EVENT = 38;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PINCH_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PINCH_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PINCH_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The number of structural features of the '<em>Pinch Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PINCH_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Pinch Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PINCH_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.RotateEventImpl <em>Rotate Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.RotateEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getRotateEvent()
	 * @generated
	 */
	int ROTATE_EVENT = 39;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROTATE_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROTATE_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROTATE_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The number of structural features of the '<em>Rotate Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROTATE_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Rotate Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROTATE_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.TapEventImpl <em>Tap Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.TapEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getTapEvent()
	 * @generated
	 */
	int TAP_EVENT = 40;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The number of structural features of the '<em>Tap Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Tap Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TAP_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.SystemEventImpl <em>System Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.SystemEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getSystemEvent()
	 * @generated
	 */
	int SYSTEM_EVENT = 41;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The number of structural features of the '<em>System Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>System Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.PanEventImpl <em>Pan Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.PanEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getPanEvent()
	 * @generated
	 */
	int PAN_EVENT = 42;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAN_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAN_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAN_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The number of structural features of the '<em>Pan Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAN_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Pan Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAN_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.TouchEventImpl <em>Touch Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.TouchEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getTouchEvent()
	 * @generated
	 */
	int TOUCH_EVENT = 43;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOUCH_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOUCH_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOUCH_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The number of structural features of the '<em>Touch Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOUCH_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Touch Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOUCH_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.LongPressEventImpl <em>Long Press Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.LongPressEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getLongPressEvent()
	 * @generated
	 */
	int LONG_PRESS_EVENT = 44;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONG_PRESS_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONG_PRESS_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONG_PRESS_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The feature id for the '<em><b>Finger Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONG_PRESS_EVENT__FINGER_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Press Duration</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONG_PRESS_EVENT__PRESS_DURATION = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Long Press Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONG_PRESS_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Long Press Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LONG_PRESS_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.SwipeEventImpl <em>Swipe Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.SwipeEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getSwipeEvent()
	 * @generated
	 */
	int SWIPE_EVENT = 45;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWIPE_EVENT__NAME = MVIEW_ELEMENT_EVENT_ABSTRACT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWIPE_EVENT__DATAS = MVIEW_ELEMENT_EVENT_ABSTRACT__DATAS;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWIPE_EVENT__TYPE = MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE;

	/**
	 * The feature id for the '<em><b>Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWIPE_EVENT__DIRECTION = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Swipe Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWIPE_EVENT_FEATURE_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Swipe Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWIPE_EVENT_OPERATION_COUNT = MVIEW_ELEMENT_EVENT_ABSTRACT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MActionEventImpl <em>MAction Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MActionEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getMActionEvent()
	 * @generated
	 */
	int MACTION_EVENT = 46;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION_EVENT__NAME = MEVENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION_EVENT__DATAS = MEVENT__DATAS;

	/**
	 * The feature id for the '<em><b>Execute Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION_EVENT__EXECUTE_RESULT = MEVENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MAction Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION_EVENT_FEATURE_COUNT = MEVENT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>MAction Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MACTION_EVENT_OPERATION_COUNT = MEVENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.CameraActionEventImpl <em>Camera Action Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.CameraActionEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getCameraActionEvent()
	 * @generated
	 */
	int CAMERA_ACTION_EVENT = 47;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION_EVENT__NAME = MACTION_EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION_EVENT__DATAS = MACTION_EVENT__DATAS;

	/**
	 * The feature id for the '<em><b>Execute Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION_EVENT__EXECUTE_RESULT = MACTION_EVENT__EXECUTE_RESULT;

	/**
	 * The number of structural features of the '<em>Camera Action Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION_EVENT_FEATURE_COUNT = MACTION_EVENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Camera Action Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION_EVENT_OPERATION_COUNT = MACTION_EVENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MicrophoneActionEventImpl <em>Microphone Action Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MicrophoneActionEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getMicrophoneActionEvent()
	 * @generated
	 */
	int MICROPHONE_ACTION_EVENT = 48;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION_EVENT__NAME = MACTION_EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION_EVENT__DATAS = MACTION_EVENT__DATAS;

	/**
	 * The feature id for the '<em><b>Execute Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION_EVENT__EXECUTE_RESULT = MACTION_EVENT__EXECUTE_RESULT;

	/**
	 * The number of structural features of the '<em>Microphone Action Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION_EVENT_FEATURE_COUNT = MACTION_EVENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Microphone Action Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION_EVENT_OPERATION_COUNT = MACTION_EVENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.OtherActionEventImpl <em>Other Action Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.OtherActionEventImpl
	 * @see muicm.impl.MuicmPackageImpl#getOtherActionEvent()
	 * @generated
	 */
	int OTHER_ACTION_EVENT = 49;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION_EVENT__NAME = MACTION_EVENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION_EVENT__DATAS = MACTION_EVENT__DATAS;

	/**
	 * The feature id for the '<em><b>Execute Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION_EVENT__EXECUTE_RESULT = MACTION_EVENT__EXECUTE_RESULT;

	/**
	 * The number of structural features of the '<em>Other Action Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION_EVENT_FEATURE_COUNT = MACTION_EVENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Other Action Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION_EVENT_OPERATION_COUNT = MACTION_EVENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MExpressionImpl <em>MExpression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MExpressionImpl
	 * @see muicm.impl.MuicmPackageImpl#getMExpression()
	 * @generated
	 */
	int MEXPRESSION = 50;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEXPRESSION__NAME = MINTERACTION_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEXPRESSION__DATAS = MINTERACTION_ELEMENT__DATAS;

	/**
	 * The number of structural features of the '<em>MExpression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEXPRESSION_FEATURE_COUNT = MINTERACTION_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>MExpression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEXPRESSION_OPERATION_COUNT = MINTERACTION_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.CameraActionImpl <em>Camera Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.CameraActionImpl
	 * @see muicm.impl.MuicmPackageImpl#getCameraAction()
	 * @generated
	 */
	int CAMERA_ACTION = 51;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION__NAME = MACTION__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION__DATAS = MACTION__DATAS;

	/**
	 * The feature id for the '<em><b>Dynamic Behaviour</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION__DYNAMIC_BEHAVIOUR = MACTION__DYNAMIC_BEHAVIOUR;

	/**
	 * The feature id for the '<em><b>Maction Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION__MACTION_EVENTS = MACTION__MACTION_EVENTS;

	/**
	 * The number of structural features of the '<em>Camera Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION_FEATURE_COUNT = MACTION_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Camera Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAMERA_ACTION_OPERATION_COUNT = MACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.MicrophoneActionImpl <em>Microphone Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.MicrophoneActionImpl
	 * @see muicm.impl.MuicmPackageImpl#getMicrophoneAction()
	 * @generated
	 */
	int MICROPHONE_ACTION = 52;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION__NAME = MACTION__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION__DATAS = MACTION__DATAS;

	/**
	 * The feature id for the '<em><b>Dynamic Behaviour</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION__DYNAMIC_BEHAVIOUR = MACTION__DYNAMIC_BEHAVIOUR;

	/**
	 * The feature id for the '<em><b>Maction Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION__MACTION_EVENTS = MACTION__MACTION_EVENTS;

	/**
	 * The number of structural features of the '<em>Microphone Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION_FEATURE_COUNT = MACTION_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Microphone Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MICROPHONE_ACTION_OPERATION_COUNT = MACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.OtherActionImpl <em>Other Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.OtherActionImpl
	 * @see muicm.impl.MuicmPackageImpl#getOtherAction()
	 * @generated
	 */
	int OTHER_ACTION = 53;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION__NAME = MACTION__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION__DATAS = MACTION__DATAS;

	/**
	 * The feature id for the '<em><b>Dynamic Behaviour</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION__DYNAMIC_BEHAVIOUR = MACTION__DYNAMIC_BEHAVIOUR;

	/**
	 * The feature id for the '<em><b>Maction Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION__MACTION_EVENTS = MACTION__MACTION_EVENTS;

	/**
	 * The number of structural features of the '<em>Other Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION_FEATURE_COUNT = MACTION_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Other Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OTHER_ACTION_OPERATION_COUNT = MACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.ConditionalExpressionImpl <em>Conditional Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.ConditionalExpressionImpl
	 * @see muicm.impl.MuicmPackageImpl#getConditionalExpression()
	 * @generated
	 */
	int CONDITIONAL_EXPRESSION = 54;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_EXPRESSION__NAME = MEXPRESSION__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_EXPRESSION__DATAS = MEXPRESSION__DATAS;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_EXPRESSION__EXPRESSION = MEXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Conditional Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_EXPRESSION_FEATURE_COUNT = MEXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Conditional Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_EXPRESSION_OPERATION_COUNT = MEXPRESSION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.StaticContentImpl <em>Static Content</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.StaticContentImpl
	 * @see muicm.impl.MuicmPackageImpl#getStaticContent()
	 * @generated
	 */
	int STATIC_CONTENT = 55;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT__NAME = CONTENT_BINDING__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT__DATAS = CONTENT_BINDING__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT__SUB_MVIEW_COMPONENT_PART = CONTENT_BINDING__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Conditional Expressions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT__CONDITIONAL_EXPRESSIONS = CONTENT_BINDING_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Domain Concept</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT__DOMAIN_CONCEPT = CONTENT_BINDING_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Attributes</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT__ATTRIBUTES = CONTENT_BINDING_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Static Content</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT_FEATURE_COUNT = CONTENT_BINDING_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Static Content</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_CONTENT_OPERATION_COUNT = CONTENT_BINDING_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.DynamicBehaviourImpl <em>Dynamic Behaviour</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.DynamicBehaviourImpl
	 * @see muicm.impl.MuicmPackageImpl#getDynamicBehaviour()
	 * @generated
	 */
	int DYNAMIC_BEHAVIOUR = 56;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_BEHAVIOUR__NAME = CONTENT_BINDING__NAME;

	/**
	 * The feature id for the '<em><b>Datas</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_BEHAVIOUR__DATAS = CONTENT_BINDING__DATAS;

	/**
	 * The feature id for the '<em><b>Sub MView Component Part</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_BEHAVIOUR__SUB_MVIEW_COMPONENT_PART = CONTENT_BINDING__SUB_MVIEW_COMPONENT_PART;

	/**
	 * The feature id for the '<em><b>Behaviour Concept</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_BEHAVIOUR__BEHAVIOUR_CONCEPT = CONTENT_BINDING_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Dynamic Behaviour</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_BEHAVIOUR_FEATURE_COUNT = CONTENT_BINDING_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Dynamic Behaviour</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DYNAMIC_BEHAVIOUR_OPERATION_COUNT = CONTENT_BINDING_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.ContentModelImpl <em>Content Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.ContentModelImpl
	 * @see muicm.impl.MuicmPackageImpl#getContentModel()
	 * @generated
	 */
	int CONTENT_MODEL = 57;

	/**
	 * The feature id for the '<em><b>Content Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_MODEL__CONTENT_ELEMENTS = 0;

	/**
	 * The number of structural features of the '<em>Content Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_MODEL_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Content Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_MODEL_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link muicm.impl.ContentElementImpl <em>Content Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.ContentElementImpl
	 * @see muicm.impl.MuicmPackageImpl#getContentElement()
	 * @generated
	 */
	int CONTENT_ELEMENT = 58;

	/**
	 * The number of structural features of the '<em>Content Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_ELEMENT_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Content Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link muicm.impl.BehaviourConceptImpl <em>Behaviour Concept</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.BehaviourConceptImpl
	 * @see muicm.impl.MuicmPackageImpl#getBehaviourConcept()
	 * @generated
	 */
	int BEHAVIOUR_CONCEPT = 59;

	/**
	 * The number of structural features of the '<em>Behaviour Concept</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIOUR_CONCEPT_FEATURE_COUNT = CONTENT_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Behaviour Concept</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BEHAVIOUR_CONCEPT_OPERATION_COUNT = CONTENT_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.DomainConceptImpl <em>Domain Concept</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.DomainConceptImpl
	 * @see muicm.impl.MuicmPackageImpl#getDomainConcept()
	 * @generated
	 */
	int DOMAIN_CONCEPT = 60;

	/**
	 * The number of structural features of the '<em>Domain Concept</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOMAIN_CONCEPT_FEATURE_COUNT = CONTENT_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Domain Concept</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOMAIN_CONCEPT_OPERATION_COUNT = CONTENT_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.FeatureConceptImpl <em>Feature Concept</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.FeatureConceptImpl
	 * @see muicm.impl.MuicmPackageImpl#getFeatureConcept()
	 * @generated
	 */
	int FEATURE_CONCEPT = 61;

	/**
	 * The number of structural features of the '<em>Feature Concept</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONCEPT_FEATURE_COUNT = CONTENT_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Feature Concept</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FEATURE_CONCEPT_OPERATION_COUNT = CONTENT_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link muicm.impl.AttributeImpl <em>Attribute</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.impl.AttributeImpl
	 * @see muicm.impl.MuicmPackageImpl#getAttribute()
	 * @generated
	 */
	int ATTRIBUTE = 62;

	/**
	 * The feature id for the '<em><b>Feature Concept</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__FEATURE_CONCEPT = 0;

	/**
	 * The number of structural features of the '<em>Attribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Attribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link muicm.DataType <em>Data Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.DataType
	 * @see muicm.impl.MuicmPackageImpl#getDataType()
	 * @generated
	 */
	int DATA_TYPE = 63;

	/**
	 * The meta object id for the '{@link muicm.MeidaType <em>Meida Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.MeidaType
	 * @see muicm.impl.MuicmPackageImpl#getMeidaType()
	 * @generated
	 */
	int MEIDA_TYPE = 64;

	/**
	 * The meta object id for the '{@link muicm.SwipeDirection <em>Swipe Direction</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.SwipeDirection
	 * @see muicm.impl.MuicmPackageImpl#getSwipeDirection()
	 * @generated
	 */
	int SWIPE_DIRECTION = 65;

	/**
	 * The meta object id for the '{@link muicm.CodeType <em>Code Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.CodeType
	 * @see muicm.impl.MuicmPackageImpl#getCodeType()
	 * @generated
	 */
	int CODE_TYPE = 66;


	/**
	 * The meta object id for the '{@link muicm.EventType <em>Event Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.EventType
	 * @see muicm.impl.MuicmPackageImpl#getEventType()
	 * @generated
	 */
	int EVENT_TYPE = 67;

	/**
	 * The meta object id for the '{@link muicm.DirType <em>Dir Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see muicm.DirType
	 * @see muicm.impl.MuicmPackageImpl#getDirType()
	 * @generated
	 */
	int DIR_TYPE = 68;


	/**
	 * Returns the meta object for class '{@link muicm.MUICM <em>MUICM</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MUICM</em>'.
	 * @see muicm.MUICM
	 * @generated
	 */
	EClass getMUICM();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MUICM#getMuicmElements <em>Muicm Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Muicm Elements</em>'.
	 * @see muicm.MUICM#getMuicmElements()
	 * @see #getMUICM()
	 * @generated
	 */
	EReference getMUICM_MuicmElements();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MUICM#getContentmodel <em>Contentmodel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contentmodel</em>'.
	 * @see muicm.MUICM#getContentmodel()
	 * @see #getMUICM()
	 * @generated
	 */
	EReference getMUICM_Contentmodel();

	/**
	 * Returns the meta object for class '{@link muicm.MUICMElement <em>MUICM Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MUICM Element</em>'.
	 * @see muicm.MUICMElement
	 * @generated
	 */
	EClass getMUICMElement();

	/**
	 * Returns the meta object for the attribute '{@link muicm.MUICMElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see muicm.MUICMElement#getName()
	 * @see #getMUICMElement()
	 * @generated
	 */
	EAttribute getMUICMElement_Name();

	/**
	 * Returns the meta object for class '{@link muicm.MInteractionFlow <em>MInteraction Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MInteraction Flow</em>'.
	 * @see muicm.MInteractionFlow
	 * @generated
	 */
	EClass getMInteractionFlow();

	/**
	 * Returns the meta object for the reference '{@link muicm.MInteractionFlow#getSourceInteractionElement <em>Source Interaction Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source Interaction Element</em>'.
	 * @see muicm.MInteractionFlow#getSourceInteractionElement()
	 * @see #getMInteractionFlow()
	 * @generated
	 */
	EReference getMInteractionFlow_SourceInteractionElement();

	/**
	 * Returns the meta object for the reference '{@link muicm.MInteractionFlow#getTargetInteractionElement <em>Target Interaction Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target Interaction Element</em>'.
	 * @see muicm.MInteractionFlow#getTargetInteractionElement()
	 * @see #getMInteractionFlow()
	 * @generated
	 */
	EReference getMInteractionFlow_TargetInteractionElement();

	/**
	 * Returns the meta object for the reference '{@link muicm.MInteractionFlow#getDataBindingGroup <em>Data Binding Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Binding Group</em>'.
	 * @see muicm.MInteractionFlow#getDataBindingGroup()
	 * @see #getMInteractionFlow()
	 * @generated
	 */
	EReference getMInteractionFlow_DataBindingGroup();

	/**
	 * Returns the meta object for the attribute '{@link muicm.MInteractionFlow#getSourceElementName <em>Source Element Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Element Name</em>'.
	 * @see muicm.MInteractionFlow#getSourceElementName()
	 * @see #getMInteractionFlow()
	 * @generated
	 */
	EAttribute getMInteractionFlow_SourceElementName();

	/**
	 * Returns the meta object for the attribute '{@link muicm.MInteractionFlow#getTargetElementName <em>Target Element Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Target Element Name</em>'.
	 * @see muicm.MInteractionFlow#getTargetElementName()
	 * @see #getMInteractionFlow()
	 * @generated
	 */
	EAttribute getMInteractionFlow_TargetElementName();

	/**
	 * Returns the meta object for class '{@link muicm.NavigationFlow <em>Navigation Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Navigation Flow</em>'.
	 * @see muicm.NavigationFlow
	 * @generated
	 */
	EClass getNavigationFlow();

	/**
	 * Returns the meta object for class '{@link muicm.DataFlow <em>Data Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Flow</em>'.
	 * @see muicm.DataFlow
	 * @generated
	 */
	EClass getDataFlow();

	/**
	 * Returns the meta object for class '{@link muicm.MInteractionElement <em>MInteraction Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MInteraction Element</em>'.
	 * @see muicm.MInteractionElement
	 * @generated
	 */
	EClass getMInteractionElement();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MInteractionElement#getDatas <em>Datas</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Datas</em>'.
	 * @see muicm.MInteractionElement#getDatas()
	 * @see #getMInteractionElement()
	 * @generated
	 */
	EReference getMInteractionElement_Datas();

	/**
	 * Returns the meta object for class '{@link muicm.DataBindingGroup <em>Data Binding Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Binding Group</em>'.
	 * @see muicm.DataBindingGroup
	 * @generated
	 */
	EClass getDataBindingGroup();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.DataBindingGroup#getDataBindings <em>Data Bindings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Data Bindings</em>'.
	 * @see muicm.DataBindingGroup#getDataBindings()
	 * @see #getDataBindingGroup()
	 * @generated
	 */
	EReference getDataBindingGroup_DataBindings();

	/**
	 * Returns the meta object for class '{@link muicm.DataBinding <em>Data Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Binding</em>'.
	 * @see muicm.DataBinding
	 * @generated
	 */
	EClass getDataBinding();

	/**
	 * Returns the meta object for the reference '{@link muicm.DataBinding#getSourceData <em>Source Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source Data</em>'.
	 * @see muicm.DataBinding#getSourceData()
	 * @see #getDataBinding()
	 * @generated
	 */
	EReference getDataBinding_SourceData();

	/**
	 * Returns the meta object for the reference '{@link muicm.DataBinding#getTargetData <em>Target Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target Data</em>'.
	 * @see muicm.DataBinding#getTargetData()
	 * @see #getDataBinding()
	 * @generated
	 */
	EReference getDataBinding_TargetData();

	/**
	 * Returns the meta object for the attribute '{@link muicm.DataBinding#getSourceDataName <em>Source Data Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Data Name</em>'.
	 * @see muicm.DataBinding#getSourceDataName()
	 * @see #getDataBinding()
	 * @generated
	 */
	EAttribute getDataBinding_SourceDataName();

	/**
	 * Returns the meta object for the attribute '{@link muicm.DataBinding#getTargetDataName <em>Target Data Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Target Data Name</em>'.
	 * @see muicm.DataBinding#getTargetDataName()
	 * @see #getDataBinding()
	 * @generated
	 */
	EAttribute getDataBinding_TargetDataName();

	/**
	 * Returns the meta object for class '{@link muicm.Data <em>Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data</em>'.
	 * @see muicm.Data
	 * @generated
	 */
	EClass getData();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Data#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see muicm.Data#getType()
	 * @see #getData()
	 * @generated
	 */
	EAttribute getData_Type();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Data#getDirType <em>Dir Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dir Type</em>'.
	 * @see muicm.Data#getDirType()
	 * @see #getData()
	 * @generated
	 */
	EAttribute getData_DirType();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Data#isVisual <em>Visual</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Visual</em>'.
	 * @see muicm.Data#isVisual()
	 * @see #getData()
	 * @generated
	 */
	EAttribute getData_Visual();

	/**
	 * Returns the meta object for class '{@link muicm.MViewElement <em>MView Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MView Element</em>'.
	 * @see muicm.MViewElement
	 * @generated
	 */
	EClass getMViewElement();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MViewElement#getMviewElementEvents <em>Mview Element Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mview Element Events</em>'.
	 * @see muicm.MViewElement#getMviewElementEvents()
	 * @see #getMViewElement()
	 * @generated
	 */
	EReference getMViewElement_MviewElementEvents();

	/**
	 * Returns the meta object for class '{@link muicm.Screen <em>Screen</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Screen</em>'.
	 * @see muicm.Screen
	 * @generated
	 */
	EClass getScreen();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Screen#isIsModal <em>Is Modal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Modal</em>'.
	 * @see muicm.Screen#isIsModal()
	 * @see #getScreen()
	 * @generated
	 */
	EAttribute getScreen_IsModal();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Screen#isHasNav <em>Has Nav</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Has Nav</em>'.
	 * @see muicm.Screen#isHasNav()
	 * @see #getScreen()
	 * @generated
	 */
	EAttribute getScreen_HasNav();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Screen#isIsHome <em>Is Home</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Home</em>'.
	 * @see muicm.Screen#isIsHome()
	 * @see #getScreen()
	 * @generated
	 */
	EAttribute getScreen_IsHome();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.Screen#getMviewElements <em>Mview Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mview Elements</em>'.
	 * @see muicm.Screen#getMviewElements()
	 * @see #getScreen()
	 * @generated
	 */
	EReference getScreen_MviewElements();

	/**
	 * Returns the meta object for class '{@link muicm.MviewComponentExt <em>Mview Component Ext</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mview Component Ext</em>'.
	 * @see muicm.MviewComponentExt
	 * @generated
	 */
	EClass getMviewComponentExt();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MviewComponentExt#getMviewComponentParts <em>Mview Component Parts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mview Component Parts</em>'.
	 * @see muicm.MviewComponentExt#getMviewComponentParts()
	 * @see #getMviewComponentExt()
	 * @generated
	 */
	EReference getMviewComponentExt_MviewComponentParts();

	/**
	 * Returns the meta object for class '{@link muicm.MViewComponent <em>MView Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MView Component</em>'.
	 * @see muicm.MViewComponent
	 * @generated
	 */
	EClass getMViewComponent();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MViewComponent#getMviewComponentParts <em>Mview Component Parts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mview Component Parts</em>'.
	 * @see muicm.MViewComponent#getMviewComponentParts()
	 * @see #getMViewComponent()
	 * @generated
	 */
	EReference getMViewComponent_MviewComponentParts();

	/**
	 * Returns the meta object for class '{@link muicm.SearchView <em>Search View</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Search View</em>'.
	 * @see muicm.SearchView
	 * @generated
	 */
	EClass getSearchView();

	/**
	 * Returns the meta object for class '{@link muicm.List <em>List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>List</em>'.
	 * @see muicm.List
	 * @generated
	 */
	EClass getList();

	/**
	 * Returns the meta object for class '{@link muicm.ToolBar <em>Tool Bar</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tool Bar</em>'.
	 * @see muicm.ToolBar
	 * @generated
	 */
	EClass getToolBar();

	/**
	 * Returns the meta object for class '{@link muicm.Form <em>Form</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Form</em>'.
	 * @see muicm.Form
	 * @generated
	 */
	EClass getForm();

	/**
	 * Returns the meta object for class '{@link muicm.Message <em>Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Message</em>'.
	 * @see muicm.Message
	 * @generated
	 */
	EClass getMessage();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Message#getText <em>Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Text</em>'.
	 * @see muicm.Message#getText()
	 * @see #getMessage()
	 * @generated
	 */
	EAttribute getMessage_Text();

	/**
	 * Returns the meta object for class '{@link muicm.Details <em>Details</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Details</em>'.
	 * @see muicm.Details
	 * @generated
	 */
	EClass getDetails();

	/**
	 * Returns the meta object for class '{@link muicm.UtilityView <em>Utility View</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Utility View</em>'.
	 * @see muicm.UtilityView
	 * @generated
	 */
	EClass getUtilityView();

	/**
	 * Returns the meta object for class '{@link muicm.MViewComponentPartAbstract <em>MView Component Part Abstract</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MView Component Part Abstract</em>'.
	 * @see muicm.MViewComponentPartAbstract
	 * @generated
	 */
	EClass getMViewComponentPartAbstract();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MViewComponentPartAbstract#getSubMViewComponentPart <em>Sub MView Component Part</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sub MView Component Part</em>'.
	 * @see muicm.MViewComponentPartAbstract#getSubMViewComponentPart()
	 * @see #getMViewComponentPartAbstract()
	 * @generated
	 */
	EReference getMViewComponentPartAbstract_SubMViewComponentPart();

	/**
	 * Returns the meta object for class '{@link muicm.Field <em>Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Field</em>'.
	 * @see muicm.Field
	 * @generated
	 */
	EClass getField();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Field#getContent <em>Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Content</em>'.
	 * @see muicm.Field#getContent()
	 * @see #getField()
	 * @generated
	 */
	EAttribute getField_Content();

	/**
	 * Returns the meta object for class '{@link muicm.SimpleField <em>Simple Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Simple Field</em>'.
	 * @see muicm.SimpleField
	 * @generated
	 */
	EClass getSimpleField();

	/**
	 * Returns the meta object for class '{@link muicm.SelectionField <em>Selection Field</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Selection Field</em>'.
	 * @see muicm.SelectionField
	 * @generated
	 */
	EClass getSelectionField();

	/**
	 * Returns the meta object for the attribute '{@link muicm.SelectionField#isIsMultiSelection <em>Is Multi Selection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Multi Selection</em>'.
	 * @see muicm.SelectionField#isIsMultiSelection()
	 * @see #getSelectionField()
	 * @generated
	 */
	EAttribute getSelectionField_IsMultiSelection();

	/**
	 * Returns the meta object for class '{@link muicm.TextBox <em>Text Box</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Text Box</em>'.
	 * @see muicm.TextBox
	 * @generated
	 */
	EClass getTextBox();

	/**
	 * Returns the meta object for the attribute '{@link muicm.TextBox#getText <em>Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Text</em>'.
	 * @see muicm.TextBox#getText()
	 * @see #getTextBox()
	 * @generated
	 */
	EAttribute getTextBox_Text();

	/**
	 * Returns the meta object for class '{@link muicm.Media <em>Media</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Media</em>'.
	 * @see muicm.Media
	 * @generated
	 */
	EClass getMedia();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Media#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see muicm.Media#getType()
	 * @see #getMedia()
	 * @generated
	 */
	EAttribute getMedia_Type();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Media#getMediaImage <em>Media Image</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Media Image</em>'.
	 * @see muicm.Media#getMediaImage()
	 * @see #getMedia()
	 * @generated
	 */
	EAttribute getMedia_MediaImage();

	/**
	 * Returns the meta object for class '{@link muicm.Label <em>Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Label</em>'.
	 * @see muicm.Label
	 * @generated
	 */
	EClass getLabel();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Label#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see muicm.Label#getDescription()
	 * @see #getLabel()
	 * @generated
	 */
	EAttribute getLabel_Description();

	/**
	 * Returns the meta object for class '{@link muicm.MAction <em>MAction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MAction</em>'.
	 * @see muicm.MAction
	 * @generated
	 */
	EClass getMAction();

	/**
	 * Returns the meta object for the reference '{@link muicm.MAction#getDynamicBehaviour <em>Dynamic Behaviour</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Dynamic Behaviour</em>'.
	 * @see muicm.MAction#getDynamicBehaviour()
	 * @see #getMAction()
	 * @generated
	 */
	EReference getMAction_DynamicBehaviour();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MAction#getMactionEvents <em>Maction Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Maction Events</em>'.
	 * @see muicm.MAction#getMactionEvents()
	 * @see #getMAction()
	 * @generated
	 */
	EReference getMAction_MactionEvents();

	/**
	 * Returns the meta object for class '{@link muicm.Utility <em>Utility</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Utility</em>'.
	 * @see muicm.Utility
	 * @generated
	 */
	EClass getUtility();

	/**
	 * Returns the meta object for class '{@link muicm.Map <em>Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Map</em>'.
	 * @see muicm.Map
	 * @generated
	 */
	EClass getMap();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Map#getProvider <em>Provider</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Provider</em>'.
	 * @see muicm.Map#getProvider()
	 * @see #getMap()
	 * @generated
	 */
	EAttribute getMap_Provider();

	/**
	 * Returns the meta object for class '{@link muicm.Calendar <em>Calendar</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Calendar</em>'.
	 * @see muicm.Calendar
	 * @generated
	 */
	EClass getCalendar();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Calendar#getYearsBlockSize <em>Years Block Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Years Block Size</em>'.
	 * @see muicm.Calendar#getYearsBlockSize()
	 * @see #getCalendar()
	 * @generated
	 */
	EAttribute getCalendar_YearsBlockSize();

	/**
	 * Returns the meta object for class '{@link muicm.Code <em>Code</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Code</em>'.
	 * @see muicm.Code
	 * @generated
	 */
	EClass getCode();

	/**
	 * Returns the meta object for the attribute '{@link muicm.Code#getFormat <em>Format</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Format</em>'.
	 * @see muicm.Code#getFormat()
	 * @see #getCode()
	 * @generated
	 */
	EAttribute getCode_Format();

	/**
	 * Returns the meta object for class '{@link muicm.Icon <em>Icon</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Icon</em>'.
	 * @see muicm.Icon
	 * @generated
	 */
	EClass getIcon();

	/**
	 * Returns the meta object for class '{@link muicm.ContentBinding <em>Content Binding</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Content Binding</em>'.
	 * @see muicm.ContentBinding
	 * @generated
	 */
	EClass getContentBinding();

	/**
	 * Returns the meta object for class '{@link muicm.MEvent <em>MEvent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MEvent</em>'.
	 * @see muicm.MEvent
	 * @generated
	 */
	EClass getMEvent();

	/**
	 * Returns the meta object for class '{@link muicm.MViewElementEventAbstract <em>MView Element Event Abstract</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MView Element Event Abstract</em>'.
	 * @see muicm.MViewElementEventAbstract
	 * @generated
	 */
	EClass getMViewElementEventAbstract();

	/**
	 * Returns the meta object for the attribute '{@link muicm.MViewElementEventAbstract#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see muicm.MViewElementEventAbstract#getType()
	 * @see #getMViewElementEventAbstract()
	 * @generated
	 */
	EAttribute getMViewElementEventAbstract_Type();

	/**
	 * Returns the meta object for class '{@link muicm.MViewComponentPart <em>MView Component Part</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MView Component Part</em>'.
	 * @see muicm.MViewComponentPart
	 * @generated
	 */
	EClass getMViewComponentPart();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.MViewComponentPart#getMviewelementevent <em>Mviewelementevent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mviewelementevent</em>'.
	 * @see muicm.MViewComponentPart#getMviewelementevent()
	 * @see #getMViewComponentPart()
	 * @generated
	 */
	EReference getMViewComponentPart_Mviewelementevent();

	/**
	 * Returns the meta object for class '{@link muicm.MViewElementEvent <em>MView Element Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MView Element Event</em>'.
	 * @see muicm.MViewElementEvent
	 * @generated
	 */
	EClass getMViewElementEvent();

	/**
	 * Returns the meta object for class '{@link muicm.PinchEvent <em>Pinch Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pinch Event</em>'.
	 * @see muicm.PinchEvent
	 * @generated
	 */
	EClass getPinchEvent();

	/**
	 * Returns the meta object for class '{@link muicm.RotateEvent <em>Rotate Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rotate Event</em>'.
	 * @see muicm.RotateEvent
	 * @generated
	 */
	EClass getRotateEvent();

	/**
	 * Returns the meta object for class '{@link muicm.TapEvent <em>Tap Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tap Event</em>'.
	 * @see muicm.TapEvent
	 * @generated
	 */
	EClass getTapEvent();

	/**
	 * Returns the meta object for class '{@link muicm.SystemEvent <em>System Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Event</em>'.
	 * @see muicm.SystemEvent
	 * @generated
	 */
	EClass getSystemEvent();

	/**
	 * Returns the meta object for class '{@link muicm.PanEvent <em>Pan Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pan Event</em>'.
	 * @see muicm.PanEvent
	 * @generated
	 */
	EClass getPanEvent();

	/**
	 * Returns the meta object for class '{@link muicm.TouchEvent <em>Touch Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Touch Event</em>'.
	 * @see muicm.TouchEvent
	 * @generated
	 */
	EClass getTouchEvent();

	/**
	 * Returns the meta object for class '{@link muicm.LongPressEvent <em>Long Press Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Long Press Event</em>'.
	 * @see muicm.LongPressEvent
	 * @generated
	 */
	EClass getLongPressEvent();

	/**
	 * Returns the meta object for the attribute '{@link muicm.LongPressEvent#getFingerCount <em>Finger Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Finger Count</em>'.
	 * @see muicm.LongPressEvent#getFingerCount()
	 * @see #getLongPressEvent()
	 * @generated
	 */
	EAttribute getLongPressEvent_FingerCount();

	/**
	 * Returns the meta object for the attribute '{@link muicm.LongPressEvent#getPressDuration <em>Press Duration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Press Duration</em>'.
	 * @see muicm.LongPressEvent#getPressDuration()
	 * @see #getLongPressEvent()
	 * @generated
	 */
	EAttribute getLongPressEvent_PressDuration();

	/**
	 * Returns the meta object for class '{@link muicm.SwipeEvent <em>Swipe Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Swipe Event</em>'.
	 * @see muicm.SwipeEvent
	 * @generated
	 */
	EClass getSwipeEvent();

	/**
	 * Returns the meta object for the attribute '{@link muicm.SwipeEvent#getDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Direction</em>'.
	 * @see muicm.SwipeEvent#getDirection()
	 * @see #getSwipeEvent()
	 * @generated
	 */
	EAttribute getSwipeEvent_Direction();

	/**
	 * Returns the meta object for class '{@link muicm.MActionEvent <em>MAction Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MAction Event</em>'.
	 * @see muicm.MActionEvent
	 * @generated
	 */
	EClass getMActionEvent();

	/**
	 * Returns the meta object for the attribute '{@link muicm.MActionEvent#isExecuteResult <em>Execute Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Execute Result</em>'.
	 * @see muicm.MActionEvent#isExecuteResult()
	 * @see #getMActionEvent()
	 * @generated
	 */
	EAttribute getMActionEvent_ExecuteResult();

	/**
	 * Returns the meta object for class '{@link muicm.CameraActionEvent <em>Camera Action Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Camera Action Event</em>'.
	 * @see muicm.CameraActionEvent
	 * @generated
	 */
	EClass getCameraActionEvent();

	/**
	 * Returns the meta object for class '{@link muicm.MicrophoneActionEvent <em>Microphone Action Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Microphone Action Event</em>'.
	 * @see muicm.MicrophoneActionEvent
	 * @generated
	 */
	EClass getMicrophoneActionEvent();

	/**
	 * Returns the meta object for class '{@link muicm.OtherActionEvent <em>Other Action Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Other Action Event</em>'.
	 * @see muicm.OtherActionEvent
	 * @generated
	 */
	EClass getOtherActionEvent();

	/**
	 * Returns the meta object for class '{@link muicm.MExpression <em>MExpression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MExpression</em>'.
	 * @see muicm.MExpression
	 * @generated
	 */
	EClass getMExpression();

	/**
	 * Returns the meta object for class '{@link muicm.CameraAction <em>Camera Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Camera Action</em>'.
	 * @see muicm.CameraAction
	 * @generated
	 */
	EClass getCameraAction();

	/**
	 * Returns the meta object for class '{@link muicm.MicrophoneAction <em>Microphone Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Microphone Action</em>'.
	 * @see muicm.MicrophoneAction
	 * @generated
	 */
	EClass getMicrophoneAction();

	/**
	 * Returns the meta object for class '{@link muicm.OtherAction <em>Other Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Other Action</em>'.
	 * @see muicm.OtherAction
	 * @generated
	 */
	EClass getOtherAction();

	/**
	 * Returns the meta object for class '{@link muicm.ConditionalExpression <em>Conditional Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conditional Expression</em>'.
	 * @see muicm.ConditionalExpression
	 * @generated
	 */
	EClass getConditionalExpression();

	/**
	 * Returns the meta object for the attribute '{@link muicm.ConditionalExpression#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Expression</em>'.
	 * @see muicm.ConditionalExpression#getExpression()
	 * @see #getConditionalExpression()
	 * @generated
	 */
	EAttribute getConditionalExpression_Expression();

	/**
	 * Returns the meta object for class '{@link muicm.StaticContent <em>Static Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Static Content</em>'.
	 * @see muicm.StaticContent
	 * @generated
	 */
	EClass getStaticContent();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.StaticContent#getConditionalExpressions <em>Conditional Expressions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Conditional Expressions</em>'.
	 * @see muicm.StaticContent#getConditionalExpressions()
	 * @see #getStaticContent()
	 * @generated
	 */
	EReference getStaticContent_ConditionalExpressions();

	/**
	 * Returns the meta object for the reference '{@link muicm.StaticContent#getDomainConcept <em>Domain Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Domain Concept</em>'.
	 * @see muicm.StaticContent#getDomainConcept()
	 * @see #getStaticContent()
	 * @generated
	 */
	EReference getStaticContent_DomainConcept();

	/**
	 * Returns the meta object for the reference '{@link muicm.StaticContent#getAttributes <em>Attributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Attributes</em>'.
	 * @see muicm.StaticContent#getAttributes()
	 * @see #getStaticContent()
	 * @generated
	 */
	EReference getStaticContent_Attributes();

	/**
	 * Returns the meta object for class '{@link muicm.DynamicBehaviour <em>Dynamic Behaviour</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dynamic Behaviour</em>'.
	 * @see muicm.DynamicBehaviour
	 * @generated
	 */
	EClass getDynamicBehaviour();

	/**
	 * Returns the meta object for the reference '{@link muicm.DynamicBehaviour#getBehaviourConcept <em>Behaviour Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Behaviour Concept</em>'.
	 * @see muicm.DynamicBehaviour#getBehaviourConcept()
	 * @see #getDynamicBehaviour()
	 * @generated
	 */
	EReference getDynamicBehaviour_BehaviourConcept();

	/**
	 * Returns the meta object for class '{@link muicm.ContentModel <em>Content Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Content Model</em>'.
	 * @see muicm.ContentModel
	 * @generated
	 */
	EClass getContentModel();

	/**
	 * Returns the meta object for the containment reference list '{@link muicm.ContentModel#getContentElements <em>Content Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Content Elements</em>'.
	 * @see muicm.ContentModel#getContentElements()
	 * @see #getContentModel()
	 * @generated
	 */
	EReference getContentModel_ContentElements();

	/**
	 * Returns the meta object for class '{@link muicm.ContentElement <em>Content Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Content Element</em>'.
	 * @see muicm.ContentElement
	 * @generated
	 */
	EClass getContentElement();

	/**
	 * Returns the meta object for class '{@link muicm.BehaviourConcept <em>Behaviour Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Behaviour Concept</em>'.
	 * @see muicm.BehaviourConcept
	 * @generated
	 */
	EClass getBehaviourConcept();

	/**
	 * Returns the meta object for class '{@link muicm.DomainConcept <em>Domain Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Domain Concept</em>'.
	 * @see muicm.DomainConcept
	 * @generated
	 */
	EClass getDomainConcept();

	/**
	 * Returns the meta object for class '{@link muicm.FeatureConcept <em>Feature Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Concept</em>'.
	 * @see muicm.FeatureConcept
	 * @generated
	 */
	EClass getFeatureConcept();

	/**
	 * Returns the meta object for class '{@link muicm.Attribute <em>Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Attribute</em>'.
	 * @see muicm.Attribute
	 * @generated
	 */
	EClass getAttribute();

	/**
	 * Returns the meta object for the reference '{@link muicm.Attribute#getFeatureConcept <em>Feature Concept</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Feature Concept</em>'.
	 * @see muicm.Attribute#getFeatureConcept()
	 * @see #getAttribute()
	 * @generated
	 */
	EReference getAttribute_FeatureConcept();

	/**
	 * Returns the meta object for enum '{@link muicm.DataType <em>Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Data Type</em>'.
	 * @see muicm.DataType
	 * @generated
	 */
	EEnum getDataType();

	/**
	 * Returns the meta object for enum '{@link muicm.MeidaType <em>Meida Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Meida Type</em>'.
	 * @see muicm.MeidaType
	 * @generated
	 */
	EEnum getMeidaType();

	/**
	 * Returns the meta object for enum '{@link muicm.SwipeDirection <em>Swipe Direction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Swipe Direction</em>'.
	 * @see muicm.SwipeDirection
	 * @generated
	 */
	EEnum getSwipeDirection();

	/**
	 * Returns the meta object for enum '{@link muicm.CodeType <em>Code Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Code Type</em>'.
	 * @see muicm.CodeType
	 * @generated
	 */
	EEnum getCodeType();

	/**
	 * Returns the meta object for enum '{@link muicm.EventType <em>Event Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Event Type</em>'.
	 * @see muicm.EventType
	 * @generated
	 */
	EEnum getEventType();

	/**
	 * Returns the meta object for enum '{@link muicm.DirType <em>Dir Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Dir Type</em>'.
	 * @see muicm.DirType
	 * @generated
	 */
	EEnum getDirType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MuicmFactory getMuicmFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link muicm.impl.MUICMImpl <em>MUICM</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MUICMImpl
		 * @see muicm.impl.MuicmPackageImpl#getMUICM()
		 * @generated
		 */
		EClass MUICM = eINSTANCE.getMUICM();

		/**
		 * The meta object literal for the '<em><b>Muicm Elements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MUICM__MUICM_ELEMENTS = eINSTANCE.getMUICM_MuicmElements();

		/**
		 * The meta object literal for the '<em><b>Contentmodel</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MUICM__CONTENTMODEL = eINSTANCE.getMUICM_Contentmodel();

		/**
		 * The meta object literal for the '{@link muicm.impl.MUICMElementImpl <em>MUICM Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MUICMElementImpl
		 * @see muicm.impl.MuicmPackageImpl#getMUICMElement()
		 * @generated
		 */
		EClass MUICM_ELEMENT = eINSTANCE.getMUICMElement();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MUICM_ELEMENT__NAME = eINSTANCE.getMUICMElement_Name();

		/**
		 * The meta object literal for the '{@link muicm.impl.MInteractionFlowImpl <em>MInteraction Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MInteractionFlowImpl
		 * @see muicm.impl.MuicmPackageImpl#getMInteractionFlow()
		 * @generated
		 */
		EClass MINTERACTION_FLOW = eINSTANCE.getMInteractionFlow();

		/**
		 * The meta object literal for the '<em><b>Source Interaction Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MINTERACTION_FLOW__SOURCE_INTERACTION_ELEMENT = eINSTANCE.getMInteractionFlow_SourceInteractionElement();

		/**
		 * The meta object literal for the '<em><b>Target Interaction Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MINTERACTION_FLOW__TARGET_INTERACTION_ELEMENT = eINSTANCE.getMInteractionFlow_TargetInteractionElement();

		/**
		 * The meta object literal for the '<em><b>Data Binding Group</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MINTERACTION_FLOW__DATA_BINDING_GROUP = eINSTANCE.getMInteractionFlow_DataBindingGroup();

		/**
		 * The meta object literal for the '<em><b>Source Element Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MINTERACTION_FLOW__SOURCE_ELEMENT_NAME = eINSTANCE.getMInteractionFlow_SourceElementName();

		/**
		 * The meta object literal for the '<em><b>Target Element Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MINTERACTION_FLOW__TARGET_ELEMENT_NAME = eINSTANCE.getMInteractionFlow_TargetElementName();

		/**
		 * The meta object literal for the '{@link muicm.impl.NavigationFlowImpl <em>Navigation Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.NavigationFlowImpl
		 * @see muicm.impl.MuicmPackageImpl#getNavigationFlow()
		 * @generated
		 */
		EClass NAVIGATION_FLOW = eINSTANCE.getNavigationFlow();

		/**
		 * The meta object literal for the '{@link muicm.impl.DataFlowImpl <em>Data Flow</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.DataFlowImpl
		 * @see muicm.impl.MuicmPackageImpl#getDataFlow()
		 * @generated
		 */
		EClass DATA_FLOW = eINSTANCE.getDataFlow();

		/**
		 * The meta object literal for the '{@link muicm.impl.MInteractionElementImpl <em>MInteraction Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MInteractionElementImpl
		 * @see muicm.impl.MuicmPackageImpl#getMInteractionElement()
		 * @generated
		 */
		EClass MINTERACTION_ELEMENT = eINSTANCE.getMInteractionElement();

		/**
		 * The meta object literal for the '<em><b>Datas</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MINTERACTION_ELEMENT__DATAS = eINSTANCE.getMInteractionElement_Datas();

		/**
		 * The meta object literal for the '{@link muicm.impl.DataBindingGroupImpl <em>Data Binding Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.DataBindingGroupImpl
		 * @see muicm.impl.MuicmPackageImpl#getDataBindingGroup()
		 * @generated
		 */
		EClass DATA_BINDING_GROUP = eINSTANCE.getDataBindingGroup();

		/**
		 * The meta object literal for the '<em><b>Data Bindings</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_BINDING_GROUP__DATA_BINDINGS = eINSTANCE.getDataBindingGroup_DataBindings();

		/**
		 * The meta object literal for the '{@link muicm.impl.DataBindingImpl <em>Data Binding</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.DataBindingImpl
		 * @see muicm.impl.MuicmPackageImpl#getDataBinding()
		 * @generated
		 */
		EClass DATA_BINDING = eINSTANCE.getDataBinding();

		/**
		 * The meta object literal for the '<em><b>Source Data</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_BINDING__SOURCE_DATA = eINSTANCE.getDataBinding_SourceData();

		/**
		 * The meta object literal for the '<em><b>Target Data</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DATA_BINDING__TARGET_DATA = eINSTANCE.getDataBinding_TargetData();

		/**
		 * The meta object literal for the '<em><b>Source Data Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_BINDING__SOURCE_DATA_NAME = eINSTANCE.getDataBinding_SourceDataName();

		/**
		 * The meta object literal for the '<em><b>Target Data Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA_BINDING__TARGET_DATA_NAME = eINSTANCE.getDataBinding_TargetDataName();

		/**
		 * The meta object literal for the '{@link muicm.impl.DataImpl <em>Data</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.DataImpl
		 * @see muicm.impl.MuicmPackageImpl#getData()
		 * @generated
		 */
		EClass DATA = eINSTANCE.getData();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA__TYPE = eINSTANCE.getData_Type();

		/**
		 * The meta object literal for the '<em><b>Dir Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA__DIR_TYPE = eINSTANCE.getData_DirType();

		/**
		 * The meta object literal for the '<em><b>Visual</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DATA__VISUAL = eINSTANCE.getData_Visual();

		/**
		 * The meta object literal for the '{@link muicm.impl.MViewElementImpl <em>MView Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MViewElementImpl
		 * @see muicm.impl.MuicmPackageImpl#getMViewElement()
		 * @generated
		 */
		EClass MVIEW_ELEMENT = eINSTANCE.getMViewElement();

		/**
		 * The meta object literal for the '<em><b>Mview Element Events</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MVIEW_ELEMENT__MVIEW_ELEMENT_EVENTS = eINSTANCE.getMViewElement_MviewElementEvents();

		/**
		 * The meta object literal for the '{@link muicm.impl.ScreenImpl <em>Screen</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.ScreenImpl
		 * @see muicm.impl.MuicmPackageImpl#getScreen()
		 * @generated
		 */
		EClass SCREEN = eINSTANCE.getScreen();

		/**
		 * The meta object literal for the '<em><b>Is Modal</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCREEN__IS_MODAL = eINSTANCE.getScreen_IsModal();

		/**
		 * The meta object literal for the '<em><b>Has Nav</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCREEN__HAS_NAV = eINSTANCE.getScreen_HasNav();

		/**
		 * The meta object literal for the '<em><b>Is Home</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SCREEN__IS_HOME = eINSTANCE.getScreen_IsHome();

		/**
		 * The meta object literal for the '<em><b>Mview Elements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SCREEN__MVIEW_ELEMENTS = eINSTANCE.getScreen_MviewElements();

		/**
		 * The meta object literal for the '{@link muicm.impl.MviewComponentExtImpl <em>Mview Component Ext</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MviewComponentExtImpl
		 * @see muicm.impl.MuicmPackageImpl#getMviewComponentExt()
		 * @generated
		 */
		EClass MVIEW_COMPONENT_EXT = eINSTANCE.getMviewComponentExt();

		/**
		 * The meta object literal for the '<em><b>Mview Component Parts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MVIEW_COMPONENT_EXT__MVIEW_COMPONENT_PARTS = eINSTANCE.getMviewComponentExt_MviewComponentParts();

		/**
		 * The meta object literal for the '{@link muicm.impl.MViewComponentImpl <em>MView Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MViewComponentImpl
		 * @see muicm.impl.MuicmPackageImpl#getMViewComponent()
		 * @generated
		 */
		EClass MVIEW_COMPONENT = eINSTANCE.getMViewComponent();

		/**
		 * The meta object literal for the '<em><b>Mview Component Parts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MVIEW_COMPONENT__MVIEW_COMPONENT_PARTS = eINSTANCE.getMViewComponent_MviewComponentParts();

		/**
		 * The meta object literal for the '{@link muicm.impl.SearchViewImpl <em>Search View</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.SearchViewImpl
		 * @see muicm.impl.MuicmPackageImpl#getSearchView()
		 * @generated
		 */
		EClass SEARCH_VIEW = eINSTANCE.getSearchView();

		/**
		 * The meta object literal for the '{@link muicm.impl.ListImpl <em>List</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.ListImpl
		 * @see muicm.impl.MuicmPackageImpl#getList()
		 * @generated
		 */
		EClass LIST = eINSTANCE.getList();

		/**
		 * The meta object literal for the '{@link muicm.impl.ToolBarImpl <em>Tool Bar</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.ToolBarImpl
		 * @see muicm.impl.MuicmPackageImpl#getToolBar()
		 * @generated
		 */
		EClass TOOL_BAR = eINSTANCE.getToolBar();

		/**
		 * The meta object literal for the '{@link muicm.impl.FormImpl <em>Form</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.FormImpl
		 * @see muicm.impl.MuicmPackageImpl#getForm()
		 * @generated
		 */
		EClass FORM = eINSTANCE.getForm();

		/**
		 * The meta object literal for the '{@link muicm.impl.MessageImpl <em>Message</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MessageImpl
		 * @see muicm.impl.MuicmPackageImpl#getMessage()
		 * @generated
		 */
		EClass MESSAGE = eINSTANCE.getMessage();

		/**
		 * The meta object literal for the '<em><b>Text</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE__TEXT = eINSTANCE.getMessage_Text();

		/**
		 * The meta object literal for the '{@link muicm.impl.DetailsImpl <em>Details</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.DetailsImpl
		 * @see muicm.impl.MuicmPackageImpl#getDetails()
		 * @generated
		 */
		EClass DETAILS = eINSTANCE.getDetails();

		/**
		 * The meta object literal for the '{@link muicm.impl.UtilityViewImpl <em>Utility View</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.UtilityViewImpl
		 * @see muicm.impl.MuicmPackageImpl#getUtilityView()
		 * @generated
		 */
		EClass UTILITY_VIEW = eINSTANCE.getUtilityView();

		/**
		 * The meta object literal for the '{@link muicm.impl.MViewComponentPartAbstractImpl <em>MView Component Part Abstract</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MViewComponentPartAbstractImpl
		 * @see muicm.impl.MuicmPackageImpl#getMViewComponentPartAbstract()
		 * @generated
		 */
		EClass MVIEW_COMPONENT_PART_ABSTRACT = eINSTANCE.getMViewComponentPartAbstract();

		/**
		 * The meta object literal for the '<em><b>Sub MView Component Part</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MVIEW_COMPONENT_PART_ABSTRACT__SUB_MVIEW_COMPONENT_PART = eINSTANCE.getMViewComponentPartAbstract_SubMViewComponentPart();

		/**
		 * The meta object literal for the '{@link muicm.impl.FieldImpl <em>Field</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.FieldImpl
		 * @see muicm.impl.MuicmPackageImpl#getField()
		 * @generated
		 */
		EClass FIELD = eINSTANCE.getField();

		/**
		 * The meta object literal for the '<em><b>Content</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FIELD__CONTENT = eINSTANCE.getField_Content();

		/**
		 * The meta object literal for the '{@link muicm.impl.SimpleFieldImpl <em>Simple Field</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.SimpleFieldImpl
		 * @see muicm.impl.MuicmPackageImpl#getSimpleField()
		 * @generated
		 */
		EClass SIMPLE_FIELD = eINSTANCE.getSimpleField();

		/**
		 * The meta object literal for the '{@link muicm.impl.SelectionFieldImpl <em>Selection Field</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.SelectionFieldImpl
		 * @see muicm.impl.MuicmPackageImpl#getSelectionField()
		 * @generated
		 */
		EClass SELECTION_FIELD = eINSTANCE.getSelectionField();

		/**
		 * The meta object literal for the '<em><b>Is Multi Selection</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SELECTION_FIELD__IS_MULTI_SELECTION = eINSTANCE.getSelectionField_IsMultiSelection();

		/**
		 * The meta object literal for the '{@link muicm.impl.TextBoxImpl <em>Text Box</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.TextBoxImpl
		 * @see muicm.impl.MuicmPackageImpl#getTextBox()
		 * @generated
		 */
		EClass TEXT_BOX = eINSTANCE.getTextBox();

		/**
		 * The meta object literal for the '<em><b>Text</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEXT_BOX__TEXT = eINSTANCE.getTextBox_Text();

		/**
		 * The meta object literal for the '{@link muicm.impl.MediaImpl <em>Media</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MediaImpl
		 * @see muicm.impl.MuicmPackageImpl#getMedia()
		 * @generated
		 */
		EClass MEDIA = eINSTANCE.getMedia();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEDIA__TYPE = eINSTANCE.getMedia_Type();

		/**
		 * The meta object literal for the '<em><b>Media Image</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MEDIA__MEDIA_IMAGE = eINSTANCE.getMedia_MediaImage();

		/**
		 * The meta object literal for the '{@link muicm.impl.LabelImpl <em>Label</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.LabelImpl
		 * @see muicm.impl.MuicmPackageImpl#getLabel()
		 * @generated
		 */
		EClass LABEL = eINSTANCE.getLabel();

		/**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LABEL__DESCRIPTION = eINSTANCE.getLabel_Description();

		/**
		 * The meta object literal for the '{@link muicm.impl.MActionImpl <em>MAction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MActionImpl
		 * @see muicm.impl.MuicmPackageImpl#getMAction()
		 * @generated
		 */
		EClass MACTION = eINSTANCE.getMAction();

		/**
		 * The meta object literal for the '<em><b>Dynamic Behaviour</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MACTION__DYNAMIC_BEHAVIOUR = eINSTANCE.getMAction_DynamicBehaviour();

		/**
		 * The meta object literal for the '<em><b>Maction Events</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MACTION__MACTION_EVENTS = eINSTANCE.getMAction_MactionEvents();

		/**
		 * The meta object literal for the '{@link muicm.impl.UtilityImpl <em>Utility</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.UtilityImpl
		 * @see muicm.impl.MuicmPackageImpl#getUtility()
		 * @generated
		 */
		EClass UTILITY = eINSTANCE.getUtility();

		/**
		 * The meta object literal for the '{@link muicm.impl.MapImpl <em>Map</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MapImpl
		 * @see muicm.impl.MuicmPackageImpl#getMap()
		 * @generated
		 */
		EClass MAP = eINSTANCE.getMap();

		/**
		 * The meta object literal for the '<em><b>Provider</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MAP__PROVIDER = eINSTANCE.getMap_Provider();

		/**
		 * The meta object literal for the '{@link muicm.impl.CalendarImpl <em>Calendar</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.CalendarImpl
		 * @see muicm.impl.MuicmPackageImpl#getCalendar()
		 * @generated
		 */
		EClass CALENDAR = eINSTANCE.getCalendar();

		/**
		 * The meta object literal for the '<em><b>Years Block Size</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALENDAR__YEARS_BLOCK_SIZE = eINSTANCE.getCalendar_YearsBlockSize();

		/**
		 * The meta object literal for the '{@link muicm.impl.CodeImpl <em>Code</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.CodeImpl
		 * @see muicm.impl.MuicmPackageImpl#getCode()
		 * @generated
		 */
		EClass CODE = eINSTANCE.getCode();

		/**
		 * The meta object literal for the '<em><b>Format</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CODE__FORMAT = eINSTANCE.getCode_Format();

		/**
		 * The meta object literal for the '{@link muicm.impl.IconImpl <em>Icon</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.IconImpl
		 * @see muicm.impl.MuicmPackageImpl#getIcon()
		 * @generated
		 */
		EClass ICON = eINSTANCE.getIcon();

		/**
		 * The meta object literal for the '{@link muicm.impl.ContentBindingImpl <em>Content Binding</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.ContentBindingImpl
		 * @see muicm.impl.MuicmPackageImpl#getContentBinding()
		 * @generated
		 */
		EClass CONTENT_BINDING = eINSTANCE.getContentBinding();

		/**
		 * The meta object literal for the '{@link muicm.impl.MEventImpl <em>MEvent</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getMEvent()
		 * @generated
		 */
		EClass MEVENT = eINSTANCE.getMEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.MViewElementEventAbstractImpl <em>MView Element Event Abstract</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MViewElementEventAbstractImpl
		 * @see muicm.impl.MuicmPackageImpl#getMViewElementEventAbstract()
		 * @generated
		 */
		EClass MVIEW_ELEMENT_EVENT_ABSTRACT = eINSTANCE.getMViewElementEventAbstract();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MVIEW_ELEMENT_EVENT_ABSTRACT__TYPE = eINSTANCE.getMViewElementEventAbstract_Type();

		/**
		 * The meta object literal for the '{@link muicm.impl.MViewComponentPartImpl <em>MView Component Part</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MViewComponentPartImpl
		 * @see muicm.impl.MuicmPackageImpl#getMViewComponentPart()
		 * @generated
		 */
		EClass MVIEW_COMPONENT_PART = eINSTANCE.getMViewComponentPart();

		/**
		 * The meta object literal for the '<em><b>Mviewelementevent</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MVIEW_COMPONENT_PART__MVIEWELEMENTEVENT = eINSTANCE.getMViewComponentPart_Mviewelementevent();

		/**
		 * The meta object literal for the '{@link muicm.impl.MViewElementEventImpl <em>MView Element Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MViewElementEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getMViewElementEvent()
		 * @generated
		 */
		EClass MVIEW_ELEMENT_EVENT = eINSTANCE.getMViewElementEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.PinchEventImpl <em>Pinch Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.PinchEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getPinchEvent()
		 * @generated
		 */
		EClass PINCH_EVENT = eINSTANCE.getPinchEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.RotateEventImpl <em>Rotate Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.RotateEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getRotateEvent()
		 * @generated
		 */
		EClass ROTATE_EVENT = eINSTANCE.getRotateEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.TapEventImpl <em>Tap Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.TapEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getTapEvent()
		 * @generated
		 */
		EClass TAP_EVENT = eINSTANCE.getTapEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.SystemEventImpl <em>System Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.SystemEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getSystemEvent()
		 * @generated
		 */
		EClass SYSTEM_EVENT = eINSTANCE.getSystemEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.PanEventImpl <em>Pan Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.PanEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getPanEvent()
		 * @generated
		 */
		EClass PAN_EVENT = eINSTANCE.getPanEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.TouchEventImpl <em>Touch Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.TouchEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getTouchEvent()
		 * @generated
		 */
		EClass TOUCH_EVENT = eINSTANCE.getTouchEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.LongPressEventImpl <em>Long Press Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.LongPressEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getLongPressEvent()
		 * @generated
		 */
		EClass LONG_PRESS_EVENT = eINSTANCE.getLongPressEvent();

		/**
		 * The meta object literal for the '<em><b>Finger Count</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LONG_PRESS_EVENT__FINGER_COUNT = eINSTANCE.getLongPressEvent_FingerCount();

		/**
		 * The meta object literal for the '<em><b>Press Duration</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LONG_PRESS_EVENT__PRESS_DURATION = eINSTANCE.getLongPressEvent_PressDuration();

		/**
		 * The meta object literal for the '{@link muicm.impl.SwipeEventImpl <em>Swipe Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.SwipeEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getSwipeEvent()
		 * @generated
		 */
		EClass SWIPE_EVENT = eINSTANCE.getSwipeEvent();

		/**
		 * The meta object literal for the '<em><b>Direction</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SWIPE_EVENT__DIRECTION = eINSTANCE.getSwipeEvent_Direction();

		/**
		 * The meta object literal for the '{@link muicm.impl.MActionEventImpl <em>MAction Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MActionEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getMActionEvent()
		 * @generated
		 */
		EClass MACTION_EVENT = eINSTANCE.getMActionEvent();

		/**
		 * The meta object literal for the '<em><b>Execute Result</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MACTION_EVENT__EXECUTE_RESULT = eINSTANCE.getMActionEvent_ExecuteResult();

		/**
		 * The meta object literal for the '{@link muicm.impl.CameraActionEventImpl <em>Camera Action Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.CameraActionEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getCameraActionEvent()
		 * @generated
		 */
		EClass CAMERA_ACTION_EVENT = eINSTANCE.getCameraActionEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.MicrophoneActionEventImpl <em>Microphone Action Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MicrophoneActionEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getMicrophoneActionEvent()
		 * @generated
		 */
		EClass MICROPHONE_ACTION_EVENT = eINSTANCE.getMicrophoneActionEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.OtherActionEventImpl <em>Other Action Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.OtherActionEventImpl
		 * @see muicm.impl.MuicmPackageImpl#getOtherActionEvent()
		 * @generated
		 */
		EClass OTHER_ACTION_EVENT = eINSTANCE.getOtherActionEvent();

		/**
		 * The meta object literal for the '{@link muicm.impl.MExpressionImpl <em>MExpression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MExpressionImpl
		 * @see muicm.impl.MuicmPackageImpl#getMExpression()
		 * @generated
		 */
		EClass MEXPRESSION = eINSTANCE.getMExpression();

		/**
		 * The meta object literal for the '{@link muicm.impl.CameraActionImpl <em>Camera Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.CameraActionImpl
		 * @see muicm.impl.MuicmPackageImpl#getCameraAction()
		 * @generated
		 */
		EClass CAMERA_ACTION = eINSTANCE.getCameraAction();

		/**
		 * The meta object literal for the '{@link muicm.impl.MicrophoneActionImpl <em>Microphone Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.MicrophoneActionImpl
		 * @see muicm.impl.MuicmPackageImpl#getMicrophoneAction()
		 * @generated
		 */
		EClass MICROPHONE_ACTION = eINSTANCE.getMicrophoneAction();

		/**
		 * The meta object literal for the '{@link muicm.impl.OtherActionImpl <em>Other Action</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.OtherActionImpl
		 * @see muicm.impl.MuicmPackageImpl#getOtherAction()
		 * @generated
		 */
		EClass OTHER_ACTION = eINSTANCE.getOtherAction();

		/**
		 * The meta object literal for the '{@link muicm.impl.ConditionalExpressionImpl <em>Conditional Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.ConditionalExpressionImpl
		 * @see muicm.impl.MuicmPackageImpl#getConditionalExpression()
		 * @generated
		 */
		EClass CONDITIONAL_EXPRESSION = eINSTANCE.getConditionalExpression();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONDITIONAL_EXPRESSION__EXPRESSION = eINSTANCE.getConditionalExpression_Expression();

		/**
		 * The meta object literal for the '{@link muicm.impl.StaticContentImpl <em>Static Content</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.StaticContentImpl
		 * @see muicm.impl.MuicmPackageImpl#getStaticContent()
		 * @generated
		 */
		EClass STATIC_CONTENT = eINSTANCE.getStaticContent();

		/**
		 * The meta object literal for the '<em><b>Conditional Expressions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STATIC_CONTENT__CONDITIONAL_EXPRESSIONS = eINSTANCE.getStaticContent_ConditionalExpressions();

		/**
		 * The meta object literal for the '<em><b>Domain Concept</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STATIC_CONTENT__DOMAIN_CONCEPT = eINSTANCE.getStaticContent_DomainConcept();

		/**
		 * The meta object literal for the '<em><b>Attributes</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference STATIC_CONTENT__ATTRIBUTES = eINSTANCE.getStaticContent_Attributes();

		/**
		 * The meta object literal for the '{@link muicm.impl.DynamicBehaviourImpl <em>Dynamic Behaviour</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.DynamicBehaviourImpl
		 * @see muicm.impl.MuicmPackageImpl#getDynamicBehaviour()
		 * @generated
		 */
		EClass DYNAMIC_BEHAVIOUR = eINSTANCE.getDynamicBehaviour();

		/**
		 * The meta object literal for the '<em><b>Behaviour Concept</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DYNAMIC_BEHAVIOUR__BEHAVIOUR_CONCEPT = eINSTANCE.getDynamicBehaviour_BehaviourConcept();

		/**
		 * The meta object literal for the '{@link muicm.impl.ContentModelImpl <em>Content Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.ContentModelImpl
		 * @see muicm.impl.MuicmPackageImpl#getContentModel()
		 * @generated
		 */
		EClass CONTENT_MODEL = eINSTANCE.getContentModel();

		/**
		 * The meta object literal for the '<em><b>Content Elements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTENT_MODEL__CONTENT_ELEMENTS = eINSTANCE.getContentModel_ContentElements();

		/**
		 * The meta object literal for the '{@link muicm.impl.ContentElementImpl <em>Content Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.ContentElementImpl
		 * @see muicm.impl.MuicmPackageImpl#getContentElement()
		 * @generated
		 */
		EClass CONTENT_ELEMENT = eINSTANCE.getContentElement();

		/**
		 * The meta object literal for the '{@link muicm.impl.BehaviourConceptImpl <em>Behaviour Concept</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.BehaviourConceptImpl
		 * @see muicm.impl.MuicmPackageImpl#getBehaviourConcept()
		 * @generated
		 */
		EClass BEHAVIOUR_CONCEPT = eINSTANCE.getBehaviourConcept();

		/**
		 * The meta object literal for the '{@link muicm.impl.DomainConceptImpl <em>Domain Concept</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.DomainConceptImpl
		 * @see muicm.impl.MuicmPackageImpl#getDomainConcept()
		 * @generated
		 */
		EClass DOMAIN_CONCEPT = eINSTANCE.getDomainConcept();

		/**
		 * The meta object literal for the '{@link muicm.impl.FeatureConceptImpl <em>Feature Concept</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.FeatureConceptImpl
		 * @see muicm.impl.MuicmPackageImpl#getFeatureConcept()
		 * @generated
		 */
		EClass FEATURE_CONCEPT = eINSTANCE.getFeatureConcept();

		/**
		 * The meta object literal for the '{@link muicm.impl.AttributeImpl <em>Attribute</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.impl.AttributeImpl
		 * @see muicm.impl.MuicmPackageImpl#getAttribute()
		 * @generated
		 */
		EClass ATTRIBUTE = eINSTANCE.getAttribute();

		/**
		 * The meta object literal for the '<em><b>Feature Concept</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ATTRIBUTE__FEATURE_CONCEPT = eINSTANCE.getAttribute_FeatureConcept();

		/**
		 * The meta object literal for the '{@link muicm.DataType <em>Data Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.DataType
		 * @see muicm.impl.MuicmPackageImpl#getDataType()
		 * @generated
		 */
		EEnum DATA_TYPE = eINSTANCE.getDataType();

		/**
		 * The meta object literal for the '{@link muicm.MeidaType <em>Meida Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.MeidaType
		 * @see muicm.impl.MuicmPackageImpl#getMeidaType()
		 * @generated
		 */
		EEnum MEIDA_TYPE = eINSTANCE.getMeidaType();

		/**
		 * The meta object literal for the '{@link muicm.SwipeDirection <em>Swipe Direction</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.SwipeDirection
		 * @see muicm.impl.MuicmPackageImpl#getSwipeDirection()
		 * @generated
		 */
		EEnum SWIPE_DIRECTION = eINSTANCE.getSwipeDirection();

		/**
		 * The meta object literal for the '{@link muicm.CodeType <em>Code Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.CodeType
		 * @see muicm.impl.MuicmPackageImpl#getCodeType()
		 * @generated
		 */
		EEnum CODE_TYPE = eINSTANCE.getCodeType();

		/**
		 * The meta object literal for the '{@link muicm.EventType <em>Event Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.EventType
		 * @see muicm.impl.MuicmPackageImpl#getEventType()
		 * @generated
		 */
		EEnum EVENT_TYPE = eINSTANCE.getEventType();

		/**
		 * The meta object literal for the '{@link muicm.DirType <em>Dir Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see muicm.DirType
		 * @see muicm.impl.MuicmPackageImpl#getDirType()
		 * @generated
		 */
		EEnum DIR_TYPE = eINSTANCE.getDirType();

	}

} //MuicmPackage
